// German translation of TreeGrid texts 

TreeGridLoaded ({ /* JSONP header, to be possible to load from xxx_Jsonp data source */ 
   "Cfg" : { "TextVersion": "150001"   }, 

/* 
In Alert section place CR/LF as "&#x0a;"
In HTML sections place CR/LF as "&lt;br>"
In HTML sections use HTML tags &lt;em> (error - red), &lt;s> (disabled - gray), &lt;i> (highlight - blue), &lt;b> (strong highlight - blue+bold)
Some texts can place dynamic information, e.g. count or id; some text replace "%d", some other texts replace %1, %2, ... 
*/


"Lang" : { 
      
// All alert / confirm non HTML texts 
      
"Alert" : { 
         
"V3_1": "", 
   "CanReloadStart": "Dieses Kommando ", 
   "CanReloadChanges": "übermittelt alle Änderungen zum Server", 
   "CanCancelChanges": "verwirft alle Änderungen", 
   "And": " und ", 
   "CanReloadSelect": "hebt jegliche Auswahl auf", 
   "CanReloadEnd": "! Möchten Sie fortsetzen?", 
"V3_2": "", 
   "ErrTimeout": "Daten können nicht heruntergeladen werden, Timeout überschritten", 
   "AskTimeout": "Daten können nicht heruntergeladen werden, Server-Timeout!\u000AMöchten Sie die Anfrage wiederholen?", 
   "UploadTimeout": "Daten können nicht hochgeladen werden, Timeout überschritten", 
   "AskUploadTimeout": "Daten können nicht hochgeladen werden, Server-Timeout!\u000AMöchten Sie die Daten erneut senden?", 
"V3_5": "", 
   "ErrHide": "Es können nicht alle variablen Spalten ausgeblendet werden!", 
   "ErrHideExt": "Breite aller fixen Spalten ist zu groß!", 
"V4_2": "", 
   "ErrPrintOpen": "Das Druckfenster kann nicht geöffnet werden\u000A\u000A Bitte erlauben Sie Popup-Fenster um das Drucken zu ermöglichen", 
   "ErrPrint": "Das Dokument wurde nicht erfolgreich gedruckt", 
"V4_4_3": "", 
   "ErrCheck": "Synchronisation mit dem Server fehlgeschlagen!\u000AMöchten Sie temporär die Prüfung auf Aktualisierungen deaktivieren?", 
"V4_7": "", 
   "SearchHelp": "Geben Sie einen Suchstring ein für die Google-Suche\u000A- Einzelne Schlüsselwörter separiert durch Leerzeichen\u000A- Ganze Sätze in Anführungszeichen\u000A- Alternativen separiert durch das Schlüsselwort OR (groß)\u000A- Auszuschließendes vorangestellt mit \"-\" (Minus)\u000A\u000AOder Eingabe eines Suchausdrucks:\u000A- Angabe von Spaltenbezeichnung und\u000A- Operatoren < <= > >= = <> ( ) + - * /\u000A- verwenden Sie UND bzw. ODER um Ausdrücke zu verknüpfen\u000A- verwenden Sie die speziellen Schlüsselwörter STARTET ENDET ENTHÄLT um Zeichenketten zu vergleichen\u000A- verwenden Sie NICHT um zu negieren\u000A- Beispiel: Kunde starts martin and Datum <= 1.1.2019", 
   "NotFound": "Nichts gefunden", 
   "SearchStart": "Nichts gefunden.\u000AMöchten Sie von vorn beginnen?", 
   "SearchError": "Der Suchausdruck ist ungültig!", 
"V5_3": "", 
   "Invalid": "Ungültiger Wert", 
"V6_0": "", 
   "DelRow": "Sind Sie sicher die Zeile '%d' zu löschen?", 
   "DelSelected": "Sind Sie sicher %d Zeilen zu löschen?", 
   "StyleErr": "TreeGrid-CSS-Style kann nicht geladen werden!", 
   "ExportDownload": "Download", 
"V7_0": "", 
   "FoundResults": "%d Treffer gefunden", 
   "PrintPrepared": "Grid ist bereit zum Drucken", 
"V7_1": "", 
   "PrintReady": "Grid ist bereit zum Drucken.\u000AWählen Sie die Druckvorschau im Menü um die Seitengröße anzupassen\u000AOder wählen Sie Drucken bzw. drücken Strg+P um direkt zu drucken", 
   "PrintCloseWindow": "\u000ANach dem Drucken, können Sie diese Seite schließen", 
   "PrintCloseTag": "\u000ANach dem Drucken, können Sie mit Klick auf das Grid zurückkehren", 
"V9_2": "", 
   "PivotReload": "Möchten Sie das Pivot-Grid neu erzeugen?", 
"V12_0": "", 
   "FormulaCircularAsk": "Formel enthält Zirkelbezüge\u000AMöchten Sie das erlauben?", 
   "DelCol": "Sind Sie sicher Spalte'%d' zu löschen?", 
   "DelSelectedCols": "Sind Sie sicher %d Spalten zu löschen?", 
   "SearchEnd": "Nichts gefunden. \u000AMöchten Sie vom Ende fortsetzen?", 
"V12_1": "", 
   "ExportIE": "Nicht verfügbar bei IE 9 oder älter", 
   "ExportError": "Export fehlgeschlagen!", 
"V13_0": "", 
   "DefaultSheet": "Blatt", 
   "NewSheet": "Blatt%1", 
   "LoadSheetErrorMissingModule": "Laden der Daten fehlgeschlagen aufgrund fehlenden TreeGrid-Moduls %1", 
   "StripHtml": "Die Änderung entfernt die Formatierung vom Text!\u000AMöchten Sie die Änderung übernehmen?", 
"V14_0": "", 
   "DownloadSync": "Diese Aktion erfordert das Herunterladen aller Daten zum Client.\u000ADas kann eine längere Zeit dauern!\u000AMöchten Sie fortfahren?", 
"V15_0": "", 
   "ImgData": "Bild", 
   "ImgWidth": "B", 
   "ImgHeight": "H", 
   "ImgX": "X", 
   "ImgY": "Y", 
   "ImgUrl": "URL", 
   "ImgSrc": "QUELLE", 
   "LinkUrl": "URL", 
   "LinkText": "TEXT", 
   "ReplaceDefinedName": "Der Name '%1' existiert bereits mit dem Wert '%2'\u000AMöchten Sie es ersetzen?", 
   "DeleteDefinedName": "Möchtest du den Namen '%1' mit dem Wert '%2' löschen?"  
    }, 
    
    
    
// All message HTML texts     

"Text" : { 
      
"V2_0": "", 
   "DelSelected": "Zeilen werden gelöscht ...", 
   "ExtentErr": "Zu wenig Platz für das Grid", 
   "Sort": "Zeilen werden sortiert ...", 
   "SelectAll": "Auswahl aller Zeilen ändern ...", 
   "DoFilter": "Zeilen werden gefiltert ...", 
"V2_3": "", 
   "UpdateGrid": "Ansicht wird aktualisiert ...", 
   "CollapseAll": "Alle Zeilen einklappen ...", 
   "ExpandAll": "Alle Zeilen aufklappen ...", 
"V2_6": "", 
   "Render": "Anzeige wird aufbereitet ...", 
   "Page": "Seite", 
   "NoPages": "Leer", 
   "UpdateCfg": "Einstellungen werden aktualisiert ...", 
   "StartErr": "Fataler Fehler! <br/>TreeGrid kann nicht generiert werden", 
"V3_0": "", 
   "Calculate": "Zellen werden berechnet ...", 
   "UpdateValues": "Werte werden aktualisiert ...", 
   "UpdateTree": "Baum wird aktualisiert ...", 
"V3_1": "", 
   "PageErr": "Download dieses Datenteils nicht möglich!", 
"V3_2": "", 
   "Layout": "Layout wird geladen ...", 
   "Load": "Daten werden geladen ...", 
"V3_5": "", 
   "ColumnsCaption": "Auswahl anzuzeigender Spalten", 
   "ColUpdate": "Spalten werden aktualisiert ...", 
"V4_3": "", 
   "Picture": "Bild", 	
   "DefaultsDate": "Auswahl Datum ...", 
   "DefaultsButton": "Auswahl ...", 
"V4_5": "", 
   "GroupCustom": "Für Gruppierung Spaltenüberschrift hierhin ziehen ...", 
   "Group": "Zeilen werden gruppiert ...", 
   "DefaultsFilterOff": "(Alle)", 
   "Items": "Elemente %d - %d", 
   "Print": "<h2><center>Bitte warten, Druckausgabe wird generiert ...</center></h2>", 
"V4_7": "", 
   "SearchMethodList": "|Automatisch|Google-Suche|Suche&#160;via&#160;Ausdruck", 
   "Contains": "contains,has,enthält", 
   "Starts": "starts,starts with,starts by,begins,begins with,begins by,beginnt,beginnt mit", 
   "Ends": "ends,ends by,ends with,endet,endet mit", 
   "And": "und", 
   "Or": "oder", 
   "Not": "nicht", 
   "SearchSearch": "Suche", 
   "SearchFilter": "Filtern", 
   "SearchSelect": "Auswahl", 
   "SearchMark": "Markieren", 
   "SearchFind": "Finden", 
   "SearchClear": "Abbrechen", 
   "SearchHelp": "Hilfe", 
   "Search": "Suche ...", 
"V5_0_1": "", 
   "Printed": "Für Druck bitte zum Fenster der Druckausgabe wechseln", 
"V5_6": "", 
   "DoUndo": "Rückgängig wird ausgeführt ...", 
   "DoRedo": "Wiederherstellen wird ausgeführt ...", 
"V5_9": "", 
   "GanttUpdate": "Gantt wird aktualisiert...", 
"V6_0": "", 
   "GanttCreate": "Gantt wird erzeugt...", 
   "LoadStyles": "Style wird geladen...", 
   "SetStyle": "Style wird aktualisiert...", 
   "LoadPage": "Seite wird geladen...", 
   "RenderPage": "Anzeige aufbereiten", 
   "ColWidth": "Breite von Spalte '%d' ändern", 
   "ColMove": "Spalte '%d' verschieben", 
   "Password": "***", 
   "DefaultsNone": "Alle leer", 
   "RadioFilterOff": "<i>aus</i>", 
   "DragObjectMove": "Zeile <b>%d</b> verschieben", 
   "DragObjectCopy": "Zeile <b>%d</b> kopieren", 
   "DragObjectMoreMove": "<b>%d</b> Zeilen verschieben", 
   "DragObjectMoreCopy": "<b>%d</b> Zeilen kopieren", 
   "ExportFinished": "<center><b>Report generiert</b><br/><br/>Button drücken für Download<br/></center><br/>", 
   "RenderProgressText": "%d Seiten von %d fertiggestellt", 
   "RenderProgressCancel": "Aufbereitung im Hintergrund", 
   "PrintProgressCaption": "Druckliste wird generiert", 
   "PrintProgressText": "%d Zeilen von %d fertiggestellt", 
   "PrintProgressCancel": "Drucken abbrechen", 
   "ExportProgressCaption": "Exportliste wird generiert", 
   "ExportProgressText": "%d% fertiggestellt", 
   "ExportProgressCancel": "Export abbrechen", 
   "ExpandProgressCaption": "Alle Zeilen werden aufgeklappt", 
   "ExpandProgressText": "%d Zeilen von %d fertiggestellt", 
   "ExpandProgressCancel": "Aufklappen abbrechen", 
   "ExportCaption": "Spalten für Export auswählen", 
   "PrintCaption": "Zu druckende Spalten auswählen", 
   "DefaultsAll": "Alle auswählen", 
"V6_1": "", 
   "DefaultsAlphabet": "%d ...", 
"V7_0": "", 
   "RemoveUnused": "Nicht verwendete Seiten werden gelöscht...", 
   "ErrorSave": "Das Senden von Änderungen zum Server ist fehlgeschlagen", 
   "DatesRepeat": "Wiederholen", 
   "DatesStart": "Beginn", 
   "DatesEndTime": "Ende", 
   "DatesValue": "Wert", 
   "DatesRepeatEnum": "||Wöchentlich|Täglich|Stündlich", 
   "DatesRepeatKeys": "||w|t|s", 
   "RenderProgressCaptionRows": "Aufbereitung Seiten (für Zeilen)", 
   "RenderProgressCaptionCols": "Aufbereitung Seiten (für Spalten)", 
   "RenderProgressCaptionChildren": "Aufbereitung Seiten (Baum)", 
"V8_0": "", 
   "CalendarNone": "<s>Keine</s>", 
   "CalendarEmpty": "<s>Standard</s>", 
   "CalendarEdit": "<i>Bearbeiten...</i>", 
"V9_2": "", 
   "ExpandCols": "Spalten aufklappen ...", 
   "CollapseCols": "Spalten einklappen ...", 
"V9_3": "", 
   "PagingUpdate": "Erzeuge Seiten ...", 
   "CopySlow": "Das Kopieren dauerte zu lange (%d ms). Bitte Strg+C drücken um die Aktion zu beenden", 
   "CopyOk": "Kopieren erfolgreich beendet", 
"V10_0": "", 
   "LevelsTip": "Zeilen aufklappen bis Level %d", 
"V12_0": "", 
   "FileIE": "Nicht verfügbar bei IE<=9", 
   "Paste": "Daten aus der Zwischenablage werden eingefügt ...", 
   "FormulaError1": "Formel <b>%1</b> kann nicht aufgelöst werden", 
   "FormulaError2": "Inkorrekte Zellbezüge in Formel <b>%1</b>", 
   "FormulaError3": "Inkorrektes Element <b>%2</b> in Formel <b>%1</b>", 
   "FormulaError4": "Inkorrekte Formel <b>%1</b> mit Fehler <i>%2</i>", 
   "FormulaError5": "Formel kann nicht berechnet werden mit Fehler <i>%2</i>", 
   "FormulaError6": "Formel <b>%1</b> liefert <b>null</b> Ergebnis", 
   "FormulaError7": "Formel <b>%1</b> liefert <b>NaN</b> Ergebnis", 
   "NotInList": "Der Wert <b>%1</b> ist nicht in der Elementliste enthalten", 
   "EmptyValue": "leer", 
   "CannotEdit": "Kein änderbarer Wert", 
   "NoStyle": "Style kann nicht geändert werden", 
   "NoFormat": "Format kann nicht geändert werden", 
   "NoNumber": "Zellwert ist keine Zahl", 
   "EditMaskError": "Der Wert <b>%1</b> enthält nicht erlaubte Zeichen", 
   "FormulaRestrict": "Formel <b>%1</b> ist ungültig, Fehler <i>%2</i>", 
   "SizeChanged": "Wert <b>%1</b> geändert wegen Größenbeschränkungen", 
   "ResultText": "Der Wert <b>%1</b> ist ungültig", 
   "EditErrorsMessage": "%1", 
   "EditChangesMessage": "%1", 
   "EditErrorsMessageCell": "%1 in Zelle <b>%2</b><br>", 
   "EditChangesMessageCell": "%1 in Zelle <b>%2</b><br>", 
   "EditErrorsMessageMore": "Es sind <b>%1</b> weitere Probleme vorhanden ...", 
   "FormulaCircular": "Formel enthält Zirkelbezüge", 
   "FormulaCircularAlert": "Formel enthält Zirkelbezüge", 
   "ErrAdd": "Neue Zeile kann nicht unter Zeile %1 hinzugefügt werden", 
   "ErrAddRoot": "Neue Zeile kann nicht zur Wurzel hinzugefügt werden", 
   "DelSelectedCols": "Zeilen werden gelöscht ...", 
   "SearchFindPrev": "Rückwärts", 
   "NoMenu": "Keine Aktion möglich", 
   "SetStyleSame": "Keine Zelle geändert", 
   "SetStyleError": "Keine Zelle geändert wegen Änderungsrestriktionen", 
   "SetStyleErrors": "%1 Zellen nicht geändert wegen Änderungsrestriktionen", 
"V13_0": "", 
   "PagerSep1": "\u00A0|\u00A0", 
   "PagerSep2": "\u00A0=>\u00A0", 
   "PagerSep3": ",\u00A0", 
   "PagerNone": "...", 
   "LoadSheet": "Blatt wird gelesen ...", 
   "DiscardSheet": "Möchten Sie alle Daten verwerfen und Daten aus Datei <b>%1</b> laden?", 
   "AddSheet": "Möchten Sie Daten aus Datei <b>%1</b> zu aktuellen Daten hinzufügen?", 
   "OpenSheet": "Möchten Sie Daten aus Datei <b>%1</b> zu aktuellen Daten hinzufügen<br>oder alle bisherigen Daten verwerfen und Daten aus Datei <b>%1</b> laden?", 
   "LoadSheetError": "Laden der Datei <b>%1</b> fehlgeschlagen mit Fehler <b>%2</b>", 
   "ParseSheetError": "Einlesen der Daten aus <b>%1</b> fehlgeschlagen", 
   "SheetsUnsupported": "Das Öffnen von Dateien wird von Ihrem Browser nicht unterstützt!", 
   "DeleteSheet": "Möchten Sie Blatt <b>%1</b> löschen?", 
   "DeleteTab": "Möchten Sie Tab <b>%1</b>? löschen", 
   "OnlyXlsx": "<b>%1</b> kann nicht geöffnet werden! Nur <b>XLSX</b>-Dateien werden unterstützt.", 
   "CompatibleStyles": "Kompatibel", 
   "ShrinkStyle": "Style ist zu groß! Die Stylegröße wird reduziert.", 
   "SetSize": "Stylegröße wird geändert ...", 
   "UniqueSheet": " (%1)", 
   "ShrinkSize": "Es ist zu wenig Platz um Grid vollständig anzuzeigen!<br>Möchten Sie die Stylegröße reduzieren?", 
   "EnterFormat": "Geben Sie eine Formatierung wie in MS Excel ein", 
   "FormulaError8": "Externer Verweis zu unbekanntem Blatt <b>%2</b> in Formel <b>%1</b>", 
   "FormulaError9": "Nicht unterstützte Funktion <b>%2</b> in Formel <b>%1</b>", 
   "FormulaError10": "Nicht unterstützter Verweis auf externe Datei <b>%2</b> in Formel <b>%1</b>", 
   "FormulaError11": "Noch nicht implementierte Array-Funktion oder unerwarteter Zellbereich <b>%2</b> in Formel <b>%1</b>", 
"V13_1": "", 
   "MoveRows": "%d Zeilen werden verschoben ...", 
"V13_3": "", 
   "NaNContinue": "Der eingegebene Wert ist ungültig! Bitte ändern.", 
   "NaNRejected": "Der eingegebene Wert ist ungültig und wird ignoriert", 
   "NaNAccepted": "Der eingegebene Wert ist ungültig und wird geändert", 
   "NaNAsk": "Der eingegebene Wert ist ungültig. Möchten Sie ihn trotzdem übernehmen?", 
   "NaNAskReject": "Der eingegebene Wert ist ungültig. Möchten Sie ihn verwerfen?", 
"V14_0": "", 
   "DownloadSyncComplete": "Download beendet!", 
   "PasteError": "Der Wert <b>%1</b> kann nicht eingefügt werden", 
   "PasteChanged": "Der Wert <b>%1</b> wurde leer eingefügt", 
"V15_0": "", 
   "EnterLink": "Geben Sie die Hyperlink-URL ein", 
   "ExternalFocus": "%1", 
   "ExternalFocusRect": "%1 => %2 : %3", 
   "ExternalFocusWait": "Wechselnder Fokus ...", 
   "EnterImageOpacity": "Geben Sie die Bildopazität ein (0 - transparent, 100 - undurchsichtig)", 
   "EnterImageName": "Geben Sie die Bildtitel ein", 
   "SetContrast": "Stylekontrast wird geändert ...", 
   "FormulaErrorTimeout": "<span style='color:red;'>Berechnungs-Timeout abgelaufen! Es wurden nicht alle Formeln berechnet!</span><br><br>", 
   "PageRows": "%1 - %2", 
   "FormulaError12": "Inkorrekt Name <b>%2</b> in Formel <b>%1</b>", 
   "EnterDefinedName": "Geben Sie den Namen für %1 ein", 
   "EnterDefinedValue": "Geben Sie den Wert für den Namen %1 ein", 
   "GlobalName": "%1", 
   "GlobalNameDup": "%1 (global)", 
   "LocalName": "%1", 
   "LocalNameDup": "%1 (lokal)"  
    }, 



// Gantt texts 

"Gantt" : { 

"V6_0": "", 
   "ErrGanttDep": "Hier kann keine Abhängigkeit zugeordnet werden", 
   "ErrGanttPercentEdit": "Falsche Eingabe. Der Wert muss im Intervall 0 - 100 liegen", 
   "DelAllGanttDep": "Alle Abhängigkeiten aufheben", 
   "DelGanttMilestone": "Meilensteine löschen", 
   "EditGanttPercent": "Geben Sie den Fertigstellungsgrad an", 
   "DelGanttFlow": "Aktuellen Fortschritt löschen", 
   "DelGanttFlowPart": "Balken für aktuellen Fortschritt löschen", 
   "DelGanttFlags": "Alle Kennzeichen löschen", 
   "DelGanttFlag": "Kennzeichen löschen", 
   "EditGanttFlag": "Geben Sie die Bezeichnung zum Kennzeichen ein", 
   "DelGanttAll": "Gantt-Zelle löschen", 
   "NewGanttFlag": "Neues Kennzeichen zum ausgewählten Punkt hinzufügen", 
   "EditGanttResource": "Ressourcen ändern", 
   "AssignGanttResource": "Ressourcen zuordnen", 
   "CorrectAllDependencies": "Alle Abhängigkeiten im Chart korrigieren", 
   "CorrectRelatedDependencies": "Korrigieren Sie zugehörige Abhängigkeiten", 
   "CorrectDep": "Verschieben von %d Balken...", 
   "GanttFlagEdit": "Geben Sie den Text des Kennzeichens ein", 
   "GanttPercentEdit": "Geben Sie den neuen Fertigstellungsgrad in Prozent ein", 
   "GanttResourceEdit": "Geben Sie den Ressourcentext ein", 
   "GanttDepLagEdit": "Geben Sie die Verzögerung für die Abhängigkeit ein", 
"V6_1": "", 
   "GanttResizeDelete": "Sind Sie sicher, dass Sie das Element löschen möchten?", 
   "DelGanttRunPart": "Box löschen", 
   "EditGanttRun": "Box-Text ändern", 
   "EditGanttRunTip": "Box-Information ändern", 
   "GanttRunEdit": "Box-Text editieren", 
   "GanttRunEditTip": "Box-Information eingeben", 
   "ChooseGanttFlagIcon": "Symbol für Kennzeichen wählen", 
"V6_3": "", 
   "GanttCorrectDependencies": "Es sind noch <b>%d</b> abhängige Aufgaben vorhanden, die ebenfalls aktualisiert werden sollten.<br>Möchten Sie diese verschieben?", 
   "GanttCorrectDependency": "Es ist noch eine abhängige Aufgabe vorhanden, die ebenfalls aktualisiert werden sollte. Möchten Sie diese verschieben?", 
   "GanttCorrectTask": "Die Aufgabe überschreitet ihre Grenzen. Möchten Sie sie verschieben?", 
   "GanttDeleteDependencies": "Es sind %d Abhängigkeiten vorhanden. Möchten Sie diese löschen?", 
   "GanttCircularDependencies": "Diese Abhängigkeit erzeugt eine zirkuläre Beziehung. Möchten Sie sie trotzdem erzeugen?", 
   "GanttCircularDependenciesErr": "Es ist nicht möglich, eine zirkuläre Beziehung von Abhängigkeiten zu erstellen", 
   "ErrComplete": "Der Fertigstellungsgrad muss zwischen 0 - 100 liegen!", 
   "ErrDuration": "Der Wert für die Dauer ist falsch!", 
   "ErrEnd": "Das Endedatum kann nicht kleiner als das Beginndatum sein!", 
   "ErrDependency": "Der Abhängigkeitswert ist falsch!", 
   "ErrCorrect": "Es ist nicht möglich die Abhängigkeiten zu korrigieren!", 
   "ErrCorrectSome": "Aufgrund vorgegebener Einschränkungen wurden nicht alle Abhängigkeiten korrigiert!", 
   "IncorrectDependencies": "<em><b>%d</b> fehlerhafte Abhängigkeiten</em>", 
   "IncorrectDependency": "<em><b>1</b> fehlerhafte Abhängigkeit</em>", 
   "CorrectDependencies": "Alle Abhängigkeiten sind korrekt", 
   "DisabledDependencies": "<s>Überprüfung von Abhängigkeiten deaktiviert</s>", 
   "GanttCheckExclude": "Das Objekt beginnt an einem arbeitsfreien Tag. Möchten Sie es nach rechts verschieben?", 
   "GanttMinStart": "Aufgabe muss beginnen nach <b>%d</b>", 
   "GanttMaxStart": "Aufgabe muss beginnen vor<b>%d</b>", 
   "GanttMinEnd": "Aufgabe muss enden nach <b>%d</b>", 
   "GanttMaxEnd": "Aufgabe muss enden vor <b>%d</b>", 
   "DelGanttConstraint": "Einstellung %d löschen", 
   "DelGanttConstraints": "Alle Einschränkungen löschen", 
   "ChangeGanttConstraint": "Einschränkung ändern auf %d", 
   "NewGanttConstraint": "Einschränkung %d hier einfügen", 
   "MinStart": "Frühester Beginn", 
   "MaxStart": "Spätester Beginn", 
   "MinEnd": "Frühestes Ende", 
   "MaxEnd": "Spätestes Ende", 
   "ExactStart": "Exakter Beginn", 
   "ExactEnd": "Exaktes Ende", 
   "SplitGanttConstraint": "Einschränkung %d teilen", 
   "GanttDepLagChangeEnd": "Ändern Sie die Verzögerung der Abhängigkeit von <b>%d</b>", 
"V6_4": "", 
   "GanttExactStart": "Aufgabe muss beginnen am <b>%d</b>", 
   "GanttExactEnd": "Aufgabe muss enden am <b>%d</b>", 
   "ExtraPrice": "Aufpreis", 
   "ExtraPrices": "Extra-Ressourceneinheiten", 
   "DelGanttPoint": "Punkt löschen", 
   "DelGanttPoints": "Alle Punkte löschen", 
   "NewGanttPoint": "Neuen Punkt hinzufügen", 
"V6_5": "", 
   "ErrStart": "Das Beginndatum kann nicht größer als das Endedatum sein!", 
"V6_6": "", 
   "GanttCheckExcludeBack": "Das Objekt endet an einem arbeitsfreien Tag. Möchten Sie es nach links verschieben?", 
   "DelGanttBase": "Projektbeginn löschen", 
   "SetGanttBase": "Projektbeginn hier setzen", 
   "DelGanttFinish": "Projektende löschen", 
   "SetGanttFinish": "Projektende hier setzen", 
   "NewGanttMilestone": "Neuen Meilenstein hinzufügen", 
"V7_0": "", 
   "ErrDateLow": "Das Datum kann nicht vor dem <em><b>%1</b></em> liegen wegen Einschränkung <b>%2</b>", 
   "ErrDateHigh": "Das Datum kann nicht nach dem <em><b>%1</b></em> liegen wegen Einschränkung <b>%2</b>", 
   "Baseline": "Projektbeginn", 
   "Finishline": "Projektende", 
   "ChartMinStart": "Minimaler Projektbeginn", 
   "ChartMaxEnd": "Maximales Projektende", 
   "NewGanttEndMilestone": "Neuen Ende-Meilenstein einfügen", 
   "ErrCorrectDep": "Aufgrund von Fehlern wurden nicht alle Abhängigkeiten korrigiert!", 
   "DelGanttRunGroup": "Zeilengruppe löschen (%d Boxen)", 
   "DelGanttRunGroupAll": "Gruppe löschen(%d Boxen)", 
   "ValueChanged": "Wert aufgrund von Einschränkungen geändert", 
   "ErrChangeValue": "Eingegebener Wert ist falsch", 
   "CompleteChanged": "Wert wurde geändert, damit er im Intervall 0 - 100 liegt", 
   "DurationChanged": "Wert wurde geändert, damit er nicht negativ ist", 
   "EditGanttRunText": "Geben Sie den Aufgabentext ein", 
   "SetGanttMilestoneIncomplete": "Meilenstein nicht erledigt setzen", 
   "SetGanttMilestoneComplete": "Meilenstein erledigt setzen", 
   "ErrMoveChildren": "Aufgabe kann nicht verschoben werden aufgrund untergeordneter Einschränkungen", 
   "MoveChildrenChanged": "Wert wurde aufgrund untergeordneter Einschränkungen geändert", 
   "NewGanttRunStop": "Neuen Stopp einfügen", 
   "GanttCorrectExclude": "Das Objekt beginnt oder endet an einem arbeitsfreien Tag. Möchten Sie das korrigieren?", 
"V9_2": "", 
   "SplitGanttFlow": "Balken für aktuellen Fortschritt teilen", 
"V10_0": "", 
   "ZoomMain": "Zoomen auf Balken", 
   "ZoomRun": "Zoomen auf Box", 
   "ZoomAll": "Zoomen auf alle Objekte", 
   "SplitGanttRun": "Box teilen", 
   "SplitGanttMain": "Balken teilen", 
   "DelGanttMainPart": "Balken löschen", 
   "DelGanttMain": "Aufgabe löschen", 
   "DelGanttMainAll": "Alle Aufgaben löschen", 
   "DelGanttMainBar": "Aufgabe löschen", 
   "DelGanttRun": "Alle %d Boxen der Zeile löschen", 
   "SelectGanttRunPart": "Box auswählen", 
   "UnselectGanttRunPart": "Auswahl Box aufheben", 
   "SelectGanttRun": "Alle Boxen aufheben", 
   "UnselectGanttRun": "Auswahl aller Boxen aufheben", 
   "DelGanttRunSelected": "%d ausgewählte Boxen löschen", 
   "Plan0": "0", 
   "GanttTextEdit": "Aufgaben-Information eingeben", 
   "EditGanttText": "Aufgaben-Information angeben", 
   "GanttDepLagChange": "Verzögerung der Abhängigkeit ändern", 
   "DelGanttDep": "Abhängigkeit löschen", 
   "DisableGanttMain": "Aufgabe deaktivieren", 
   "EnableGanttMain": "Aufgabe aktivieren", 
   "LockGanttMain": "Aufgabe sperren", 
   "UnlockGanttMain": "Aufgabe entsperren", 
   "DisableGanttRun": "Aufgabe deaktivieren", 
   "EnableGanttRun": "Aufgabe aktivieren", 
   "LockGanttRun": "Aufgabe sperren", 
   "UnlockGanttRun": "Aufgabe entsperren", 
   "DisableGanttRunPart": "Box deaktivieren", 
   "EnableGanttRunPart": "Box aktivieren", 
   "LockGanttRunPart": "Box sperren", 
   "UnlockGanttRunPart": "Box entsperren", 
   "SetGanttPercent": "Fertigstellungsgrad hier einstellen", 
   "ErrLag": "Verzögerungswert ist falsch!", 
   "EmptyManual": "Keine", 
   "ErrCorrectNone": "Aufgrund von Beschränkungen können nicht alle Abhängigkeiten korrigiert werden!", 
   "ZoomHeader": "Zoomen zu <b>%d</b> %d - %d", 
   "ZoomUndo": "Zoomen zurück zu <b>%d</b>", 
   "ZoomIn": "Hereinzoomen zu <b>%d</b>", 
   "ZoomOut": "Herauszoomen zu <b>%d</b>", 
   "ZoomFit": "Zoom passend", 
"V11_0": "", 
   "JoinGanttRunSelected": "Ausgewählte Boxen verbinden", 
   "SplitGanttRunJoined": "Verbundene Boxen trennen", 
   "JoinGanttRunAdjacent": "Benachbarte Boxen verbinden", 
   "SplitGanttRunAdjacent": "Verbundene benachbarte Boxen trennen", 
   "ChooseGanttRunType": "Box-Typ ändern", 
   "ChooseGanttRunRowType": "Typ von %d Boxen der Zeile ändern", 
   "ChooseGanttRunSelectedType": "Typ von %d ausgewählten Boxen ändern", 
   "ChooseGanttRunGroupType": "Typ von %d Boxen der Zeilengruppe ändern", 
   "ChooseGanttRunGroupAllType": "Typ von %d Boxen der Gruppe ändern", 
"V12_0": "", 
   "GanttPinchZoom": "Maßstab %d%", 
"V13_0": "", 
   "DelGanttRunContainerOnly": "Container löschen", 
   "DelGanttRunContainer": "Alle %d Boxen des Containers löschen", 
   "EnableGanttRunContainer": "Alle %d Boxen des Containers aktivieren", 
   "DisableGanttRunContainer": "Alle %d Boxen des Containers deaktivieren", 
   "LockGanttRunContainer": "Alle %d Boxen des Containers sperren", 
   "ChooseGanttRunContainerType": "Typ von %d Boxen des Containers ändern", 
   "ChooseGanttRunContainer": "Typ des Containers ändern", 
   "AddGanttRunContainer": "Neuen Container für die Box hinzufügen", 
"V13_1": "", 
   "SelectGanttRunContainer": "Container auswählen", 
   "UnselectGanttRunContainer": "Auswahl Container aufheben", 
"V15_0": "", 
   "RemoveGanttRunPart": "Box entfernen", 
   "RemoveGanttRunGroup": "Zeilengruppe entfernen (%d Boxen)", 
   "RemoveGanttRunGroupAll": "Gruppe entfernen(%d Boxen)", 
   "RemoveGanttRunSelected": "%d ausgewählte Boxen entfernen"  
    }, 

"GanttUnits" : { 
"V10_0": "", 
   "ms": "Millisekunde", "ms10": "10 Millisekunden", "ms100": "100 Millisekunden", 
   "s": "Sekunde", "s2": "2 Sekunden", "s5": "5 Sekunden", "s10": "10 Sekunden", "s15": "15 Sekunden", "s30": "30 Sekunden", 
   "m": "Minute", "m2": "2 Minuten", "m5": "5 Minuten", "m10": "10 Minuten", "m15": "15 Minuten", "m30": "30 Minuten", 
   "h": "Stunde", "h2": "2 Stunden", "h3": "3 Stunden", "h6": "6 Stunden", "h8": "8 Stunden", "h12": "12 Stunden", 
   "d": "Tag", "w": "Woche", "w0": "Woche", "w1": "Woche", "w6": "Woche", 
   "M": "Monat", "M2": "2 Monate", "M3": "3 Monate", "M4": "4 Monate", "M6": "6 Monate", 
   "y": "Jahr", "y2": "2 Jahre", "y3": "3 Jahre", "y4": "4 Jahre", "y5": "5 Jahre", "y10": "10 Jahre", "y20": "20 Jahre", "y50": "50 Jahre"  
    }, 



// Popup dialog buttons, non HTML 

"MenuButtons" : { 
      
"V6_0": "", 
   "Ok": "OK", 
   "Clear": "Löschen", 
   "Today": "Heute", 
   "All": "Alle auswählen", 
   "Cancel": "Abbrechen", 
"V6_7": "", 
   "Yesterday": "Gestern", 
"V7_0": "", 
   "EmptyTip": "Leeres Datum", 
"V10_0": "", 
   "Yes": "Ja", 
   "No": "Nein", 
   "Always": "Immer", 
   "Never": "Nie", 
"V12_1": "", 
   "ShowAll": "Alle anzeigen", 
   "HideAll": "Alle ausblenden", 
   "Reset": "Standard", 
"V13_0": "", 
   "Add": "Hinzufügen", 
   "Discard": "Verwerfen", 
   "Once": "Einmal", 
"V13_1": "", 
   "Shrink": "Stylegröße reduzieren"  
    }, 



// Cell menu item names (cell Menu attribute), HTML 
// %1 is replaced by count of affected rows, only for mass actions 

"MenuCell" : { 
      
"V6_0": "", 
   "CopyRow": "Zeile duplizieren", 
   "CopyRowBelow": "Zeile duplizieren", 
   "CopyTree": "Baum duplizieren", 
   "CopyTreeBelow": "Baum duplizieren", 
   "CopyEmpty": "Leeren Baum oberhalb einfügen", 
   "CopyEmptyBelow": "Leeren Baum unterhalb einfügen", 
   "CopySelected1": "Ausgewählte Zeile nach oben kopieren", 
   "CopySelectedBelow1": "Ausgewählte Zeile nach unten kopieren", 
   "CopySelectedTree1": "Ausgewählte Teilbaum nach oben kopieren", 
   "CopySelectedTreeBelow1": "Ausgewählte Teilbaum nach unten kopieren", 
   "CopySelectedEmpty1": "Ausgewählte Teilbaum oberhalb leer einfügen", 
   "CopySelectedEmptyBelow1": "Ausgewählte Teilbaum unterhalb leer einfügen", 
   "CopySelectedChild1": "Ausgewählte Zeile als erstes Kind kopieren", 
   "CopySelectedTreeChild1": "Ausgewählte Teilbaum als erstes Kind kopieren", 
   "CopySelectedEmptyChild1": "Ausgewählte Teilbaum leer als erste Kinder einfügen", 
   "CopySelectedChildEnd1": "Ausgewählte Zeile als letzte Kinder kopieren", 
   "CopySelectedTreeChildEnd1": "Ausgewählte Teilbaum als letzte Kinder kopieren", 
   "CopySelectedEmptyChildEnd1": "Ausgewählte Teilbaum leer als letzte Kinder einfügen", 
   "CopySelectedEnd1": "Ausgewählte Zeile ans Ende kopieren", 
   "CopySelectedEndPage1": "Ausgewählte Zeile ans Seitenende kopieren", 
   "CopySelectedEndGrid1": "Ausgewählte Zeile ans Grid-Ende kopieren", 
   "CopySelectedTreeEnd1": "Ausgewählte Teilbaum ans Ende kopieren", 
   "CopySelectedTreeEndPage1": "Ausgewählte Teilbaum ans Seitenende kopieren", 
   "CopySelectedTreeEndGrid1": "Ausgewählte Teilbaum ans Grid-Ende kopieren", 
   "CopySelectedEmptyEnd1": "Ausgewählte Teilbaum am Ende leer einfügen", 
   "CopySelectedEmptyEndPage1": "Ausgewählte Teilbaum am Seitenende leer einfügen", 
   "CopySelectedEmptyEndGrid1": "Ausgewählte Teilbaum am Grid-Ende leer einfügen", 
   "CopySelected": "%1 ausgewählte Zeilen nach oben kopieren", 
   "CopySelectedBelow": "%1 ausgewählte Zeilen nach unten kopieren", 
   "CopySelectedTree": "%1 ausgewählte Teilbäume nach oben kopieren", 
   "CopySelectedTreeBelow": "%1 ausgewählte Teilbäume nach unten kopieren", 
   "CopySelectedEmpty": "%1 ausgewählte Teilbäume oberhalb leer einfügen", 
   "CopySelectedEmptyBelow": "%1 ausgewählte Teilbäume unterhalb leer einfügen", 
   "CopySelectedChild": "%1 ausgewählte Zeilen als erstes Kind kopieren", 
   "CopySelectedTreeChild": "%1 ausgewählte Teilbäume als erstes Kind kopieren", 
   "CopySelectedEmptyChild": "%1 ausgewählte Teilbäume leer als erste Kinder einfügen", 
   "CopySelectedChildEnd": "%1 ausgewählte Zeilen als letzte Kinder kopieren", 
   "CopySelectedTreeChildEnd": "%1 ausgewählte Teilbäume als letzte Kinder kopieren", 
   "CopySelectedEmptyChildEnd": "%1 ausgewählte Teilbäume leer als letzte Kinder einfügen", 
   "CopySelectedEnd": "%1 ausgewählte Zeilen ans Ende kopieren", 
   "CopySelectedEndPage": "%1 ausgewählte Zeilen ans Seitenende kopieren", 
   "CopySelectedEndGrid": "%1 ausgewählte Zeilen ans Grid-Ende kopieren", 
   "CopySelectedTreeEnd": "%1 ausgewählte Teilbäume ans Ende kopieren", 
   "CopySelectedTreeEndPage": "%1 ausgewählte Teilbäume ans Seitenende kopieren", 
   "CopySelectedTreeEndGrid": "%1 ausgewählte Teilbäume ans Grid-Ende kopieren", 
   "CopySelectedEmptyEnd": "%1 ausgewählte Teilbäume am Ende leer einfügen", 
   "CopySelectedEmptyEndPage": "%1 ausgewählte Teilbäume am Seitenende leer einfügen", 
   "CopySelectedEmptyEndGrid": "%1 ausgewählte Teilbäume am Grid-Ende leer einfügen", 

   "AddRow": "Neue Zeile oberhalb einfügen", 
   "AddChild": "Neue Zeile als erstes Kind einfügen", 
   "AddChildEnd": "Neue Zeile als letztes Kind einfügen", 
   "AddRowBelow": "Neue Zeile unterhalb einfügen", 
   "AddRowEnd": "Neue Zeile am Ende einfügen", 
   "AddRowEndPage": "Neue Zeile am Seitenende einfügen", 
   "AddRowEndGrid": "Neue Zeile am Grid-Ende einfügen", 

"V12_0": "", 
   "CopyRows1": "Zeile nach oben kopieren", 
   "CopyRowsBelow1": "Zeile nach unten kopieren", 
   "CopyRowsTree1": "Teilbaum nach oben kopieren", 
   "CopyRowsTreeBelow1": "Teilbaum nach unten kopieren", 
   "CopyRowsEmpty1": "Teilbaum oberhalb leer einfügen", 
   "CopyRowsEmptyBelow1": "Teilbaum unterhalb leer einfügen", 
   "CopyRows": "%1 Zeilen nach oben kopieren", 
   "CopyRowsBelow": "%1 Zeilen nach unten kopieren", 
   "CopyRowsTree": "%1 Teilbäume nach oben kopieren", 
   "CopyRowsTreeBelow": "%1 Teilbäume nach unten kopieren", 
   "CopyRowsEmpty": "%1 Teilbäume oberhalb leer einfügen", 
   "CopyRowsEmptyBelow": "%1 Teilbäume unterhalb leer einfügen", 

   "AddRows1": "Zeile oberhalb leer einfügen", 
   "AddRowsBelow1": "Zeile unterhalb leer einfügen", 
   "AddSelected1": "Zeile oberhalb leer einfügen", 
   "AddSelectedBelow1": "Zeile unterhalb leer einfügen", 
   "AddRows": "%1 Zeilen oberhalb leer einfügen", 
   "AddRowsBelow": "%1 Zeilen unterhalb leer einfügen", 
   "AddSelected": "%1 Zeilen oberhalb leer einfügen", 
   "AddSelectedBelow": "%1 Zeilen unterhalb leer einfügen", 

   "DeleteRow": "Zeile löschen", 
   "UndeleteRow": "Zeile löschen zurücknehmen", 
   "RemoveRow": "Zeile entfernen", 
   "DeleteRows1": "Zeile löschen", 
   "UndeleteRows1": "Zeile löschen zurücknehmen", 
   "RemoveRows1": "Zeile entfernen", 
   "DeleteSelected1": "Ausgewählte Zeile löschen", 
   "UndeleteSelected1": "Ausgewählte Zeile löschen zurücknehmen", 
   "RemoveSelected1": "Ausgewählte Zeile entfernen", 
   "DeleteRows": "%1 Zeilen löschen", 
   "UndeleteRows": "Löschen von %1 Zeilen zurücknehmen", 
   "RemoveRows": "%1 Zeilen entfernen", 
   "DeleteSelected": "%1 ausgewählte Zeilen löschen", 
   "UndeleteSelected": "Löschen von %1 ausgewählten Zeilen zurücknehmen", 
   "RemoveSelected": "%1 ausgewählte Zeilen entfernen", 

   "CopyCol": "Spalte duplizieren", 
   "CopyColNext": "Spalte duplizieren", 
   "CopyCols1": "Spalte nach links kopieren", 
   "CopyColsNext1": "Spalte nach rechts kopieren", 
   "CopySelectedCols1": "Ausgewählte Spalte nach links kopieren", 
   "CopySelectedColsNext1": "Ausgewählte Spalte nach rechts kopieren", 
   "CopyCols": "%1 Spalten nach links kopieren", 
   "CopyColsNext": "%1 Spalten nach rechts kopieren", 
   "CopySelectedCols": "%1 ausgewählte Spalten nach links kopieren", 
   "CopySelectedColsNext": "%1 ausgewählte Spalten nach rechts kopieren", 

   "AddCol": "Neue Spalte links einfügen", 
   "AddColNext": "Neue Spalte rechts einfügen", 
   "AddCols1": "Spalte links leer einfügen", 
   "AddColsNext1": "Spalte rechts leer einfügen", 
   "AddSelectedCols1": "Spalte links leer einfügen", 
   "AddSelectedColsNext1": "Spalte rechts leer einfügen", 
   "AddCols": "%1 Spalten links leer einfügen", 
   "AddColsNext": "%1 Spalten rechts leer einfügen", 
   "AddSelectedCols": "%1 Spalten links leer einfügen", 
   "AddSelectedColsNext": "%1 Spalten rechts leer einfügen", 
   "AddColEnd": "Neue Spalte am Ende einfügen", 

   "DeleteCol": "Spalte löschen", 
   "UndeleteCol": "Spalte löschen zurücknehmen", 
   "RemoveCol": "Spalte entfernen", 
   "DeleteCols1": "Spalte löschen", 
   "UndeleteCols1": "Spalte löschen zurücknehmen", 
   "RemoveCols1": "Spalte entfernen", 
   "DeleteSelectedCols1": "Ausgewählte Spalte löschen", 
   "UndeleteSelectedCols1": "Ausgewählte Spalte löschen zurücknehmen", 
   "RemoveSelectedCols1": "Ausgewählte Spalten entfernen", 
   "DeleteCols": "%1 Spalten löschen", 
   "UndeleteCols": "Löschen von %1 Spalten zurücknehmen", 
   "RemoveCols": "%1 Spalten entfernen", 
   "DeleteSelectedCols": "%1 ausgewählte Spalten löschen", 
   "UndeleteSelectedCols": "Löschen von %1 ausgewählten Spalten zurücknehmen", 
   "RemoveSelectedCols": "%1 ausgewählte Spalten entfernen", 

   "ClearSelection": "Auswahl von %1 Zeilen und Spalten aufheben", 
   "SelectRow": "Zeile auswählen", 
   "DeselectRow": "Zeilenauswahl aufheben", 
   "SelectFocusedRows1": "Fokussierten Zeile auswählen", 
   "DeselectFocusedRows1": "Auswahl fokussierten Zeile aufheben", 
   "SelectFocusedRows": "%1 fokussierte Zeilen auswählen", 
   "DeselectFocusedRows": "Auswahl %1 fokussierter Zeilen aufheben", 
   "SelectAll1": "Alle %1 Zeilen auswählen", 
   "DeselectAll1": "Auswahl die einzige Zeile aufheben", 
   "InvertAll1": "Auswahl die einzige Zeile umkehren", 
   "SelectAll": "Alle die einzige Zeile auswählen", 
   "DeselectAll": "Auswahl aller %1 Zeilen aufheben", 
   "InvertAll": "Auswahl aller %1 Zeilen umkehren", 
   "SelectCol": "Spalte auswählen", 
   "DeselectCol": "Spaltenauswahl aufheben", 
   "SelectFocusedCols1": "Fokussierten Spalte auswählen", 
   "DeselectFocusedCols1": "Auswahl fokussierten Spalte aufheben", 
   "SelectFocusedCols": "%1 fokussierte Spalten auswählen", 
   "DeselectFocusedCols": "Auswahl %1 fokussierter Spalten aufheben", 
   "SelectCell": "Zelle auswählen", 
   "DeselectCell": "Zellenauswahl aufheben", 
   "SelectRowRange1": "Die Zeile in Bereich auswählen", 
   "DeselectRowRange1": "Auswahl von Zeile in Bereich aufheben", 
   "SelectColRange1": "Spalte in Bereich auswählen", 
   "DeselectColRange1": "Auswahl von Spalte in Bereich aufheben", 
   "SelectCellRange1": "Zelle in Bereich auswählen", 
   "DeselectCellRange1": "Auswahl von Zelle in Bereich aufheben", 
   "SelectColCells1": "Die einzige Zelle in Spalte auswählen", 
   "DeselectColCells1": "Die einzige Zelle in Spalte aufheben", 
   "SelectRowCells1": "Die einzige in Zeile auswählen", 
   "DeselectRowCells1": "Die einzige Zellen in Zeile aufheben", 
   "SelectAllCells1": "Die einzige Zellen auswählen", 
   "DeselectAllCells1": "Auswahl die einzige Zellen aufheben", 
   "SelectAllCols1": "Die einzige spalte auswählen", 
   "DeselectAllCols1": "Auswahl die einzige Spalte aufheben", 
   "SelectRowRange": "%1 Zeilen in Bereich auswählen", 
   "DeselectRowRange": "Auswahl von %1 Zeilen in Bereich aufheben", 
   "SelectColRange": "%1 Spalten in Bereich auswählen", 
   "DeselectColRange": "Auswahl von %1 Spalten in Bereich aufheben", 
   "SelectCellRange": "%1 Zellen in Bereich auswählen", 
   "DeselectCellRange": "Auswahl von %1 Zellen in Bereich aufheben", 
   "SelectColCells": "Alle %1 Zellen in Spalte auswählen", 
   "DeselectColCells": "Auswahl von %1 Zellen in Spalte aufheben", 
   "SelectRowCells": "Alle %1 Zellen in Zeile auswählen", 
   "DeselectRowCells": "Auswahl von %1 Zellen in Zeile aufheben", 
   "SelectAllCells": "Alle %1 Zellen auswählen", 
   "DeselectAllCells": "Auswahl aller %1 Zellen aufheben", 
   "SelectAllCols": "Alle %1 Spalten auswählen", 
   "DeselectAllCols": "Auswahl aller %1 Spalten aufheben", 

   "Span": "Zellen verbinden", 
   "Split": "Verbundene Zellen trennen", 

   "Expand": "Zeile aufklappen", 
   "Collapse": "Zeile einklappen", 
   "ExpandAll1": "Die einzige Zeile aufklappen", 
   "CollapseAll1": "Die einzige Zeile einklappen", 
   "CollapseAllRoot1": "Die einzige Wurzelzeilen einklappen", 
   "ExpandAll": "Alle %1 Zeilen aufklappen", 
   "CollapseAll": "Alle %1 Zeilen einklappen", 
   "CollapseAllRoot": "Alle %1 Wurzelzeilen einklappen", 
   "Outdent1": "Zeileneinzug verkleinern", 
   "Indent1": "Zeileneinzug vergrößern", 
   "Outdent": "Einzug von %1 Zeilen verkleinern", 
   "Indent": "Einzug von %1 Zeilen vergrößern", 

   "ExpandCell": "Zelle auf- oder einklappen", 
   "ExpandCol": "Spalte aufklappen", 
   "CollapseCol": "Spalte einklappen", 
   "ExpandRow": "Zeile aufklappen", 
   "CollapseRow": "Zeile einklappen", 
   "ExpandAllCells": "Alle Spalten aufklappen", 
   "CollapseAllCells": "Alle Spalten einklappen", 
   "ExpandRowCells": "Alle Spalten in Zeile aufklappen", 
   "CollapseRowCells": "Alle Spalten in Zeile einklappen", 

   "HideRows1": "Zeile ausblenden", 
   "HideRows": "%1 Zeilen ausblenden", 
   "ShowRowAbove": "Ausgeblendete Zeile oberhalb anzeigen", 
   "ShowRowBelow": "Ausgeblendete Zeile unterhalb anzeigen", 
   "ShowRows1": "Ausgeblendete Zeile anzeigen", 
   "ShowRowsW": "Alle %1 ausgeblendeten Zeilen anzeigen", 
   "ShowRows": "%1 ausgeblendeten Zeilen anzeigen", 

   "HideCols1": "Spalte ausblenden", 
   "HideCols": "%1 Spalten ausblenden", 
   "ShowColLeft": "Ausgeblendete Spalte links anzeigen", 
   "ShowColRight": "Ausgeblendete Spalte rechts anzeigen", 
   "ShowCols1": "Ausgeblendete Spalte anzeigen", 
   "ShowColsW": "Alle %1 ausgeblendeten Spalten anzeigen", 
   "ShowCols": "%1 ausgeblendeten Spalten anzeigen", 

   "SearchOn": "Suche aktivieren", 
   "SearchOff": "Suche deaktivieren", 

   "SortAsc": "Nach dieser Spalte aufsteigend sortieren", 
   "SortDesc": "Nach dieser Spalte absteigend sortieren", 
   "SortAscOne": "Nur nach dieser Spalte aufsteigend sortieren", 
   "SortDescOne": "Nur nach dieser Spalte absteigend sortieren", 
   "SortAscAppend": "Nach dieser Spalte aufsteigend sortieren (als letztes Kriterium)", 
   "SortDescAppend": "Nach dieser Spalte absteigend sortieren (als letztes Kriterium)", 
   "NoSort": "Sortierung nach dieser Spalte entfernen", 
   "DefaultSort": "Original-Sortierung wiederherstellen", 
   "SortOn": "Sortieren aktivieren", 
   "SortOff": "Sortieren deaktivieren", 

   "Undo": "Letzte Aktion zurücknehmen", 
   "UndoAll1": "Letzte Aktion zurücknehmen", 
   "UndoAll": "Letzten %1 Aktionen zurücknehmen", 
   "Redo": "Letzte zurückgenommene Aktion wiederholen", 
   "RedoAll1": "Letzte zurückgenommene Aktion wiederholen", 
   "RedoAll": "Letzten %1 zurückgenommenen Aktionen wiederholen", 
   "ClearUndo": "Rücknahmepuffer leeren", 

   "Print": "Grid drucken", 
   "ExportPDF": "Grid als PDF drucken", 
   "Export": "Grid als XLSX, XLS oder CSV exportieren", 
   "Repaint": "Seiten auffrischen, ungenutzte Seiten entfernen", 
   "RenderPages": "Paging ändern", 
   "PagingOn": "Paging aktivieren, ungenutzte Seiten entfernen", 
   "PagingOff": "Paging deaktivieren, alle Seiten neu aufbereiten", 
   "ShowCfg": "Konfigurationsmenü anzeigen", 
   "ShowColumns": "Spalten-Menü anzeigen", 
   "ShowDebug": "Debugging-Fenster anzeigen", 
   "Reload": "Grid neu laden, Änderungen verwerfen", 
   "Validate": "Daten auf Fehler prüfen", 
   "Save": "Änderungen zum Server senden", 

   "GoUp": "Gehe nach oben", 
   "GoUpEdit": "Gehe nach oben", 
   "GoDown": "Gehe nach unten", 
   "GoDownEdit": "Gehe nach unten", 
   "GoDownAdd": "Gehe nach unten", 
   "GoDownEditAdd": "Gehe nach unten", 
   "GoLeft": "Gehe nach links", 
   "GoLeftEdit": "Gehe nach links", 
   "GoRight": "Gehe nach rechts", 
   "GoRightEdit": "Gehe nach rechts", 
   "GoFirst": "Gehe zu erster Zeile", 
   "GoLast": "Gehe zu letzter Zeile", 
   "PageDown": "Gehe zu nächster Seite", 
   "PageUp": "Gehe zu vorhergehender Seite", 
   "PageDownFull": "Gehe zu nächster Seite", 
   "PageUpFull": "Gehe zu vorhergehender Seite", 

   "ShowDetail": "Zeige Details für Zeile", 
   "RefreshDetail": "Zeige Details für Zeile", 
   "ClearDetail": "Details löschen", 

   "ShowHintStatic": "Kompletten Zellinhalt anzeigen", 
   "GridResizeDefault": "Originalgröße des Grids wiederherstellen", 

   "GroupBy": "Nach Spalte gruppieren", 
   "GroupByLast": "Gruppierung für Spalte hinzufügen", 
   "UngroupBy": "Gruppierung für Spalte aufheben", 
   "GroupOn": "Gruppierung aktivieren", 
   "GroupOff": "Gruppierung aktivieren", 

   "Focus": "Zelle fokussieren", 
   "FocusEdit": "Zelle fokussieren und editieren", 
   "FocusAndEdit": "Zelle fokussieren und editieren", 
   "ChangeFocus": "Zelle fokussieren", 
   "ChangeFocusRow": "Zelle in Zeile fokussieren", 
   "ChangeFocusCol": "Zelle in Spalte fokussieren", 
   "Blur": "Fokus entfernen", 
   "BlurFocused": "Fokus entfernen", 
   "FocusWholeRow": "Alle Zellen der Zeile fokussieren", 
   "FocusWholeCol": "Alle Zellen der Spalte fokussieren", 
   "FocusWholeGrid": "Alle Zellen des Grids fokussieren", 

   "StartEdit": "Fokussierte Zelle editieren", 
   "StartEditEmpty": "Fokussierte Zelle leeren und editieren", 
   "StartEditCell": "Zelle editieren", 
   "StartEditCellEmpty": "Zelle leeren und editieren", 
   "CancelEdit": "Editieren abbrechen", 
   "AcceptEdit": "Editieren beenden", 
   "ShowCalendar": "Datum aus Kalender auswählen", 
   "ShowDates": "Datum aus Tabelle auswählen", 
   "ShowLink": "Zu URL navigieren", 
   "Button": "Button drücken", 
   "ButtonClick": "Button rechts drücken", 
   "IconClick": "Button links drücken", 
   "ShowHelp": "Hilfe anzeigen", 
   "ShowFile": "Datei auswählen", 
   "ShowDefaults": "Default-Werte anzeigen", 
   "ShowDefaultsMenu": "Default-Werte anzeigen", 

   "ChangeBool": "Checkbox ändern", 
   "CheckBool": "Checkbox setzen", 
   "UncheckBool": "Checkbox leeren", 
   "ClearBool": "Zelle leeren", 
   "ChangeRadioLeft": "Auswahl nach links", 
   "ChangeRadioLeftCycle": "Auswahl nach links", 
   "ChangeRadioRight": "Auswahl nach rechts", 
   "ChangeRadioRightCycle": "Auswahl nach rechts", 
   "CheckIcon": "Checkbox setzen", 
   "UncheckIcon": "Checkbox leeren", 
   "SetChecked": "Checkbox ändern", 

   "ShowFilterMenu": "Zeige Filtermenü", 
   "ShowFilterMenuRow": "Zeige Filtermenü", 
   "FilterBy": "Nach Zellwert filtern", 
   "FilterByMenu": "Filter für Zellwert wählen", 
   "FilterByMenuRow": "Filter für Zellwert wählen", 
   "ClearFilter": "Filter für Spalte entfernen", 
   "ClearFilters": "Alle Filter entfernen", 
   "FilterOn": "Filtern aktivieren", 
   "FilterOff": "Filtern deaktivieren", 

   "ClearCell": "Leeren", 
   "ClearValueStyle": "Werte und Style löschen", 
   "ClearValue": "Werte löschen", 
   "ClearStyle": "Style löschen", 

   "SetCellAbsolute": "Zellbezug absolut setzen", 
   "SetCellRelative": "Zellbezug relativ setzen", 
   "SwitchCellAbsolute": "Zellbezug umschalten", 
   "SwitchRowColAbsolute": "Zellbezug umschalten", 
   "ChooseRowInsert": "Bezug auf Zeile einfügen", 
   "ChooseRowReplace": "Bezug auf Zeile ersetzen", 
   "ChooseRowReplaceAll": "Bezug auf Zeile ersetzen", 
   "ChooseColInsert": "Bezug auf Spalte einfügen", 
   "ChooseColReplace": "Bezug auf Spalte ersetzen", 
   "ChooseColReplaceAll": "Bezug auf Spalte ersetzen", 
   "ChooseCellInsert": "Bezug auf Zelle einfügen", 
   "ChooseCellReplace": "Bezug auf Zelle ersetzen", 
   "ChooseCellReplaceAll": "Bezug auf Zelle ersetzen", 

   "CalcOn": "Berechnung aktivieren", 
   "CalcOff": "Berechnung deaktivieren", 

   "ClearBorder": "Rahmen entfernen", 
   "ClearBorderOut": "Äußeren Rahmen entfernen", 
   "ClearBorderIn": "Inneren Rahmen entfernen", 
   "ClearBorderTop": "Rahmen oben entfernen", 
   "ClearBorderBottom": "Rahmen unten entfernen", 
   "ClearBorderLeft": "Rahmen links entfernen", 
   "ClearBorderRight": "Rahmen rechts entfernen", 
   "SetBorder": "Rahmen setzen", 
   "SetBorderTop": "Rahmen oben setzen", 
   "SetBorderBottom": "Rahmen unten setzen", 
   "SetBorderLeft": "Rahmen links setzen", 
   "SetBorderRight": "Rahmen rechts setzen", 
   "SetBorderOut": "Äußeren Rahmen setzen", 
   "SetBorderOutTop": "Äußeren Rahmen oben setzen", 
   "SetBorderOutBottom": "Äußeren Rahmen unten setzen", 
   "SetBorderOutLeft": "Äußeren Rahmen links setzen", 
   "SetBorderOutRight": "Äußeren Rahmen rechts setzen", 
   "SetBorderIn": "Inneren Rahmen setzen", 
   "SetBorderInTop": "Inneren Rahmen oben setzen", 
   "SetBorderInBottom": "Inneren Rahmen unten setzen", 
   "SetBorderInLeft": "Inneren Rahmen links setzen", 
   "SetBorderInRight": "Inneren Rahmen rechts setzen", 
   "ChooseBorderEdge": "Rahmenseite wählen", 
   "ChooseBorderEdgeItems": "%1", 
   "ChooseBorderStyle": "Rahmenstil wählen", 
   "ChooseBorderStyleItems": "%1", 
   "ChooseBorderColor": "Rahmenfarbe wählen", 
   "ChooseBorderColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "ChooseBorder": "Rahmen wählen", 

   "RotateLeft": "Nach links drehen", 
   "RotateRight": "Nach rechts drehen", 
   "NoRotate": "Rotation entfernen", 
   "VertAlignTop": "Inhalt oben ausrichten", 
   "VertAlignBottom": "Inhalt unten ausrichten", 
   "VertAlignMiddle": "Inhalt vertikal zentriert ausrichten", 
   "NoVertAlign": "Vertikale Ausrichtung entfernen", 
   "AlignLeft": "Inhalt links ausrichten", 
   "AlignRight": "Inhalt rechts ausrichten", 
   "AlignCenter": "Inhalt horizontal zentriert ausrichten", 
   "NoAlign": "Horizontale Ausrichtung entfernen", 
   "WrapOn": "Umbruch", 
   "WrapOff": "Kein Umbruch", 
   "NoWrap": "Standard-Umbruch", 
   "NoTextStyle": "Standard-Textstil", 
   "BoldOn": "Schrift fett", 
   "BoldOff": "Schrift nicht fett", 
   "ItalicOn": "Schrift kursiv", 
   "ItalicOff": "Schrift nicht kursiv", 
   "UnderlineOn": "Schrift unterstrichen", 
   "UnderlineOff": "Schrift nicht unterstrichen", 
   "StrikeOn": "Schrift durchgestrichen", 
   "StrikeOff": "Schrift nicht durchgestrichen", 
   "OverlineOn": "Schrift überstrichen", 
   "OverlineOff": "Schrift nicht überstrichen", 
   "SmallCapsOn": "Kapitälchen", 
   "SmallCapsOff": "Keine Kapitälchen ", 
   "SetTextColor": "Textfarbe setzen", 
   "NoTextColor": "Textfarbe entfernen", 
   "ChooseTextColor": "Textfarbe wählen", 
   "ChooseTextColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "SetColor": "Füllfarbe setzen", 
   "NoColor": "Füllfarbe entfernen", 
   "ChooseColor": "Füllfarbe wählen", 
   "ChooseColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "SetTextSize": "Schriftgröße setzen", 
   "NoTextSize": "Standard-Schriftgröße setzen", 
   "ChooseTextSize": "Schriftgröße wählen", 
   "ChooseTextSizeItems": "%1", 
   "SetTextFont": "Schriftart setzen", 
   "NoTextFont": "Standard-Schriftart setzen", 
   "ChooseTextFont": "Schriftart wählen", 
   "ChooseTextFontItems": "%1", 
   "SetTextShadowColor": "Schattenfarbe setzen", 
   "NoTextShadowColor": "Schattenfarbe entfernen", 
   "ChooseTextShadowColor": "Schattenfarbe wählen", 
   "ChooseTextShadowColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "SetTextShadow": "Textschatten setzen", 
   "NoTextShadow": "Textschatten entfernen", 
   "ChooseTextShadow": "Textschatten wählen", 
   "ChooseTextShadowItems": "%1", 

   "SetEditable": "Änderbar", 
   "SetReadOnly": "Schreibgeschützt", 
   "SetPreview": "Preview-Modus", 
   "ClearEditable": "Schreibgeschützt, wenn gesperrt", 
   
   "ShowFormula": "Formel anzeigen", 
   "HideFormula": "Formel ausblenden", 
   "DefaultFormula": "Formel ausblenden, wenn gesperrt", 

   "ChooseFormat": "Format wählen", 
   "SetFormat": "Format setzen", 

"V12_1": "", 
   "Copy": "Kopieren in die Zwischenablage", 
   "Exclude": "Ausschneiden in die Zwischenablage", 

"V13_0": "", 
   "Import": "Lokale XLSX-Datei in Grid importieren", 

"V15_0": "", 
   "ShowCellLink": "Zu link URL navigieren", 
   "SetLink1": "Der link URL einzugeben", 
   "SetLinkE": "Der link URL einzugeben", 
   "SetLink": "Die %1 link URL einzugeben", 
   "ClearLink1": "Der link URL zu löschen", 
   "ClearLinkE": "Der link URL zu löschen", 
   "ClearLink": "Die %1 link URL zu löschen", 

   "OpenImage": "Eine lokale Bilddatei in die Zelle einfügen", 

   "UpperCase1": "In Großbuchstaben", 
   "UpperCaseE": "In Großbuchstaben", 
   "UpperCase": "%1 Texte in Großbuchstaben", 
   "LowerCase1": "In Kleinbuchstaben", 
   "LowerCaseE": "In Kleinbuchstaben", 
   "LowerCase": "%1 Texte in Kleinbuchstaben", 

   "IncreaseTextSizeE": "Schriftgröße erhöhen", 
   "IncreaseTextSize": "Schriftgröße erhöhen", 
   "DecreaseTextSizeE": "Schriftgröße verringern", 
   "DecreaseTextSize": "Schriftgröße verringern", 

   "Superscript": "Texte in Hochgestellt", 
   "Subscript": "Texte in Tiefgestellt", 
   "Noscript": "Hochgestellt / tiefgestellt löschen", 
   "SetTextLine": "Der Dekoration für die Unterstreichung setzen", 
   "NoTextLine": "Der Dekoration für die Unterstreichung entfernen", 
   "ChooseTextLine": "Der Dekoration für die Unterstreichung wählen", 
   "ChooseTextLineItems": "<span style='text-decoration:%1 line-through;'>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</span>", 
   "SetPattern": "Hintergrundmuster setzen", 
   "NoPattern": "Hintergrundmuster entfernen", 
   "ChoosePattern": "Hintergrundmuster wählen", 
   "ChoosePatternItems": "<span style='background-image:%1;padding-left:50px;line-height:16px;font-size:16px;'></span>", 
   "SetPatternColor": "Hintergrundmusterfarbe setzen", 
   "NoPatternColor": "Hintergrundmusterfarbe entfernen", 
   "ChoosePatternColor": "Hintergrundmusterfarbe wählen", 
   "ChoosePatternColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 

   "RotateLeft30": "Zelle um 30 Grad nach links drehen", 
   "RotateRight30": "Zelle um 30 Grad nach rechts drehen", 
   "RotateLeft45": "Zelle um 45 Grad nach links drehen", 
   "RotateRight45": "Zelle um 45 Grad nach rechts drehen", 
   "RotateLeft60": "Zelle um 60 Grad nach links drehen", 
   "RotateRight60": "Zelle um 60 Grad nach rechts drehen", 
   "RotateLeft90": "Zelle um 90 Grad nach links drehen", 
   "RotateRight90": "Zelle um 90 Grad nach rechts drehen", 
   "RotateLeftVert": "Zelle vertikal nach links drehen", 
   "RotateRightVert": "Zelle vertikal nach rechts drehen", 

   "VertAlignTopE": "Texte in Hochgestellt", 
   "SuperscriptE": "Texte in Hochgestellt", 
   "VertAlignBottomE": "Texte in Tiefgestellt", 
   "SubscriptE": "Texte in Tiefgestellt", 
   "VertAlignMiddleE": "Hochgestellt / tiefgestellt löschen", 
   "NoVertAlignE": "Hochgestellt / tiefgestellt löschen", 
   "NoscriptE": "Hochgestellt / tiefgestellt löschen", 
   "BoldOnE": "Fett- / Normalschriftstärke", 
   "BoldOffE": "", 
   "ItalicOnE": "Kursiven / normalen Schriftstil", 
   "ItalicOffE": "", 
   "UnderlineOnE": "Unterstrichene / normale Schriftart", 
   "UnderlineOffE": "", 
   "StrikeOnE": "Durchgestrichene / normale Schriftart", 
   "StrikeOffE": "", 
   "SetTextLineE": "Unterstreichungsfarbe setzen", 
   "NoTextLineE": "Unterstreichungsfarbe entfernen", 
   "ChooseTextLineE": "Unterstreichungsfarbe wählen", 
   "SetTextColorE": "Textfarbe setzen", 
   "NoTextColorE": "Textfarbe entfernen", 
   "ChooseTextColorE": "Textfarbe wählen", 
   "SetColorE": "Füllfarbe setzen", 
   "NoColorE": "Füllfarbe entfernen", 
   "ChooseColorE": "Füllfarbe wählen", 
   "SetTextSizeE": "Schriftgröße setzen", 
   "NoTextSizeE": "Standard-Schriftgröße setzen", 
   "ChooseTextSizeE": "Schriftgröße wählen", 
   "SetTextFontE": "Schriftart setzen", 
   "NoTextFontE": "Standard-Schriftart setzen", 
   "ChooseTextFontE": "Schriftart wählen", 
   "SetTextShadowColorE": "Schattenfarbe setzen", 
   "NoTextShadowColorE": "Schattenfarbe entfernen", 
   "ChooseTextShadowColorE": "Schattenfarbe wählen", 
   "ClearStyleE": "Textstyle löschen", 

   "ShowColTreeLevel": "Aufklappen die Spalten bis diese Level", 
   "OutdentCols1": "Spalteneinzug verkleinern", 
   "OutdentColsForce1": "Spalteneinzug verkleinern", 
   "IndentCols1": "Spalteneinzug vergrößern", 
   "IndentColsForce1": "Spalteneinzug vergrößern", 
   "OutdentCols": "Einzug von %1 Spalten verkleinern", 
   "OutdentColsForce": "Einzug von %1 Spalten verkleinern", 
   "IndentCols": "Einzug von %1 Spalten vergrößern", 
   "IndentColsForce": "Einzug von %1 Spalten vergrößern", 

   "FixAbove": "Frieren vorherigen Zeilen oben", 
   "FixBelow": "Frieren nächsten Zeilen unten", 
   "FixPrev": "Frieren vorherigen Spalten nach links", 
   "FixNext": "Frieren nächsten Spalten nach rechts", 

   "RestoreImage": "Bildgröße/Position/Drehung wiederherstellen", 
   "RestoreImageSize": "Bildgröße auf Standard einstellen", 
   "RestoreImageRotation": "Bild nicht drehen", 
   "RestoreImagePosition": "Bild an seine ursprüngliche Position verschieben", 
   "AssignImage": "Bild in die obere linke Zelle verschieben", 
   "DeleteImage": "Bild löschen", 
   "DuplicateImage": "Bild duplizieren", 
   "DragImageClear": "Das Bild ziehen führt die Standardaktion aus", 
   "DragImageResize": "Durch Ziehen wird die Größe des Bildes geändert", 
   "DragImageResizeXY": "Durch Ziehen wird die Größe des Bildes in eine Richtung geändert", 
   "DragImageResizeFree": "Durch Ziehen wird die Größe des Bildes geändert, das Seitenverhältnis ignoriert", 
   "DragImageRotate": "Durch Ziehen des Bildes wird es drehen", 
   "DragImageCrop": "Durch Ziehen des Bildes wird es beschnitten", 
   "DragImageMove": "Durch Ziehen des Bildes wird es verschoben", 
   "DragImageMoveXY": "Durch Ziehen des Bildes wird es in eine Richtung verschoben", 
   "DragImageCopy": "Durch Ziehen des Bildes wird es kopieren", 
   "DragImageCopyXY": "Durch Ziehen des Bildes wird es in eine Richtung kopieren", 
   "DragImageNone": "Durch Ziehen von Bildern wird eingeschränkt", 
   "EnterImageOpacity": "Die Bildopazität eingeben", 
   "EnterImageName": "Die Bildtitel eingeben", 

   "AutoSpan": "Zellen automatisch verbinden", 
   "AutoRowSpan": "Zellen automatisch vertikal verbinden", 
   "AutoColSpan": "Zellen automatisch horizontal verbinden", 

   "Lock": "Grid sperren / entsperren", 
   "Lock0": "Grid entsperren", 
   "Lock1": "Gridstruktur sperren", 
   "Lock2": "Grid Struktur und Stile sperren", 
   "Lock3": "Grid vollständig sperren", 

   "DefineName": "Name festlegen", 
   "DefineGlobalName": "Global Name festlegen", 
   "EditName": "Name ändern", 
   "DeleteName": "Name löschen"  
    }, 



// Configuration menu item names, HTML 
      
"MenuCfg" : { 
         
"V2_3": "", 		
   "Caption": "TreeGrid Einstellungen", 
   "ShowDeleted": "Gelöschte Zeilen anzeigen (in rot)", 
   "AutoSort": "Automatisches Sortieren nach Änderungen", 
   "AutoUpdate": "Änderungen automatisch zum Server senden", 
   "MouseHover": "Mausposition hervorheben", 
   "Hover1": "Nein", 
   "Hover2": "Nur Zelle", 
   "Hover3": "Zeile", 
   "Hover4": "Zeile und Spalte", 
   "ShowDrag": "Gezogene Objekte anzeigen", 
   "ShowPanel": "Panel links anzeigen", 
"V2_6": "", 
   "ShowPager": "Pager anzeigen", 
   "ShowAllPages": "Alle Seiten anzeigen", 
"V4_4": "", 
   "CheckUpdates": "Server auf Aktualisierungen prüfen alle", 
   "CheckUpdates0": "aus", 
   "CheckUpdates2": "2 Sekunden", 
   "CheckUpdates5": "5 Sekunden", 
   "CheckUpdates10": "10 Sekunden", 
   "CheckUpdates30": "30 Sekunden", 
   "CheckUpdates60": "1 Minute", 
   "CheckUpdates120": "2 Minuten", 
   "CheckUpdates300": "5 Minuten", 
   "CheckUpdates600": "10 Minuten", 
"V5_0_20": "", 
   "SortClick": "Klickverhalten Sortierung", 
   "SortClick1": "Einfach, keine Icons", 
   "SortClick2": "Einfach", 
   "SortClick3": "Gerichtet, nur Icons", 
   "SortClick4": "Gerichtet", 
"V6_3": "", 
   "GanttCorrectDependencies": "Aufgaben terminieren", 
   "Correct1": "manuell", 
   "Correct2": "automatisch", 
   "Correct3": "nachfragen", 
   "GanttCheckDependencies": "Zirkuläre Abhängigkeiten", 
   "Check1": "erlauben", 
   "Check2": "verbieten", 
   "Check3": "nachfragen", 
   "GanttHideExclude": "Arbeitsfreie Tage im Chart anzeigen", 
   "GanttCheckExclude": "Aufgaben an arbeitsfreien Tagen starten", 
   "GanttCorrectDependenciesFixed": "Automatisches Planen geänderter Aufgaben", 
"V6_4": "", 
   "GanttBaseProof": "Objekte vor Projektstart verschieben möglich", 
   "GanttBasePreferred": "Projektbeginn hat Vorrang ggü. Restriktionen", 
"V6_6": "", 
   "GanttMinSlack": "Minimaler Spielraum für kritische Aufgaben", 
   "GanttErrSlack": "Minimaler-Spielraum-Limit für fehlgeschlagene Aufgaben", 
   "GanttSeparateSlack": "Kritischen Pfad individuell berechnen", 
"V6_7": "", 
   "Check4": "alert", 
"V7_0": "", 
   "GanttFixComplete": "Auch bereits gestartete Aufgaben terminieren", 
   "GanttFinishProof": "Objekte nach Projektende verschieben möglich", 
   "GanttFinishPreferred": "Projektende hat Vorrang ggü. Restriktionen", 
   "Scrollbars": "Typ Scrollbalken", 
   "Scrollbars1": "Keine", 
   "Scrollbars2": "Dünn", 
   "Scrollbars3": "Standard", 
   "Scrollbars4": "Breit", 
   "Scroll": "Scrollen mit", 
   "Scroll1": "Nur Scrollbalken", 
   "Scroll2": "Ein Finger (Kein Schieben)", 
   "Scroll3": "Zwei Finger (Kein Zoom)", 
   "Scroll4": "Drei Finger (Kein Drag)", 
"V10_0": "", 
   "GanttCheck": "Inkorrekte Eingaben", 
   "GanttCheck1": "erlauben", 
   "GanttCheck2": "verbieten", 
   "GanttCheck3": "verbieten + Warnung", 
   "GanttCheck4": "korrigieren", 
   "GanttCheck5": "korrigieren + Warnung", 
   "ReversedTree": "Umgekehrter Baum (wie in MS Excel)", 
   "GanttDirection": "Aufgaben terminieren vom", 
   "GanttDirection1": "Projektbeginn", 
   "GanttDirection2": "Projektende", 
   "GanttStrict": "Planungsmethode", 
   "GanttStrict1": "minimale Verschiebung", 
   "GanttStrict2": "strenge Verschiebung", 
   "GanttStrict3": "", 
   "GanttStrict4": "min. strenge Verschiebung", 
"V11_0": "", 
   "ShowButtons": "Button-Anzeige", 
   "ShowButtons1": "Nur Icons", 
   "ShowButtons2": "Nur Texte", 
   "ShowButtons3": "Icons und Texte", 
   "GanttCorrectOutsideBounds": "Aufgaben außerhalb Projektgrenzen terminieren", 
"V12_1": "", 
   "CfgCaption": "Grundlegende Einstellung", 
   "GanttCaption": "Gantt-Einstellungen", 
"V13_0": "", 
   "Animations": "Aktionen animieren", 
   "ShrinkStyle": "Bei wenig Platz Stylegröße reduzieren", 
   "ShrinkStyle1": "Nie", 
   "ShrinkStyle2": "Immer", 
   "ShrinkStyle3": "Fragen", 
   "CompatibleStyles": "Kompatibel", 
   "Style": "Style", 
   "GanttStyle": "Gantt-Style", 
   "StyleSize": "Stylegröße", 
   "Scale": "Skalierung", 
   "StylesCaption": "-", 
   "ShowBorder": "Standard-Rahmen anzeigen", 
   "FormulaTip": "Formel als Tooltip anzeigen", 
"V13_1": "", 
   "ShrinkStyle4": "Minimal", 
"V14_0": "", 
   "LanguageCaption": "-", 
   "Language": "Sprache", 
"V15_0": "", 
   "ShowFormulas": "Zeige Formeln anstelle von Ergebnissen", 
   "ShowZeros": "Zellen Nullwerte anzeigen", 
   "PageBreaks": "Seitenumbrüche zum Drucken anzeigen", 
   "Contrast": "Kontrast", 
   "ShowTree": "Zeilenbaum anzeigen", 
   "ShowTree1": "Deaktivieren", 
   "ShowTree2": "Ausblenden", 
   "ShowTree3": "Eltern oben", 
   "ShowTree4": "Eltern unten", 
   "ColTree": "Spaltenbaum anzeigen", 
   "ColTree1": "Deaktivieren", 
   "ColTree2": "Ausblenden", 
   "ColTree3": "Eltern links", 
   "ColTree4": "Eltern rechts", 
   "SheetCaption": "Blatt Einstellung", 
   "GanttShowBorder": "Zellrahmen anzeigen"  
    }, 



// Columns menu item names, HTML 

"MenuColumns" : { 

"V12_1": "", 
   "Caption": "Elemente auswählen", 
   "ColsCaption": "Spalten auswählen", 
   "PagersCaption": "Pager auswählen", 
   "SpaceCaption": "Toolbars auswählen", 
   "RowsCaption": "Zeilen auswählen"  
    }, 



// Print menu item names, HTML 

"MenuPrint" : { 

"V12_1": "", 
   "Caption": "Druckeinstellungen", 
   "PrintOptions": "Druckeinstellungen", 
   "PDFName": "Dateiname", 
   "PDFFormat": "", 
   "PrintRows": "Max. Zeilen pro Seite", 
   "PrintPageRoot": "Startseite immer mit Wurzelzeile", 
   "PDFText": "", 
   "PDFTexts": "Nur Bild,Auswählbarer Text,Eingebettete Schriftarten", 
   "PrintExpanded": "Alle Zeilen aufgeklappt drucken", 
   "PrintFiltered": "Alle Zeilen (ungefiltert) drucken", 
   "PrintSelectedRows": "Nur ausgewählte Zeilen drucken", 
   "PrintSelectedCols": "Nur ausgewählte Spalten drucken", 
   "PrintSelectedCells": "Nur ausgewählte Zellen drucken", 
   "PrintVisible": "Nur sichtbares Gantt drucken", 

   "PrintPageOptions": "Seitengröße<div style='font-size:10px;color:#EA4647;white-space:normal;'>Die&nbsp;selben&nbsp;Werte&nbsp;sollten&nbsp;auch&nbsp;im&nbsp;Druckdialog&nbsp;des&nbsp;Browsers&nbsp;gesetzt&nbsp;werden!</div>", 
   "PDFPageOptions": "Seitengröße", 
   "PrintPageSize": "Seitengröße", 
   "PrintPageSizes": "Auto,26000,26000,Letter (8.5x11in),215.9,279.4,Legal (8.5x14in),215.9,355.6,Ledger (11x17in),279.4,431.8,A0 - (841x1189),841,1189,A1 - (594x841),594,841,A2 - (420x594),420,594,A3 - (297x420),297,420,A4 - (210x297),210,297,A5 - (148x210),148,210,A6 - (105x148),105,148,A7 - (74x105),74,105,A8 - (52x74),52,74,A9 - (37x52),37,52,B0 - (1000x1414),1000,1414,B1 - (707x1000),707,1000,B2 - (500x707),500,707,B3 - (353x500),353,500,B4 - (250x353),250,353,B5 - (176x250),176,250", 
   "PrintPageOrientation": "Ausrichtung", 
   "PrintPageOrientations": "Hochformat,Querformat", 
   "PrintMarginWidth": "Seitenränder Breite (mm)", 
   "PrintMarginHeight": "Seitenränder Höhe (mm)", 
   "PDFFitPage": "Auf Seite einpassen", 
   "PDFFitPages": "nein,Breite,Höhe,Eine Seite", 
   "PrintDPI": "Auflösung DPI (PPI)", 
   "PrintWidth": "Seitenbreite (px)", 
   "PrintHeight": "Seitenhöhe (px)", 
   "PrintResults": "Druckgröße ist %d x %d Seiten", 
"V15_0": "", 
   "PrintOnlyData": "Ohne die letzten leeren Zellen"  
    }, 



// Export menu item names, HTML 

"MenuExport" : { 

"V12_1": "", 
   "Caption": "Export-Optionen", 
   "ExportOptions": "Export-Optionen", 
   "ExportName": "Dateiname", 
   "ExportFormat": "Dateiformat", 
   "ExportExpanded": "Alle Zeilen aufgeklappt exportieren", 
   "ExportFiltered": "Alle Zeilen (ungefiltert) exportieren", 
   "ExportOutline": "Baum als Gliederung in Excel exportieren", 
   "ExportIndent": "Baum in Hauptspalte einrücken", 
   "ExportSelectedRows": "Nur ausgewählte Zeilen exportieren", 
   "ExportSelectedCols": "Nur ausgewählte Spalten exportieren", 
   "ExportSelectedCells": "Nur ausgewählte Zellen exportieren", 
   "ExportFixedRows": "Kopfzeilen einfrieren", 
   "ExportFixedCols": "Linke Spalten einfrieren", 
   "ExportEmpty": "Auch leere Zellen exportieren"  
    },  



// Filter menu operator names, HTML 
      
"MenuFilter" : { 
       
   "F0": "Aus", 
   "F1": "Gleich", 
   "F2": "Ungleich", 
   "F3": "Kleiner als", 
   "F4": "Kleiner oder gleich", 
   "F5": "Größer als", 
   "F6": "Größer oder gleich", 
   "F7": "Beginnt mit", 
   "F8": "Beginnt nicht mit", 
   "F9": "Endet mit", 
   "F10": "Endet nicht mit", 
   "F11": "Enthält", 
   "F12": "Enthält nicht", 
"V14_0": "", 
   "Defs": "Filter anwenden auf", 
   "Defs1": "Filter angewendet auf"  
    }, 



// Names of functions in editable formulas, in format JavaScriptName="LocalizedName". Since 12.0 

"FormulaFunctions" : { 

"V12_0": "", 
   "sum": "summe", 
   "sumsq": "quadratsumme", 
   "count": "anzahl", 
   "counta": "anzahl2", 
   "countblank": "anzahlleerezellen", 
   "max": "max", 
   "min": "min", 
   "product": "produkt", 
   "second": "sekunde", 
   "minute": "minute", 
   "hour": "stunde", 
   "day": "tag", 
   "month": "monat", 
   "year": "jahr", 
   "date": "datum", 
   "time": "zeit", 
   "today": "heute", 
   "now": "jetzt", 
   "weekday": "wochentag", 
   "weeknum": "kalenderwoche", 
   "round": "runden", 
   "ceil": "ceil", 
   "floor": "untergrenze", 
   "abs": "abs", 
   "exp": "exp", 
   "log": "log", 
   "pow": "potenz", 
   "sqrt": "wurzel", 
   "sin": "sin", 
   "cos": "cos", 
   "tan": "tan", 
   "asin": "arcsin", 
   "acos": "arccos", 
   "atan": "arctan", 
   "text": "text", 
"V13_0": "", 
   "if": "wenn", 
   "ifs": "wenns", 
   "switch": "ersterwert", 
   "choose": "wahl", 
   "concatenate": "verketten", 
   "concat": "textkette", 
   "int": "ganzzahl", 
   "fix": "fix", 
   "pi": "pi", 
   "hlookup": "hverweis", 
   "vlookup": "sverweis", 
   "lookup": "verweis", 
   "match": "vergleich", 
   "index": "index", 
   "rank": "rang", 
   "rank.eq": "rang.gleich", 
   "rank.avg": "rang.mittelw", 
   "percentrank": "quantilsrang", 
   "percentrank.inc": "quantilsrang.inkl", 
   "percentrank.exc": "quantilsrang.exkl", 
   "percentile": "quantil", 
   "percentile.inc": "quantil.inkl", 
   "percentile.exc": "quantil.exkl", 
   "quartile": "quartile", 
   "quartile.inc": "quartile.inkl", 
   "quartile.exc": "quartile.exkl", 
   "find": "finden", 
   "iferror": "wennfehler", 
   "ifna": "wennnv", 
   "and": "und", 
   "or": "oder", 
   "xor": "xoder", 
   "not": "nicht", 
   "true": "wahr", 
   "false": "falsch", 
   "address": "adresse", 
   "column": "spalte", 
   "columns": "spalten", 
   "row": "zeile", 
   "rows": "zeilen", 
   "offset": "bereich.verschieben", 
   "days": "tage", 
   "edate": "edatum", 
   "eomonth": "monatsende", 
   "timevalue": "zeitwert", 
   "datevalue": "datwert", 
   "isoweeknum": "isokalenderwoche", 
   "isblank": "istleer", 
   "iserror": "istfehler", 
   "iserr": "istfehl", 
   "isna": "istnv", 
   "iseven": "istgerade", 
   "isodd": "istungerade", 
   "isformula": "istformel", 
   "islogical": "istlog", 
   "isnontext": "istktext", 
   "istext": "isttext", 
   "isnumber": "istzahl", 
   "isref": "istbezug", 
   "n": "n", 
   "t": "t", 
   "na": "nv", 
   "type": "typ", 
   "formulatext": "formeltext", 
   "char": "zeichen", 
   "clean": "säubern", 
   "code": "code", 
   "dollar": "dm", 
   "exact": "identisch", 
   "fixed": "fest", 
   "left": "links", 
   "right": "rechts", 
   "mid": "teil", 
   "len": "länge", 
   "lower": "klein", 
   "upper": "gross", 
   "numbervalue": "zahlenwert", 
   "proper": "gross2", 
   "replace": "ersetzen", 
   "rept": "wiederholen", 
   "search": "suchen", 
   "substitute": "wechseln", 
   "textjoin": "textverketten", 
   "unicode": "unicode", 
   "unichar": "unizeichen", 
   "value": "wert", 
   "trim": "glätten", 
   "sinh": "sinhyp", 
   "cosh": "coshyp", 
   "tanh": "tanhyp", 
   "asinh": "arcsinhyp", 
   "acosh": "arccoshyp", 
   "atanh": "arctanhyp", 
   "cot": "cot", 
   "acot": "arccot", 
   "coth": "cothyp", 
   "acoth": "arccothyp", 
   "atan2": "arctan2", 
   "base": "basis", 
   "ceiling": "obergrenze", 
   "ceiling.math": "obergrenze.mathematik", 
   "ceiling.precise": "obergrenze.genau", 
   "floor.math": "untergrenze.mathematik", 
   "floor.precise": "untergrenze.genau", 
   "combin": "kombinationen", 
   "combina": "kombinationen2", 
   "sign": "vorzeichen", 
   "gcd": "ggt", 
   "lcm": "kgv", 
   "power": "potenz", 
   "quotient": "quotient", 
   "mod": "rest", 
   "mround": "vrunden", 
   "roundup": "aufrunden", 
   "rounddown": "abrunden", 
   "trunc": "kürzen", 
   "rand": "zufallszahl", 
   "randbetween": "zufallsbereich", 
   "sumproduct": "summenprodukt", 
   "sumx2my2": "summex2my2", 
   "sumx2py2": "summex2py2", 
   "sumxmy2": "summexmy2", 
   "seriessum": "potenzreihe", 
   "sqrtpi": "wurzelpi", 
   "degrees": "grad", 
   "radians": "bogenmass", 
   "sec": "sec", 
   "sech": "sechyp", 
   "csc": "cosec", 
   "csch": "cosechyp", 
   "ln": "ln", 
   "log10": "log10", 
   "fact": "fakultät", 
   "factdouble": "zweifakultät", 
   "multinomial": "polynomial", 
   "decimal": "dezimal", 
   "mdeterm": "mdet", 
   "sumif": "summewenn", 
   "countif": "countif", 
   "sumifs": "summewenns", 
   "countifs": "zählenwenn", 
   "permut": "variationen", 
   "permutationa": "variationen2", 
   "average": "mittelwert", 
   "averagea": "mittelwerta", 
   "averageif": "mittelwertwenn", 
   "averageifs": "mittelwertwenns", 
   "median": "median", 
   "mode": "modalwert", 
   "mode.sngl": "modus.einf", 
   "geomean": "geomittel", 
   "harmean": "harmittel", 
   "trimmean": "gestutztmittel", 
   "avedev": "mittelabw", 
   "devsq": "sumquadabw", 
   "stdev": "stabw", 
   "stdeva": "stabwa", 
   "stdevp": "stabwn", 
   "stdevpa": "stabwna", 
   "stdev.s": "stabw.s", 
   "stdev.p": "stabw.n", 
   "var": "varianz", 
   "vara": "varianza", 
   "varp": "varianzen", 
   "varpa": "varianzena", 
   "var.s": "var.s", 
   "var.p": "var.p", 
   "covar": "kovar", 
   "covariance.s": "kovarianz.s", 
   "covariance.p": "kovarianz.p", 
   "forecast": "schätzer", 
   "forecast.linear": "prognose.linear", 
   "intercept": "achsenabschnitt", 
   "slope": "steigung", 
   "steyx": "stfehleryx", 
   "mina": "mina", 
   "minifs": "minwenns", 
   "maxa": "maxa", 
   "maxifs": "maxwenns", 
   "large": "kgrösste", 
   "small": "kkleinste", 
   "bin2dec": "binindez", 
   "bin2oct": "bininokt", 
   "bin2hex": "bininhex", 
   "oct2bin": "oktinbin", 
   "oct2dec": "oktindez", 
   "oct2hex": "oktinhex", 
   "dec2bin": "dezinbin", 
   "dec2oct": "dezinokt", 
   "dec2hex": "dezinhex", 
   "hex2bin": "hexinbin", 
   "hex2oct": "hexinokt", 
   "hex2dec": "hexindez", 
   "bitand": "bitund", 
   "bitor": "bitoder", 
   "bitxor": "bitxoder", 
   "bitlshift": "bitlverschieb", 
   "bitrshift": "bitrverschieb", 
   "delta": "delta", 
   "gestep": "gganzzahl", 
   "subtotal": "teilergebnis", 
   "aggregate": "aggregat"  
    }, 



// Names of constants in editable formulas, in format JavaScriptName="LocalizedName". Since 12.0 

"FormulaConstants" : { 

   "Math.PI": "pi", 
   "Math.LN10": "ln10", 
   "Math.LN2": "ln2", 
   "Math.LOG10E": "log10e", 
   "Math.LOG2E": "log2e", 
   "Math.SQRT2": "Wurzel2", 
   "Math.SQRT1_2": "Wurzel1_2", 
   "null": "null", 
   "false": "wahr", 
   "true": "falsch"  
    }, 



// Names of operators in editable formulas, in format TreeGridName="LocalizedName". The operator count and names (TreeGridName) cannot be changed. Since 12.0 

"FormulaOperators" : { 

   "Left": "(", 
   "Right": ")", 
   "Plus": "+", 
   "Minus": "-", 
   "Multiply": "*", 
   "Divide": "/", 
   "Modulo": "", 
   "Equal": "= ==", 
   "Inequal": "<> !=", 
   "Greater": ">", 
   "Less": "<", 
   "GreaterEqual": ">=", 
   "LessEqual": "<=", 
   "Not": "", 
   "And": "&&", 
   "Or": "||", 
   "BitNot": "~", 
   "BitAnd": "", 
   "BitOr": "|", 
   "BitXor": "", 
   "BitLeft": "<<", 
   "BitRight": ">>", 
   "If": "?", "Else": ":", 
   "Quote": "\" '", 
   "Chars": "()+-*/%=!<>~&|^?:", 
"V13_0": "", 
   "Concat": "&", 
   "Power": "^", 
   "External": "!", 
   "Percent": "%"  
    }, 



// Language dependent formatting dates and numbers 
      
"Format" : { 
         
   "LongDayNames": "Sonntag,Montag,Dienstag,Mittwoch,Donnerstag,Freitag,Samstag", 
   "ShortDayNames": "Son,Mon,Die,Mit,Don,Frei,Sam", 
   "Day2CharNames": "So,Mo,Di,Mi,Do,Fr,Sa", 
   "Day1CharNames": "S,M,D,M,D,F,S", 
   "LongMonthNames": "Januar,Februar,März,April,Mai,Juni,Juli,August,September,Oktober,November,Dezember", 
   "LongMonthNames2": "Januar,Februar,März,April,Mai,Juni,Juli,August,September,Oktober,November,Dezember", 
   "ShortMonthNames": "Jan,Feb,Mär,Apr,Mai,Jun,Jul,Aug,Sep,Okt,Nov,Dez", 
   "InputMonthNames": "", 
   "DayNumbers": "1.,2.,3.,4.,5.,6.,7.,8.,9.,10.,11.,12.,13.,14.,15.,16.,17.,18.,19.,20.,21.,22.,23.,24.,25.,26.,27.,28.,29.,30.,31.", 
   "Quarters": "I,II,III,IV", 
   "Halves": "I,II", 
   "DateSeparator": ".", 
   "InputDateSeparators": "/.-", 
   "TimeSeparator": ":", 
   "InputTimeSeparators": ":", 
   "InputDateTimeSeparators": "", 
   "AMDesignator": "vorm.", 
   "PMDesignator": "nachm.", 
   "InputAMPMDesignators": "", 
   "FirstWeekDay": "1", 
   "FirstWeekYearDay": "3", 
   "NaD": "Fehler!", 
   "Hirji": "0", 

   "sd": "dd/MM", 
   "sy": "dd/MM/yyyy", 
   "sw": "ddd dd/MM/yyyy", 
   "sm": "MM/yyyy", 
   "sn": "\\Wddddddd", 
   "ld": "dddddd MMMM", 
   "ly": "dddddd MMMM yyyy", 
   "lw": "dddd, dddddd MMMM yyyy", 
   "lwa": "ddd d MMMM yyyy", 
   "lm": "MMMMMMM yyyy", 
   "ln": "ddddddd. 'Woche'", 
   "ad": "d MMM", 
   "ay": "d MMM yyyy", 
   "aw": "ddd d MMM yyyy", 
   "awl": "dddd, d MMM yyyy", 
   "am": "MMM yyyy", 
   "an": "ddddddd. 'Wo.'", 
   "th": "HH", 
   "tm": "HH:mm", 
   "ts": "HH:mm:ss", 
   "tf": "HH:mm:ss.fff", 
   "sth": " HH", 
   "stm": " HH:mm", 
   "sts": " HH:mm:ss", 
   "stf": " HH:mm:ss.fff", 
   "lth": ", HH", 
   "ltm": ", HH:mm", 
   "lts": ", HH:mm:ss", 
   "ltf": ", HH:mm:ss.fff", 
   "yq": "MMMMM yyyy", 
   "yh": "MMMMMM yyyy", 

   "m": "dd/MM", 
   "d": "dd/MM/yyyy", 
   "h": "dd/MM/yyyy HH:mm", 
   "H": "dd/MM/yyyy HH:mm:ss", 
   "j": "dd/MM/yyyy h:mm tt", 
   "J": "dd/MM/yyyy h:mm:ss tt", 
   "y": "MM/yyyy", 
   "M": "dddddd MMMM", 
   "D": "dddddd MMMM yyyy", 
   "l": "dddddd MMMM yyyy HH:mm", 
   "L": "dddddd MMMM yyyy HH:mm:ss", 
   "k": "dddddd MMMM yyyy h:mm tt", 
   "K": "dddddd MMMM yyyy h:mm:ss tt", 
   "Y": "MMMMMMM yyyy", 
   "t": "HH:mm", 
   "T": "HH:mm:ss", 
   "i": "h:mm tt", 
   "I": "h:mm:ss tt", 

   "f": "dddddd MMMM yyyy HH:mm", 
   "F": "dddddd MMMM yyyy HH:mm:ss", 
   "g": "dd/MM/yyyy HH:mm", 
   "G": "dd/MM/yyyy HH:mm:ss", 
   "s": "yyyy-MM-ddTHH:mm:ss", 
   "u": "yyyy-MM-dd HH:mm:ssZ", 
   "U": "d. MMMM yyyy HH:mm:ss", 
   "r": "ddd MMM d HH:mm:ss UTCzzzzz yyyy", 
   "R": "ddd MMM d HH:mm:ss UTCzzzzz yyyy", 
   "a": "dddd, dddddd MMMM yyyy", 

   "CalendarMonth": "MMMMMMM yyyy", 

   "ValueSeparator": ";", "ValueSeparatorHtml": "; ", 
   "RangeSeparator": "~", "RangeSeparatorHtml": " ~ ", 
   "RepeatSeparator": "#", 
   "CountSeparator": "*", 
   "AddSeparator": "+", 
      
   "DecimalSeparator": ",", 
   "InputDecimalSeparators": ".,", 
   "GroupSeparator": ".", 
   "GroupCount1": "3", 
   "GroupCount": "3", 
   "InputGroupSeparators": "", 
   "Percent": "%", 
   "NaN": "Fehler!", 
   "Currency": " \u20AC ", 
   "Digits": "", 
   "FractionSeparator": "/", 

   "ng": "0.####", 
   "nf": "0.00", 
   "nc": ",###########0.00$;-,###########0.00$", 
   "ncm": ",###########0.00$;-,###########0.00$", 
   "ncmr": ",###########0.00$;[red]-,###########0.00$", 
   "ncp": ",###########0.00$;(,###########0.00$)", 
   "ncpr": ",###########0.00$;[red](,###########0.00$)", 
   "np": ",0.00%", 
   "nr": "0.0000", 
   "ne": "0.000000 E+000", 
	
   "Cont": "...", 
   "ContLeft": "... ", 
   "ContRight": " ...", 
   
   "PivotSeparators": "|,|:|<b>,</b> | <em><b>+</b></em> | <em><b>=</b></em> ", 

   "FormulaPrefix": "=", 
   "FormulaRangeSeparator": ":", 
   "FormulaValueSeparator": ",", 
   "FormulaIntersectionSeparator": " ", 
   "FormulaAbsolute": "$", 
   "NaR": "#FalscherBezug!", 
   "TextPrefix": "'"  
    }  

},  // End of root tag Lang 
   
   
   
// Toolbar button tooltips, HTML 
   
"Toolbar" : { 
   "SaveButtonText": "Sichern", "SaveTip": "Änderungen zum Server senden", 
   "ReloadButtonText": "Neu laden", "ReloadTip": "Grid neu laden, Änderungen verwerfen", 
   "RepaintButtonText": "Seiten", "RepaintTip": "Alle Seiten rendern", "RepaintTip1": "Seiten bei Bedarf rendern", 
   "PrintButtonText": "Drucken", "PrintTip": "Grid drucken", 
   "ExportPDFButtonText": "PDF", "ExportPDFTip": "Grid nach Adobe PDF exportieren", 
   "ExportButtonText": "Export", "ExportTip": "Grid-Daten in Tabellenkalkulation exportieren", 
   "ImportButtonText": "Import", "ImportTip": "Lokale MS-Excel-Datei (xlsx oder csv) in Grid importieren", 
   "UndoButtonText": "Rückgängig", "UndoTip": "Letzte Aktion zurücknehmen", 
   "RedoButtonText": "Wiederholen", "RedoTip": "Letzte Aktion wiederholen", 
   "AddButtonText": "Hinzufügen", "AddTip": "Neue Zeile hinzufügen oder ausgewählte Zeilen kopieren/verschieben", 
   "AddChildButtonText": "Hinzufügen zu", "AddChildTip": "Neue untergeordnete Zeile oder ausgewählte Zeilen zu aktueller Position kopieren/verschieben", 
   "AddColButtonText": "Spalte hinzufügen", "AddColTip": "Neue Spalte hinzufügen oder ausgewählte Spalte kopieren oder verschieben", 
   "JoinButtonText": "Verbinden", "JoinTip": "Ausgewählte Zellen verbinden", 
   "SplitButtonText": "Trennen", "SplitTip": "Verbundene Zellen trennen", 
   "OutdentButtonText": "Ebene höher", "OutdentTip": "Fokussierte Zeile eine Ebene nach oben verschieben", 
   "IndentButtonText": "Ebene tiefer", "IndentTip": "Fokussierte Zeile eine Ebene nach unten verschieben", 
   "LeftButtonText": "Links", "LeftTip": "Zellinhalt linksbündig ausrichten", 
   "CenterButtonText": "Zentriert", "CenterTip": "Zellinhalt horizontal zentriert ausrichten", 
   "RightButtonText": "Rechts", "RightTip": "Zellinhalt rechtsbündig ausrichten", 
   "TextIndentText": "Einrücken", "TextIndentTip": "Zellwert einrücken", 
   "TopButtonText": "Oben", "TopTip": "Zellinhalt oben ausrichten", 
   "MiddleButtonText": "Mitte", "MiddleTip": "Zellinhalt vertikal zentriert ausrichten", 
   "BottomButtonText": "Unten", "BottomTip": "Zellinhalt unten ausrichten", 
   "BoldButtonText": "Fett", "BoldTip": "Schrift fett", 
   "ItalicButtonText": "Kursiv", "ItalicTip": "Schrift kursiv", 
   "UnderlineButtonText": "Unterstrichen", "UnderlineTip": "Text unterstrichen", 
   "StrikeButtonText": "Durchgestrichen", "StrikeTip": "Text durchgestrichen", 
   "RotateLeftButtonText": "Drehung 270", "RotateLeftTip": "Zellinhalt um 90 Grad gegen den Uhrzeigersinn drehen", 
   "NoRotateButtonText": "Keine Drehung", "NoRotateTip": "Zelleninhalt nicht drehen", 
   "RotateRightButtonText": "Drehung 90", "RotateRightTip": "Zellinhalt um 90 Grad im Uhrzeigersinn drehen", 
   "WrapTextButtonText": "Zeilenumbruch", "WrapTextTip": "Automatischer Zeilenumbruch", 
   "SetLinkButtonText": "Link setzen", "SetLinkTip": "Hinzufügen oder Löschen eines Hyperlinks in der Zelle oder für ausgewählten Text in der Zelle", 
   "AddImageButtonText": "Bild einfügen", "AddImageTip": "Bild aus lokaler Datei in die Zelle einfügen", 
   "ClearStyleButtonText": "Style löschen", "ClearStyleTip": "Löscht alle Stileinstellungen", 
   "SizeTip": "Schriftgröße auswählen", 
   "BorderButtonText": "Rahmen", "BorderTip": "Rahmen anpassen", 
   "ColorTextButtonText": "Schriftfarbe", "ColorTextTip": "Schriftfarbe auswählen", 
   "ColorShadowButtonText": "Schatten", "ColorShadowTip": "Schattenfarbe auswählen", 
   "ColorBackgroundButtonText": "Füllung", "ColorBackgroundTip": "Füllfarbe auswählen", 
   "TextFormatTip": "*Value*<br>Zellformat auswählen", 

   "SortButtonText": "Sortierung", "SortTip": "Sortierung aktivieren und Grid jetzt neu sortieren", "SortTip1": "Sortierung deaktivieren um Sortierkriterien schneller ändern zu können", 
   "CalcButtonText": "Berechnung", "CalcTip": "Berechnung aktivieren und Grid jetzt neu berechnen", "CalcTip1": "Berechnung deaktivieren um Zellwerte schneller zu editieren", 
   "WinScrollButtonText": "Fenster scrollen", "WinScrollTip": "Scrollbalken des Grids deaktivieren und die der Webseite verwenden", "WinScrollTip1": "Scrollbalken des Grids aktivieren", 
   "ExpandAllButtonText": "Alle aufklappen", "ExpandAllTip": "Alle Zeilen aufklappen", 
   "CollapseAllButtonText": "Alle einklappen", "CollapseAllTip": "Alle Zeilen einklappen", 
   "ColumnsButtonText": "Spalten", "ColumnsTip": "Menü zur Auswahl der sichtbaren Spalten anzeigen", 
   "CfgButtonText": "Konfig", "CfgTip": "Nutzereinstellungen TreeGrid", 
   "LockButtonText": "Sperren", "LockTip": "Grid ist vollständig entsperrt und kann bearbeitet werden", 
   "LockTip1": "Gridstruktur ist gesperrt, Zellen sind entsperrt", 
   "LockTip2": "Gridstruktur, Zellstile und Formeln sind gesperrt, Zellwerte sind entsperrt", 
   "LockTip3": "Grid ist vollständig gesperrt und schreibgeschützt", 
   "HelpButtonText": "Hilfe", "HelpTip": "TreeGrid-Hilfe anzeigen", 
   "DebugButtonText": "Debugging", "DebugTip": "Zeige Debugging-Fenster", 
   "ResizeTip": "Größe des Grids anpassen", 

   "CorrectButtonText": "Korrigieren", "CorrectTipFormula": "ganttdependencyerrors(null,1)", 
   "ZoomInButtonText": "Zoom +", "ZoomInTip": "Hereinzoomen", 
   "ZoomOutButtonText": "Zoom -", "ZoomOutTip": "Herauszoomen", 
   "ZoomFitButtonText": "Zoom 0", "ZoomFitTip": "Passend auf Seite zoomen", 

   "LanguagesLabel": "<s>Sprache:</s>", 
   "StylesLabel": "<s>Style:</s>", 
   "GanttStylesLabel": "<s>Gantt:</s>", 
   "SizesLabel": "<s>Größe:</s>", 
   "ScalesLabel": "<s>Skalierung:</s>", 
   "ContrastsLabel": "<s>Kontrast:</s>"  
    }, 

// Row displayed when no variable rows are visible 
// To hide it define Html=""    
"Solid" : [ { "id": "NoData", "Html": "Keine Daten"   }  ],    
   
// Right side pager caption 
"Pager" : { "Caption": "Pager"   },    
   
// Left side panel button tooltips, HTML 
"Panel" : { 
   "PanelMoveTip": "Zeile verschieben", 
   "PanelSelectTip": "Zeile auswählen", 
   "PanelDeleteTip": "Zeile löschen", 
   "PanelCopyTip": "Zeile kopieren", 
   "MenuName": "Zeilenpanel"  
    }, 
   
"Header" : { 
   "PanelPanelSelectAllTip": "Alle Zeilen auswählen bzw. Auswahl aufheben", 
   "PanelPanelDeleteAllTip": "Alle ausgewählten Zeilen löschen", 
   "PanelPanelCopyAllTip": "Neue Zeile hinzufügen oder ausgewählte Zeilen verschieben oder kopieren"  
    }, 

"Def" : [ 
   { "Name": "Panel", "MenuName": "Spaltenpanel", 
      "PanelColSelectTip": "Spalte auswählen", 
      "PanelColDeleteTip": "Spalte löschen", 
      "PanelColCopyTip": "Spalte kopieren", 
      "PanelColSelectAllTip": "Alle Spalten auswählen bzw. nicht auswählen", 
      "PanelColDeleteAllTip": "Alle ausgewählten Spalten löschen", 
      "PanelColCopyAllTip": "Neue Spalte hinzufügen oder ausgewählte Spalten verschieben oder kopieren"  
       }  
], 



// Other text translations, translate texts in !...! only 

"TextDE" : [ 
   { "Action":"Change", "Space": "1", "Col": "Styles,GanttStyles,StylesMenu,GanttStylesMenu", "Standard": "Standard", "White": "Weiß", "Black": "Schwarz", "Material": "Material", "Turq": "Türkis", 
      "Relief": "Relief", "Light": "Light", "Office": "Office", "Gradient": "Gradient", "Borders": "Borders", "Query": "Query", "ExtJS": "ExtJS", "Sharp": "Sharp", "Round": "Round", "Plain": "Plain", "Colors": "Colors"   }, 
   { "Action":"Set", "Row": "Toolbar", "StylesStandard": "Standard", "StylesWhite": "Weiß", "StylesBlack": "Schwarz", "StylesMaterial": "Material", "StylesTurq": "Türkis", "StylesRelief": "Relief", "StylesLight": "Light", 
      "StylesOffice": "Office", "StylesGradient": "Gradient", "StylesBorders": "Borders", "StylesQuery": "Query", "StylesExtJS": "ExtJS", "StylesSharp": "Sharp", "StylesRound": "Round", "StylesPlain": "Plain", "StylesColors": "Colors"   }, 
   { "Action":"Change", "Space": "1", "Col": "Sizes,SizesMenu", "Tiny": "Winzig", "Mini": "Mini", "Small": "Klein", "Low": "Niedrig", "Normal": "Normal", "Wide": "Breit", "High": "Hoch", "Big": "Groß", "Giant": "Riesig"   }, 
   { "Action":"Set", "Row": "Toolbar", "SizesTiny": "Winzig", "SizesMini": "Mini", "SizesSmall": "Klein", "SizesLow": "Niedrig", "SizesNormal": "Normal", "SizesWide": "Breit", "SizesHigh": "Hoch", "SizesBig": "Groß", "SizesGiant": "Riesig"   }, 
   { "Action":"Change", "Space": "1", "Col": "Contrasts,ContrastsMenu", "Bright": "Grelle", "Vivid": "Hell", "Default": "Default", "Soft": "Sanft", "Dim": "Dunkel"   }, 
   { "Action":"Set", "Row": "Toolbar", "ContrastsBright": "Grelle", "ContrastsVivid": "Hell", "ContrastsDefault": "Default", "ContrastsSoft": "Sanft", "ContrastsDim": "Dunkel"   }, 
   { "Action":"Change", "Space": "1", "Col": "Size", "N": "<span style='font-size:9px;color:silver;'>size</span>", "V": "<span style='font-size:8px;color:silver;'>Schriftgrößelt;/span>"   }, 
   { "Action":"Change", "Space": "1", "Col": "TextIndent", "N": "<span style='font-size:9px;color:silver;'>indent</span>", "V": "<span style='font-size:8px;color:silver;'>einrücken</span>"   }, 
   { "Action":"Replace", "Space": "1", "Col": "TextFormat", "general": "Standard", "text": "Text", "integer": "Ganze Zahl", "percent": "Prozent", "December": "Dezember", "pm": "nachm.", "format": "Format", "Items": [
      { "N": "12th", "V": "12."   }, 
      { "N": "percent int", "V": "Prozent (ganzzahlig)"   }  
   ]}, 
   { "Action":"Change", "Space": "1", "Col": "FormatMenu,TextFormatMenu", "Col1": "Menu", "Count": "2", "Items": [
      { "N": "General number or text", "V": "Standard (Zahl oder Text)"   }, 
      { "N": "Enter custom format ...", "V": "Benutzerdefiniertes Format eingeben..."   }, 
      { "N": "Custom formats", "V": "Benutzerdefinierte Formate"   }, 
      { "N": "Remove unused formats", "V": "Nicht verwendete Formate löschen"   }, 
      { "N": "Not formatted text", "V": "Unformatierter Text"   }, 
      { "N": "Boolean true / false", "V": "Boolean wahr / falsch"   }, 
      { "N": "Integer number", "V": "Ganze Zahl"   }, 
      { "N": "Next float numbers", "V": "Weitere Dezimalzahlen"   }, 
      { "N": "Next date times", "V": "Weitere Datum/Zeit-Formate"   }  
   ]}, 
   { "Action":"Replace", "Space": "1", "Col": "FormatMenu,TextFormatMenu,TextFormat", "Col1": "Menu", "Count": "2", "Items": [
      { "N": "Float number", "V": "Dezimalzahl"   }, 
      { "N": "Currency number", "V": "Währungsbetrag"   }, 
      { "N": "Float percent number", "V": "Prozent (dezimal)"   }, 
      { "N": "Integer percent number", "V": "Prozent (ganzzahlig)"   }, 
      { "N": "Short full date", "V": "Datum kurz (vollständig)"   }, 
      { "N": "Short partial date", "V": "Datum kurz (partiell)"   }, 
      { "N": "Short month and year", "V": "Monat und Jahr (kurz)"   }, 
      { "N": "Long full date", "V": "Datum lang (vollständig)"   }, 
      { "N": "Long partial date", "V": "Datum lang (partiell)"   }, 
      { "N": "Long month and year", "V": "Monat und Jahr lang"   }, 
      { "N": "Short date and long time am/pm", "V": "Datum kurz und Uhrzeit lang (12h)"   }, 
      { "N": "Short date and long time", "V": "Datum kurz und Uhrzeit lang"   }, 
      { "N": "Short date and time am/pm", "V": "Datum kurz und Uhrzeit kurz (12h)"   }, 
      { "N": "Short date and time", "V": "Datum kurz und Uhrzeit kurz"   }, 
      { "N": "Long date and time am/pm", "V": "Datum lang und Uhrzeit kurz (12h)"   }, 
      { "N": "Long date and time", "V": "Datum lang und Uhrzeit kurz"   }, 
      { "N": "Long date and long time am/pm", "V": "Datum lang und Uhrzeit lang (12h)"   }, 
      { "N": "Long date and long time", "V": "Datum lang und Uhrzeit lang"   }, 
      { "N": "Long time am/pm", "V": "Uhrzeit lang (12h)"   }, 
      { "N": "Short time am/pm", "V": "Uhrzeit kurz (12h)"   }, 
      { "N": "Long time", "V": "Uhrzeit lang"   }, 
      { "N": "Short time", "V": "Uhrzeit kurz"   }, 
      { "N": "1234.5", "V": "1234,5"   }, 
      { "N": "1,234.5", "V": "1 234,5"   }, 
      { "N": "$1,234.50", "V": "1 234,50 \u20AC"   }, 
      { "N": "12/31/2000", "V": "31.12.2000"   }, 
      { "N": "12/31", "V": "31.12"   }, 
      { "N": "12th December", "V": "12. Dezember"   }, 
      { "N": "December", "V": "Dezember"   }, 
      { "N": "pm", "V": " nachm."   }  
   ]}, 
   { "Action":"Last", "Space": "1", "Col": "ColorTextMenu,ColorShadowMenu,ColorBackgroundMenu,BorderMenu", "Col1": "Menu", "Count": "2", 
      "none": "keine", "black": "schwarz", "red": "rot", "green": "grün", "blue": "blau", "brown": "braun", "maroon": "rotbraun", "gray": "grau", 
      "yellow": "gelb", "lime": "hellgrün", "aqua": "aqua", "pink": "pink", "orange": "orange", "silver": "silber"   }, 
   { "Action":"Replace", "Col": "Menu", "default": "standard"   }  
], 

}) /* End of JSONP header */ 