﻿// French translation of TreeGrid texts 

TreeGridLoaded ({ /* JSONP header, to be possible to load from xxx_Jsonp data source */ 
   "Cfg" : { "TextVersion": "150001"   }, 

/* 
In Alert section place CR/LF as "&#x0a;"
In HTML sections place CR/LF as "&lt;br>"
In HTML sections use HTML tags &lt;em> (error - red), &lt;s> (disabled - gray), &lt;i> (highlight - blue), &lt;b> (strong highlight - blue+bold)
Some texts can place dynamic information, e.g. count or id; some text replace "%d", some other texts replace %1, %2, ... 
*/


"Lang" : { 
      
// All alert / confirm non HTML texts 
      
"Alert" : { 
         
"V3_1": "", 
   "CanReloadStart": "Cette commande ", 
   "CanReloadChanges": "reportés toutes les modifications au serveur", 
   "CanCancelChanges": "annulé toutes les modifications", 
   "And": " et ", 
   "CanReloadSelect": "efface toutes les sélections", 
   "CanReloadEnd": "! Voulez-vous continuer?", 
"V3_2": "", 
   "ErrTimeout": "Vous ne pouvez pas télécharger des données, le délai a expiré", 
   "AskTimeout": "Vous ne pouvez pas télécharger des données, délai du serveur a expiré!\u000AVoulez-vous répéter la demande?", 
   "UploadTimeout": "Vous ne pouvez pas télécharger des données, le délai a expiré", 
   "AskUploadTimeout": "Vous ne pouvez pas télécharger des données, délai du serveur a expiré!\u000AVoulez-vous envoyer des données à nouveau?", 
"V3_5": "", 
   "ErrHide": "Vous ne pouvez pas cacher toutes les colonnes variables!", 
   "ErrHideExt": "Largeur de toutes les colonnes fixes est trop large!", 
"V4_2": "", 
   "ErrPrintOpen": "La fenêtre d'impression ne peut pas être ouvert \u000A\u000Apermis fenêtres pop-up pour laisser imprimer la grille", 
   "ErrPrint": "Le document n'a pas été imprimé avec succès", 
"V4_4_3": "", 
   "ErrCheck": "Synchroniser avec le serveur a échoué!\u000AVoulez-vous désactiver temporairement la vérification des mises à jour?", 
"V4_7": "", 
   "SearchHelp": "Entrez la chaîne à rechercher comme dans Google\u000A\u000Aindividuels mots-clés séparer par espace\u000A des phrases placer entre guillemets\u000Avariantes séparées par des majuscules ou mot-clé\u000Aprécédé par \"-\" (moins)\u000A\u000AOu entrez l'expression à rechercher par\u000A\u000Aspécifier des entêtes des colonnes pour comparer\u000A utiliser les opérateurs < <= > >= = <> () + - * /\u000A utiliser les ET OU mots-clés pour joindre les expressions \u000Autiliser des mots-clés spéciaux COMMENCE ENDS CONTIENT\u000A pour comparer les chaînes (NON pour inverser)\u000A exemple: client commence martin et date <= 1/1/2006", 
   "NotFound": "Rien n'a été trouvé", 
   "SearchStart": "Rien n'a été trouvé\u000AVoulez-vous continuer?", 
   "SearchError": "L'expression de recherche est invalide!", 
"V5_3": "", 
   "Invalid": "Valeur incorrecte.", 
"V6_0": "", 
   "DelRow": "Êtes-vous sûr de supprimer la ligne '%d'?", 
   "DelSelected": "Êtes-vous sûr de vouloir supprimer %d lignes?", 
   "StyleErr": "Vous ne pouvez pas charger TreeGrid style CSS!", 
   "ExportDownload": "Télécharger", 
"V7_0": "", 
   "FoundResults": "Trouvées %d résultats", 
   "PrintPrepared": "Grille est prête à imprimer", 
"V7_1": "", 
   "PrintReady": "Grille est prête à imprimer\u000A Choisissez Aperçu avant impression option dans le menu pour mettre à jour la taille de page\u000AOu choisissez l'option d'impression ou appuyez sur Ctrl + P pour imprimer directement", 
   "PrintCloseWindow": "\u000AAprès impression est terminée, vous pouvez fermer cette page", 
   "PrintCloseTag": "\u000AAprès l'impression terminée, vous pouvez cliquer sur la grille pour revenir", 
"V9_2": "", 
   "PivotReload": "Voulez-vous recréer la grille de pivot?", 
"V12_0": "", 
   "FormulaCircularAsk": "La formule contient une référence de cellule circulaire \u000AVoulez-vous le permettre?", 
   "DelCol": "Etes-vous sûr de supprimer la colonne '%d'?", 
   "DelSelectedCols": "Êtes-vous sûr de vouloir supprimer %d colonnes?", 
   "SearchEnd": "Rien n'a été trouvé\u000AVoulez-vous continuer?", 
"V12_1": "", 
   "ExportIE": "Non disponible dans IE 9 et plus vieux", 
   "ExportError": "Export a échoué!", 
"V13_0": "", 
   "DefaultSheet": "Feuille", 
   "NewSheet": "Feuille%1", 
   "LoadSheetErrorMissingModule": "Le chargement des données a échoué en raison du module TreeGrid manquant%1", 
   "StripHtml": "Le changement supprimera la mise en forme du texte!\u000A Voulez-vous enregistrer le changement?", 
"V14_0": "", 
   "DownloadSync": "Cette action nécessite de télécharger toutes les données sur le client.\u000ACela peut prendre plus de temps!\u000AVoulez-vous poursuivre?", 
"V15_0": "", 
   "ImgData": "image", 
   "ImgWidth": "L", 
   "ImgHeight": "H", 
   "ImgX": "X", 
   "ImgY": "Y", 
   "ImgUrl": "URL", 
   "ImgSrc": "SRC", 
   "LinkUrl": "URL", 
   "LinkText": "TEXTE", 
   "ReplaceDefinedName": "Le nom '%1' existe déjà avec la valeur '%2'\u000AVoulez-vous le remplacer?", 
   "DeleteDefinedName": "Voulez-vous supprimer le nom '%1' avec la valeur '%2'?"  
    }, 
    
    
    
// All message HTML texts     

"Text" : { 
      
"V2_0": "", 
   "DelSelected": "Suppression de lignes", 
   "ExtentErr": "Trop petite taille de la grille", 
   "Sort": "Tri des lignes ...", 
   "SelectAll": "Modification de la sélection de toutes les lignes", 
   "DoFilter": "Filtrage des lignes ...", 
"V2_3": "", 
   "UpdateGrid": "Mise à jour de vue ...", 
   "CollapseAll": "Fermés toutes les lignes ...", 
   "ExpandAll": "Élargir toutes les lignes ...", 
"V2_6": "", 
   "Render": "Génération en cours ...", 
   "Page": "PAGE", 
   "NoPages": "Vide", 
   "UpdateCfg": "Mise à jour des paramètres ...", 
   "StartErr": "Erreur fatale! <br/>TreeGrid ne peut pas générer", 
"V3_0": "", 
   "Calculate": "Calcul des cellules ...", 
   "UpdateValues": "Mise à jour des valeurs ...", 
   "UpdateTree": "Mise à jour de l'arbre ...", 
"V3_1": "", 
   "PageErr": "Vous ne pouvez pas télécharger cette partie de données!", 
"V3_2": "", 
   "Layout": "Chargement disposition ...", 
   "Load": "Chargement des données ...", 
"V3_5": "", 
   "ColumnsCaption": "Sélectionnez les colonnes à afficher", 
   "ColUpdate": "Mise à jour des colonnes ...", 
"V4_3": "", 
   "Picture": "Image", 	
   "DefaultsDate": "Sélectionner une date ...", 
   "DefaultsButton": "Sélectionnez ...", 
"V4_5": "", 
   "GroupCustom": "Pour grouper, sélectionnez colonne libellé ici ...", 
   "Group": "Groupés les lignes ...", 
   "DefaultsFilterOff": "(Tous)", 
   "Items": "Items %d - %d", 
   "Print": "<h2><center> S'il vous plaît patienter pendant que générer le rapport pour l'impression ... <center><h2>", 
"V4_7": "", 
   "SearchMethodList": "|Automatique|Recherche&#160;comme&#160;Google|Recherche&#160;par&#160; expression", 
   "Contains": "contient,a", 
   "Starts": "commence,commence par,commence par,commence,commence par,commence par", 
   "Ends": "finit,finit par,finit avec", 
   "And": "et", 
   "Or": "ou", 
   "Not": "ne pas", 
   "SearchSearch": "Rechercher", 
   "SearchFilter": "Filtre", 
   "SearchSelect": "Sélectionner", 
   "SearchMark": "Marquer", 
   "SearchFind": "Trouver", 
   "SearchClear": "Vider", 
   "SearchHelp": "Aide", 
   "Search": "Recherche ...", 
"V5_0_1": "", 
   "Printed": "S'il vous plaît passer à la fenêtre contenant le rapport pour l'imprimer", 
"V5_6": "", 
   "DoUndo": "Exécution d'annuler ...", 
   "DoRedo": "Exécution refaire ...", 
"V5_9": "", 
   "GanttUpdate": "Mise à jour de Gantt ...", 
"V6_0": "", 
   "GanttCreate": "Création de Gantt ...", 
   "LoadStyles": "Chargement de style ...", 
   "SetStyle": "Mise à jour de style ...", 
   "LoadPage": "Chargement", 
   "RenderPage": "Génération en cours", 
   "ColWidth": "Changer la largeur de colonnes '%d'", 
   "ColMove": "Déplacement colonne '%d'", 
   "Password": "***", 
   "DefaultsNone": "Tout effacer", 
   "RadioFilterOff": "<i>Inactif</i>", 
   "DragObjectMove": "rangée mobile <b>%d</b>", 
   "DragObjectCopy": "copier la ligne <b>%d</b>", 
   "DragObjectMoreMove": "déplacer <b'>%d</b> lignes", 
   "DragObjectMoreCopy": "copier <b>%d</b> lignes", 
   "ExportFinished": "< center><b>Rapport généré< /b><br/><br/> Cliquez sur le bouton pour le téléchargement center><br/>", 
   "RenderProgressText": "Terminé %dpages sur %d", 
   "RenderProgressCancel": "Générer en arrière plan", 
   "PrintProgressCaption": "Rapport de Génération", 
   "PrintProgressText": "Terminé %d lignes sur %d", 
   "PrintProgressCancel": "Annuler le rapport", 
   "ExportProgressCaption": "Rapport de Génération", 
   "ExportProgressText": "Terminé %d%", 
   "ExportProgressCancel": "Annuler le rapport", 
   "ExpandProgressCaption": "Élargir toutes les lignes", 
   "ExpandProgressText": "Terminé %d lignes sur %d", 
   "ExpandProgressCancel": "Arrêtez l'expansion", 
   "ExportCaption": "Sélectionnez les colonnes à exporter", 
   "PrintCaption": "Sélectionnez les colonnes à imprimer", 
   "DefaultsAll": "Sélectionner tout", 
"V6_1": "", 
   "DefaultsAlphabet": "%d ...", 
"V7_0": "", 
   "RemoveUnused": "Effacement de pages inutilisées", 
   "ErrorSave": "Enregistrement des modifications sur le serveur a échoué!", 
   "DatesRepeat": "Répétition", 
   "DatesStart": "Début", 
   "DatesEndTime": "Fin", 
   "DatesValue": "Valeur", 
   "DatesRepeatEnum": "||Hebdomadaire|Quotidien|Horaire", 
   "DatesRepeatKeys": "||w|d|h", 
   "RenderProgressCaptionRows": "Génération des lignes ...", 
   "RenderProgressCaptionCols": "Génération des colonnes ...", 
   "RenderProgressCaptionChildren": "Génération de l'arborescence", 
"V8_0": "", 
   "CalendarNone": "<s>Aucun</s>", 
   "CalendarEmpty": "<s>Par défaut</s>", 
   "CalendarEdit": "<i>Éditer ...</i>", 
"V9_2": "", 
   "ExpandCols": "Expansion des colonnes", 
   "CollapseCols": "Envelopper les colonnes", 
"V9_3": "", 
   "PagingUpdate": "Création des pages ...", 
   "CopySlow": "L'action de copie a pris trop longtemps (%d ms), s'il vous plaît appuyez à nouveau sur les touches Ctrl + C pour terminer l'opération", 
   "CopyOk": "L'action de copie terminé avec succès", 
"V10_0": "", 
   "LevelsTip": "Développer des lignes jusqu'au %d niveau", 
"V12_0": "", 
   "FileIE": "Non disponible dans IE <=9", 
   "Paste": "Coller des données de presse-papiers ...", 
   "FormulaError1": "La formule <b>%1</b> ne peut pas être analysé", 
   "FormulaError2": "Référence de cellule incorrecte dans la formule <b>%1</b>", 
   "FormulaError3": "Élément incorrect < b>%2</b>dans la formule <b>%1</b>", 
   "FormulaError4": "Mauvaise formule<b> %1</b> avec l'erreur <i>%2</i>", 
   "FormulaError5": "Formule ne peut être calculé avec l'erreur <i>%2</i>", 
   "FormulaError6": "Formule <b>%1</b> retourné <b>null</b> Résultat", 
   "FormulaError7": "Formule <b>%1</b> retourné <b>NaN</b> Résultat", 
   "NotInList": "La valeur <b>%1</b> non inclus dans the item liste", 
   "EmptyValue": "vide", 
   "CannotEdit": "Valeur non modifiable", 
   "NoStyle": "Style ne peut pas être modifié", 
   "NoFormat": "Format ne peut pas être modifié", 
   "NoNumber": "Valeur de la cellule est pas un nombre", 
   "EditMaskError": "La valeur <b> %1</b> contient des caractères restreints", 
   "FormulaRestrict": "Formule <b>%1</b> est limitée avec l'erreur <i>%2</i>", 
   "SizeChanged": "La valeur <b> %1</b> changé limite en raison de la taille", 
   "ResultText": "La valeur <b>%1</b> est invalide", 
   "EditErrorsMessage": "%1", 
   "EditChangesMessage": "%1", 
   "EditErrorsMessageCell": "%1 dans cellule <b>%2</b><br>", 
   "EditChangesMessageCell": "%1 dans cellule <b>%2</b><br>", 
   "EditErrorsMessageMore": "Il y a <b>%1</b> plus de problèmes ...", 
   "FormulaCircular": "La formule contient une référence de cellule circulaire", 
   "FormulaCircularAlert": "La formule contient une référence de cellule circulaire", 
   "ErrAdd": "Vous ne pouvez pas ajouter une nouvelle ligne au parent %1", 
   "ErrAddRoot": "Vous ne pouvez pas ajouter une nouvelle ligne à la racine", 
   "DelSelectedCols": "Suppression les colonnes", 
   "SearchFindPrev": "Précédent", 
   "NoMenu": "Aucune action disponible", 
   "SetStyleSame": "Aucune cellule a été changée", 
   "SetStyleError": "Aucune cellule a été modifiée en raison des restrictions d'édition", 
   "SetStyleErrors": "Il n'y a pas eu de changement au %1 cellules dues aux restrictions d'édition", 
"V13_0": "", 
   "PagerSep1": "\u00A0|\u00A0", 
   "PagerSep2": "\u00A0=>\u00A0", 
   "PagerSep3": ",\u00A0", 
   "PagerNone": "...", 
   "LoadSheet": "Lecture des feuilles ...", 
   "DiscardSheet": "Voulez-vous supprimer toutes vos données et charger les données du fichier <b>%1</b>?", 
   "AddSheet": "Voulez-vous ajouter les données du fichier <b>%1</b> aux données réelles?", 
   "OpenSheet": "Voulez-vous ajouter les données du fichier <b>%1</b> aux données réelles ou ignorer toutes vos données et charger les données du fichier <b>br><%1</b>?", 
   "LoadSheetError": "Le chargement des données de <b>%1</b> a échoué avec l'erreur <b>%2</b>", 
   "ParseSheetError": "L'analyse des données de <b>%1</b> a échoué", 
   "SheetsUnsupported": "L'ouverture de fichiers n'est pas supportée dans votre navigateur", 
   "DeleteSheet": "Voulez-vous supprimer la feuille <b>%1</b>?", 
   "DeleteTab": "Voulez-vous supprimer l'onglet <b>%1</b>?", 
   "OnlyXlsx": "Impossible d'ouvrir <b>%1</b>. Seuls les fichiers <b> xlsx</b> sont pris en charge", 
   "CompatibleStyles": "Compatible", 
   "ShrinkStyle": "Trop grand style, taille du style rétrécissement", 
   "SetSize": "Changer la taille du style", 
   "UniqueSheet": " (%1)", 
   "ShrinkSize": "Il n'y a pas assez d'espace pour afficher entièrement la grille<br>Voulez-vous réduire la taille du style de grille?", 
   "EnterFormat": "Entrez la chaîne de format comme dans MS Excel", 
   "FormulaError8": "Référence externe à la feuille inconnue <b>%2</b> dans la formule <b>%1</b>", 
   "FormulaError9": "Fonction non prise en charge <b>%2</b> dans la formule <b>%1</b>", 
   "FormulaError10": "Référence non prise en charge du fichier externe <b>%2</b> dans la formule <b>%1</b>", 
   "FormulaError11": "Formule de tableau non encore implémentée ou plage de cellules inattendue <b>%2</b> dans la formule <b>%1</b>", 
"V13_1": "", 
   "MoveRows": "Déplace %d lignes", 
"V13_3": "", 
   "NaNContinue": "La valeur entrée est incorrecte, veuillez la changer", 
   "NaNRejected": "La valeur incorrecte entrée a été ignorée", 
   "NaNAccepted": "La valeur incorrecte entrée a été modifiée", 
   "NaNAsk": "La valeur entrée est incorrecte, voulez-vous l'enregistrer quand même?", 
   "NaNAskReject": "La valeur entrée est incorrecte, voulez-vous la supprimer?", 
"V14_0": "", 
   "DownloadSyncComplete": "Téléchargement terminé!", 
   "PasteError": "La valeur <b>%1</b> ne peut pas être collée", 
   "PasteChanged": "La valeur <b>%1</b> a été changée en vide pour coller", 
"V15_0": "", 
   "EnterLink": "Entrez l'URL du lien hypertexte", 
   "ExternalFocus": "%1", 
   "ExternalFocusRect": "%1 => %2 : %3", 
   "ExternalFocusWait": "Chargement focus ...", 
   "EnterImageOpacity": "Entrez l'opacité de l'image (0 - transparent, 100 - opaque)", 
   "EnterImageName": "Entrez l'nom de l'image", 
   "SetContrast": "Changer la contraste du style ...", 
   "FormulaErrorTimeout": "<span style='color:red;'>Le délai de calcul a expiré! Toutes les formules n'ont pas été calculées!</span><br><br>", 
   "PageRows": "%1 - %2", 
   "FormulaError12": "Nom incorrect <b>%2</b> dans la formule <b>%1</b>", 
   "EnterDefinedName": "Entrez le nom de %1", 
   "EnterDefinedValue": "Entrez une valeur pour le nom %1", 
   "GlobalName": "%1", 
   "GlobalNameDup": "%1 (global)", 
   "LocalName": "%1", 
   "LocalNameDup": "%1 (local)"  
    }, 



// Gantt texts 

"Gantt" : { 

"V6_0": "", 
   "ErrGanttDep": "Impossible de connecter une dépendance ici", 
   "ErrGanttPercentEdit": "Entrée incorrecte, la valeur doit être dans la gamme 0 - 100", 
   "DelAllGanttDep": "Déconnectez toutes les dépendances", 
   "DelGanttMilestone": "Supprimer l'étape", 
   "EditGanttPercent": "Entrez le statut complété", 
   "DelGanttFlow": "Supprimer flux réel", 
   "DelGanttFlowPart": "Supprimer la barre de flux réel", 
   "DelGanttFlags": "Supprimer tous les drapeaux", 
   "DelGanttFlag": "Supprimer le drapeau", 
   "EditGanttFlag": "Entrez le texte du drapeau", 
   "DelGanttAll": "Effacer la cellule de Gantt", 
   "NewGanttFlag": "Ajouter un nouveau drapeau pour point sélectionné", 
   "EditGanttResource": "Change ressources", 
   "AssignGanttResource": "Ressources Assigné", 
   "CorrectAllDependencies": "Corriger toutes les dépendances de tableau", 
   "CorrectRelatedDependencies": "Corriger les dépendances incorrectes", 
   "CorrectDep": "Déplacement %d barres", 
   "GanttFlagEdit": "Entrez le texte pour le drapeau", 
   "GanttPercentEdit": "Entrez le nouveau statut complété en pour cent", 
   "GanttResourceEdit": "Enter the ressource texte", 
   "GanttDepLagEdit": "Entrez le décalage de la dépendance", 
"V6_1": "", 
   "GanttResizeDelete": "Êtes-vous sûr de vouloir supprimer l'article?", 
   "DelGanttRunPart": "Supprimez la boite", 
   "EditGanttRun": "Modifier la boîte de texte", 
   "EditGanttRunTip": "Modifiez la boîte d'information", 
   "GanttRunEdit": "Entrez la boîte de texte", 
   "GanttRunEditTip": "Entrez la boîte d'information", 
   "ChooseGanttFlagIcon": "Sélectionnez l'icône du drapeau", 
"V6_3": "", 
   "GanttCorrectDependencies": "Il y a aussi <b>%d</b> tâches dépendantes qui devraient être mis à jour. <br>Voulez-vous les déplacer?", 
   "GanttCorrectDependency": "Il y a aussi  tâches dépendantes qui devraient être mis à jour. Voulez-vous le déplacer?", 
   "GanttCorrectTask": "La tâche viole ses contraintes, voulez-vous déplacer?", 
   "GanttDeleteDependencies": "Il y a %d dépendances, voulez-vous les supprimer?", 
   "GanttCircularDependencies": "Cela causera une relation de dépendance circulaire. Voulez-vous le créer de toute façon?", 
   "GanttCircularDependenciesErr": "Il est impossible de créer relation de dépendance circulaire", 
   "ErrComplete": "Valeur modifiée doit être dans la plage 0 - 100", 
   "ErrDuration": "La valeur de la durée est incorrecte!", 
   "ErrEnd": "La date de fin ne peut pas être antérieure à la date de début.", 
   "ErrDependency": "La valeur de la dépendance est incorrecte!", 
   "ErrCorrect": "Il est impossible de corriger les dépendances!", 
   "ErrCorrectSome": "Pas toutes les dépendances peuvent être corrigées en raison des contraintes!", 
   "IncorrectDependencies": "<em><b>%d</b> dépendances incorrectes </em>", 
   "IncorrectDependency": "<em><b>1</b> dépendance incorrecte </em>", 
   "CorrectDependencies": "Toutes les dépendances sont correctes", 
   "DisabledDependencies": "<s> Vérification de la dépendance désactivée</s>", 
   "GanttCheckExclude": "L'objet débute sur des vacances, voulez-vous déplacer vers la droite?", 
   "GanttMinStart": "La tâche doit commencer après <b>%d</b>", 
   "GanttMaxStart": "La tâche doit commencer avant <b>%d</b>", 
   "GanttMinEnd": "La tâche doit finir après <b>%d</b>", 
   "GanttMaxEnd": "La tâche doit finir avant <b>%d</b>", 
   "DelGanttConstraint": "Détruire %d contraintes", 
   "DelGanttConstraints": "Détruire toutes les contraintes", 
   "ChangeGanttConstraint": "Réglez la contrainte a %d", 
   "NewGanttConstraint": "Ajouter %d contrainte ici", 
   "MinStart": "Début le plus tôt", 
   "MaxStart": "Début le plus tard", 
   "MinEnd": "Fin le plus tôt", 
   "MaxEnd": "Fin le plus tôt", 
   "ExactStart": "démarrage obligatoire", 
   "ExactEnd": "fin obligatoire", 
   "SplitGanttConstraint": "Diviser %d contrainte", 
   "GanttDepLagChangeEnd": "Changer le décalage de la ligne de <b>%d</b>", 
"V6_4": "", 
   "GanttExactStart": "La tâche doit commencer sur <b>%d</b>", 
   "GanttExactEnd": "La tâche doit finir sur <b>%d</b>", 
   "ExtraPrice": "supplément de prix", 
   "ExtraPrices": "Extra ressource unités", 
   "DelGanttPoint": "Détruire le point", 
   "DelGanttPoints": "Détruire tous les points", 
   "NewGanttPoint": "Ajouter un nouveau point au point sélectionné", 
"V6_5": "", 
   "ErrStart": "La date de début ne peut pas être supérieure à la date de fin!", 
"V6_6": "", 
   "GanttCheckExcludeBack": "L'objet finit sur des vacances, voulez-vous déplacer vers la droite?", 
   "DelGanttBase": "Détruire le début du projet", 
   "SetGanttBase": "Ajuster le début du projet ici", 
   "DelGanttFinish": "Détruire la fin du projet", 
   "SetGanttFinish": "Ajuster la fin du projet ici", 
   "NewGanttMilestone": "Ajouter un nouveau jalon ici", 
"V7_0": "", 
   "ErrDateLow": "La date ne peut pas être avant <em><b>%1</b></em> due <b> contrainte%2</b>", 
   "ErrDateHigh": "La date ne peut pas être après <em><b>%1</b></em>due <b>%2</b> contrainte", 
   "Baseline": "début du projet", 
   "Finishline": "fin du projet", 
   "ChartMinStart": "Date minimale du projet", 
   "ChartMaxEnd": "Date maximale projet", 
   "NewGanttEndMilestone": "Ajouter un nouveau jalon de fin ici", 
   "ErrCorrectDep": "Pas toutes les dépendances peuvent être corrigées en raison des contraintes!", 
   "DelGanttRunGroup": "Supprimer le groupe de la ligne (%d boîtes)", 
   "DelGanttRunGroupAll": "Supprimer le groupe (%d boîtes)", 
   "ValueChanged": "Valeur changé en raison des contraintes", 
   "ErrChangeValue": "Les données entrées sont incorrectes.", 
   "CompleteChanged": "Valeur modifiée doit être dans la plage 0 - 100", 
   "DurationChanged": "Valeur modifiée ne pas être négative", 
   "EditGanttRunText": "Entrez l'information de la tâche", 
   "SetGanttMilestoneIncomplete": "Mettre le cap incomplet", 
   "SetGanttMilestoneComplete": "Mettre le cap complet", 
   "ErrMoveChildren": "Vous ne pouvez pas déplacer la tâche en raison des contraintes enfants", 
   "MoveChildrenChanged": "Valeur changé en raison des contraintes enfants", 
   "NewGanttRunStop": "Ajout d'un nouvelle arrêt ici", 
   "GanttCorrectExclude": "L'objet débute ou finie sur des vacances, voulez-vous déplacer vers la droite?", 
"V9_2": "", 
   "SplitGanttFlow": "Diviser la barre d'écoulement réel", 
"V10_0": "", 
   "ZoomMain": "Zoom à la barre", 
   "ZoomRun": "Zoom à la boite", 
   "ZoomAll": "Zoom à tous les objets", 
   "SplitGanttRun": "Diviser la boîte", 
   "SplitGanttMain": "Diviser la barre", 
   "DelGanttMainPart": "Supprimez la barre", 
   "DelGanttMain": "Supprimer la tâche", 
   "DelGanttMainAll": "Supprimer toutes les tâches", 
   "DelGanttMainBar": "Supprimez la tâche", 
   "DelGanttRun": "Supprimer toutes les %d boîtes dans la ligne", 
   "SelectGanttRunPart": "Sélectionner la boite", 
   "UnselectGanttRunPart": "Décochez la case", 
   "SelectGanttRun": "Sélectionner toutes les boîtes", 
   "UnselectGanttRun": "Désélectionner tous les blocs", 
   "DelGanttRunSelected": "Supprimer les boîtes sélectionnées (%d boîtes)", 
   "Plan0": "0", 
   "GanttTextEdit": "Entrez l'information de la tâche", 
   "EditGanttText": "Entrez l'information de la tâche", 
   "GanttDepLagChange": "Modifier le décalage de dépendance", 
   "DelGanttDep": "Détruire la dépendance", 
   "DisableGanttMain": "Désactiver la tâche", 
   "EnableGanttMain": "Activez la tâche", 
   "LockGanttMain": "Verrouiller la tâche", 
   "UnlockGanttMain": "Débloquer la tâche", 
   "DisableGanttRun": "Désactiver la tâche", 
   "EnableGanttRun": "Activez la tâche", 
   "LockGanttRun": "Verrouiller la tâche", 
   "UnlockGanttRun": "Débloquer la tâche", 
   "DisableGanttRunPart": "Désactivez la case", 
   "EnableGanttRunPart": "Activez la case", 
   "LockGanttRunPart": "Verrouiller la boîte", 
   "UnlockGanttRunPart": "Débloquer le bloc", 
   "SetGanttPercent": "Définir le statut complété ici", 
   "ErrLag": "La valeur de retard est incorrect!", 
   "EmptyManual": "Aucune", 
   "ErrCorrectNone": "Pas toutes les dépendances peuvent être corrigées en raison des contraintes!", 
   "ZoomHeader": "Zoom sur <b>%d</b> %d - %d", 
   "ZoomUndo": "Zoom retour à <b>%d</b>", 
   "ZoomIn": "Zoom avant à <b>%d</b>", 
   "ZoomOut": "Zoom arrière à <b>%d</b>", 
   "ZoomFit": "Zoom pour adapter à l'espace réel", 
"V11_0": "", 
   "JoinGanttRunSelected": "Joindre les boîtes sélectionnées", 
   "SplitGanttRunJoined": "Diviser les boîtes unis", 
   "JoinGanttRunAdjacent": "Joindre les boîtes adjacentes", 
   "SplitGanttRunAdjacent": "Diviser les boîtes adjacentes unis", 
   "ChooseGanttRunType": "Modifiez la zone", 
   "ChooseGanttRunRowType": "Changer toutes les %d boîtes dans la ligne", 
   "ChooseGanttRunSelectedType": "Changer %d boîtes sélectionnées", 
   "ChooseGanttRunGroupType": "Changer les %d boîtes dans la ligne du groupe", 
   "ChooseGanttRunGroupAllType": "Changer les %d boîtes dans le groupe", 
"V12_0": "", 
   "GanttPinchZoom": "échelle %d%", 
"V13_0": "", 
   "DelGanttRunContainerOnly": "Supprimer le conteneur", 
   "DelGanttRunContainer": "Supprimer toutes les boîtes %d dans le conteneur", 
   "EnableGanttRunContainer": "Activer toutes les boîtes %d dans le conteneur", 
   "DisableGanttRunContainer": "Désactiver toutes les boîtes %d dans le conteneur", 
   "LockGanttRunContainer": "Verrouiller toutes les boîtes %d dans le conteneur", 
   "ChooseGanttRunContainerType": "Changer toutes les boîtes %d dans le conteneur", 
   "ChooseGanttRunContainer": "Changer le conteneur", 
   "AddGanttRunContainer": "Ajouter un nouveau conteneur pour la boîte", 
"V13_1": "", 
   "SelectGanttRunContainer": "Sélectionnez le conteneur", 
   "UnselectGanttRunContainer": "Désélectionner le conteneur", 
"V15_0": "", 
   "RemoveGanttRunPart": "Retirer la boite", 
   "RemoveGanttRunGroup": "Retirer le groupe de la ligne (%d boîtes)", 
   "RemoveGanttRunGroupAll": "Retirer le groupe (%d boîtes)", 
   "RemoveGanttRunSelected": "Retirer les boîtes sélectionnées (%d boîtes)"  
    }, 

"GanttUnits" : { 
"V10_0": "", 
   "ms": "milliseconde", "ms10": "10 millisecondes", "ms100": "100 millisecondes", 
   "s": "deuxième", "s2": "2 secondes", "s5": "5 secondes", "s10": "10 secondes", "s15": "15 secondes", "s30": "30 secondes", 
   "m": "minute", "m2": "2 minutes", "m5": "5 minutes", "m10": "10 minutes", "m15": "15 minutes", "m30": "30 minutes", 
   "h": "heure", "h2": "2 heures", "h3": "3 heures", "h6": "6 heures", "h8": "8 heures", "h12": "12 heures", 
   "d": "jour", "w": "semaine", "w0": "semaine", "w1": "semaine", "w6": "semaine", 
   "M": "mois", "M2": "2 mois", "M3": "trimestre", "M4": "4 mois", "M6": "demi année", 
   "y": "année", "y2": "2 ans", "y3": "3 ans", "y4": "4 ans", "y5": "5 ans", "y10": "10 ans", "y20": "20 ans", "y50": "50 ans"  
    }, 



// Popup dialog buttons, non HTML 

"MenuButtons" : { 
      
"V6_0": "", 
   "Ok": "Ok", 
   "Clear": "Vider", 
   "Today": "Aujourd'hui", 
   "All": "Tous", 
   "Cancel": "Annuler", 
"V6_7": "", 
   "Yesterday": "Hier", 
"V7_0": "", 
   "EmptyTip": "Date vide", 
"V10_0": "", 
   "Yes": "Oui", 
   "No": "Non", 
   "Always": "Toujours", 
   "Never": "Jamais", 
"V12_1": "", 
   "ShowAll": "Afficher all", 
   "HideAll": "Masquer tout", 
   "Reset": "Défaut", 
"V13_0": "", 
   "Add": "Ajouter", 
   "Discard": "Rejeter", 
   "Once": "Une fois", 
"V13_1": "", 
   "Shrink": "Taille de style rétrécie"  
    }, 



// Cell menu item names (cell Menu attribute), HTML 
// %1 is replaced by count of affected rows, only for mass actions 

"MenuCell" : { 
      
"V6_0": "", 
   "CopyRow": "Dupliquer la ligne", 
   "CopyRowBelow": "Dupliquer la ligne", 
   "CopyTree": "Dupliquer l'arbre de ligne", 
   "CopyTreeBelow": "Dupliquer l'arbre de ligne", 
   "CopyEmpty": "Ajouter l'arbre de ligne vide ci-dessus", 
   "CopyEmptyBelow": "Ajouter l'arbre de ligne vide ci-dessous", 
   "CopySelected1": "Copier la ligne sélectionnée ci-dessus", 
   "CopySelectedBelow1": "Copier la ligne sélectionnée ci-dessous", 
   "CopySelectedTree1": "Copier l'arbre de lignes sélectionnée ci-dessus", 
   "CopySelectedTreeBelow1": "Copier l'arbre de lignes sélectionnée ci-dessous", 
   "CopySelectedEmpty1": "Ajouter l'arbre de lignes vides sélectionnée ci-dessus", 
   "CopySelectedEmptyBelow1": "Ajouter l'arbre de lignes vides sélectionnée ci-dessous", 
   "CopySelectedChild1": "Copier la ligne sélectionnée en tant que premiers enfants", 
   "CopySelectedTreeChild1": "Copier l'arbre de lignes sélectionnée en tant que premiers enfants", 
   "CopySelectedEmptyChild1": "Ajouter l'arbre de lignes vides sélectionnée en tant que premiers enfants", 
   "CopySelectedChildEnd1": "Copier la ligne sélectionnée en tant que derniers enfants", 
   "CopySelectedTreeChildEnd1": "Copier l'arbre de lignes sélectionnée en tant que derniers enfants", 
   "CopySelectedEmptyChildEnd1": "Ajouter l'arbre de lignes vides sélectionnée en tant que derniers enfants", 
   "CopySelectedEnd1": "Copier la ligne sélectionnée à la fin", 
   "CopySelectedEndPage1": "Copier la ligne sélectionnée à la fin de la page", 
   "CopySelectedEndGrid1": "Copier la ligne sélectionnée à la fin de la grille", 
   "CopySelectedTreeEnd1": "Copier l'arbre de lignes sélectionnée à la fin", 
   "CopySelectedTreeEndPage1": "Copier l'arbre de lignes sélectionnée à la fin de la page", 
   "CopySelectedTreeEndGrid1": "Copier l'arbre de lignes sélectionnée à la fin de la grille", 
   "CopySelectedEmptyEnd1": "Ajouter l'arbre de lignes vides sélectionnée à la fin", 
   "CopySelectedEmptyEndPage1": "Ajouter l'arbre de lignes vides sélectionnée à la fin de la page", 
   "CopySelectedEmptyEndGrid1": "Ajouter l'arbre de lignes vides sélectionnée à la fin de la grille", 
   "CopySelected": "Copier %1 lignes sélectionnées ci-dessus", 
   "CopySelectedBelow": "Copier %1 lignes sélectionnées ci-dessous", 
   "CopySelectedTree": "Copier %1 l'arbres de lignes sélectionnées ci-dessus", 
   "CopySelectedTreeBelow": "Copier %1 l'arbres de lignes sélectionnées ci-dessous", 
   "CopySelectedEmpty": "Ajouter %1 l'arbres de lignes vides sélectionnées ci-dessus", 
   "CopySelectedEmptyBelow": "Ajouter %1 l'arbres de lignes vides sélectionnées ci-dessous", 
   "CopySelectedChild": "Copier %1 lignes sélectionnées en tant que premiers enfants", 
   "CopySelectedTreeChild": "Copier %1 l'arbres de lignes sélectionnées en tant que premiers enfants", 
   "CopySelectedEmptyChild": "Ajouter %1 l'arbres de lignes vides sélectionnées en tant que premiers enfants", 
   "CopySelectedChildEnd": "Copier %1 lignes sélectionnées en tant que derniers enfants", 
   "CopySelectedTreeChildEnd": "Copier %1 l'arbres de lignes sélectionnées en tant que derniers enfants", 
   "CopySelectedEmptyChildEnd": "Ajouter %1 l'arbres de lignes vides sélectionnées en tant que derniers enfants", 
   "CopySelectedEnd": "Copier %1 lignes sélectionnées à la fin", 
   "CopySelectedEndPage": "Copier %1 lignes sélectionnées à la fin de la page", 
   "CopySelectedEndGrid": "Copier %1 lignes sélectionnées à la fin de la grille", 
   "CopySelectedTreeEnd": "Copier %1 l'arbres de lignes sélectionnées à la fin", 
   "CopySelectedTreeEndPage": "Copier %1 l'arbres de lignes sélectionnées à la fin de la page", 
   "CopySelectedTreeEndGrid": "Copier %1 l'arbres de lignes sélectionnées à la fin de la grille", 
   "CopySelectedEmptyEnd": "Ajouter %1 l'arbres de lignes vides sélectionnées à la fin", 
   "CopySelectedEmptyEndPage": "Ajouter %1 l'arbres de lignes vides sélectionnées à la fin de la page", 
   "CopySelectedEmptyEndGrid": "Ajouter %1 l'arbres de lignes vides sélectionnées à la fin de la grille", 

   "AddRow": "Ajouter une nouvelle ligne vide en haut", 
   "AddChild": "Ajouter une nouvelle ligne vide comme premier enfant", 
   "AddChildEnd": "Ajouter une nouvelle ligne vide comme dernier enfant", 
   "AddRowBelow": "Ajouter une nouvelle ligne vide en dessous", 
   "AddRowEnd": "Ajouter une nouvelle ligne vide à la fin", 
   "AddRowEndPage": "Ajouter une nouvelle ligne vide à la fin de la page", 
   "AddRowEndGrid": "Ajouter une nouvelle ligne vide à la fin de la grille", 

"V12_0": "", 
   "CopyRows1": "Copier la ligne ci-dessus", 
   "CopyRowsBelow1": "Copier la ligne ci-dessous", 
   "CopyRowsTree1": "Copier l'arbre de lignes ci-dessus", 
   "CopyRowsTreeBelow1": "Copier l'arbre de lignes ci-dessous", 
   "CopyRowsEmpty1": "Ajouter l'arbre de lignes vides ci-dessus", 
   "CopyRowsEmptyBelow1": "Ajouter l'arbre de lignes vides ci-dessous", 
   "CopyRows": "Copier %1 lignes ci-dessus", 
   "CopyRowsBelow": "Copier %1 lignes ci-dessous", 
   "CopyRowsTree": "Copier %1 l'arbres de lignes ci-dessus", 
   "CopyRowsTreeBelow": "Copier %1 l'arbres de lignes ci-dessous", 
   "CopyRowsEmpty": "Ajouter %1 l'arbres de lignes vides ci-dessus", 
   "CopyRowsEmptyBelow": "Ajouter %1 l'arbres de lignes vides ci-dessous", 

   "AddRows1": "Ajouter la ligne vide ci-dessus", 
   "AddRowsBelow1": "Ajouter la ligne vide ci-dessous", 
   "AddSelected1": "Ajouter la ligne vide ci-dessus", 
   "AddSelectedBelow1": "Ajouter la ligne vide ci-dessous", 
   "AddRows": "Ajouter %1 lignes vides ci-dessus", 
   "AddRowsBelow": "Ajouter %1 lignes vides ci-dessous", 
   "AddSelected": "Ajouter %1 lignes vides ci-dessus", 
   "AddSelectedBelow": "Ajouter %1 lignes vides ci-dessous", 

   "DeleteRow": "Supprimer la ligne", 
   "UndeleteRow": "Récupérer ligne", 
   "RemoveRow": "Retirer la ligne", 
   "DeleteRows1": "Supprimer la ligne", 
   "UndeleteRows1": "Récupérer la ligne", 
   "RemoveRows1": "Retirer la ligne", 
   "DeleteSelected1": "Supprimer la ligne sélectionnée", 
   "UndeleteSelected1": "Récupérer la ligne sélectionnée", 
   "RemoveSelected1": "Retirer la ligne sélectionnée", 
   "DeleteRows": "Supprimer %1 lignes", 
   "UndeleteRows": "Récupérer %1 lignes", 
   "RemoveRows": "Retirer %1 lignes", 
   "DeleteSelected": "Supprimer %1 lignes sélectionnées", 
   "UndeleteSelected": "Récupérer %1 lignes sélectionnées", 
   "RemoveSelected": "Retirer %1 lignes sélectionnées", 

   "CopyCol": "Dupliquer la colonne", 
   "CopyColNext": "Dupliquer la colonne", 
   "CopyCols1": "Copier la colonne à gauche", 
   "CopyColsNext1": "Copier la colonne à droite", 
   "CopySelectedCols1": "Copier la colonne sélectionnées à gauche", 
   "CopySelectedColsNext1": "Copier la colonne sélectionnées à droite", 
   "CopyCols": "Copier %1 colonnes à gauche", 
   "CopyColsNext": "Copier %1 colonnes à droite", 
   "CopySelectedCols": "Copier %1 colonnes sélectionnées à gauche", 
   "CopySelectedColsNext": "Copier %1 colonnes sélectionnées à droite", 

   "AddCol": "Ajouter une nouvelle colonne vide à gauche", 
   "AddColNext": "Ajouter une nouvelle colonne vide à droite", 
   "AddCols1": "Ajouter la colonne vide à gauche", 
   "AddColsNext1": "Ajouter la colonne vide à droite", 
   "AddSelectedCols1": "Ajouter la colonne vide à gauche", 
   "AddSelectedColsNext1": "Ajouter la colonne vide à droite", 
   "AddCols": "Ajouter %1 colonnes vides à gauche", 
   "AddColsNext": "Ajouter %1 colonnes vides à droite", 
   "AddSelectedCols": "Ajouter %1 colonnes vides à gauche", 
   "AddSelectedColsNext": "Ajouter %1 colonnes vides à droite", 
   "AddColEnd": "Ajouter une nouvelle colonne vide à fin", 

   "DeleteCol": "Supprimer la colonne", 
   "UndeleteCol": "Récupérer la colonne", 
   "RemoveCol": "Retirer la colonne", 
   "DeleteCols1": "Supprimer la colonne", 
   "UndeleteCols1": "Récupérer la colonne", 
   "RemoveCols1": "Retirer %1 la colonne", 
   "DeleteSelectedCols1": "Supprimer la colonne sélectionnée", 
   "UndeleteSelectedCols1": "Récupérer la colonne sélectionnée", 
   "RemoveSelectedCols1": "Retirer la colonne sélectionnée", 
   "DeleteCols": "Supprimer %1 colonnes", 
   "UndeleteCols": "Récupérer %1 colonnes", 
   "RemoveCols": "Retirer %1 colonnes", 
   "DeleteSelectedCols": "Supprimer %1 colonnes sélectionnées", 
   "UndeleteSelectedCols": "Récupérer %1 colonnes sélectionnées", 
   "RemoveSelectedCols": "Retirer %1 colonnes sélectionnées", 

   "ClearSelection": "Désélectionner toutes %1 lignes et colonnes", 
   "SelectRow": "Sélectionner la ligne", 
   "DeselectRow": "Désélectionner la ligne", 
   "SelectFocusedRows1": "Sélectionner la ligne pointée", 
   "DeselectFocusedRows1": "Désélectionner la ligne pointée", 
   "SelectFocusedRows": "Sélectionner %1 lignes pointées", 
   "DeselectFocusedRows": "Désélectionner %1 lignes pointées", 
   "SelectAll1": "Sélectionner la seule ligne", 
   "DeselectAll1": "Désélectionner la seule ligne", 
   "InvertAll1": "Inverser la sélection de seule ligne", 
   "SelectAll": "Sélectionner toutes les %1 lignes", 
   "DeselectAll": "Désélectionner toutes %1 lignes", 
   "InvertAll": "Inverser la sélection de toutes les %1 lignes", 
   "SelectCol": "Sélectionner une colonne", 
   "DeselectCol": "Désélectionner la colonne", 
   "SelectFocusedCols1": "Sélectionner la colonne pointée", 
   "DeselectFocusedCols1": "Désélectionner la colonnes pointée", 
   "SelectFocusedCols": "Sélectionner %1 colonnes pointées", 
   "DeselectFocusedCols": "Désélectionner %1 colonnes pointées", 
   "SelectCell": "Sélectionner la cellule", 
   "DeselectCell": "Déselectionner la celulle", 
   "SelectRowRange1": "Sélectionner la ligne", 
   "DeselectRowRange1": "Désélectionner la ligne", 
   "SelectColRange1": "Sélectionner la colonne", 
   "DeselectColRange1": "Désélectionner la colonne", 
   "SelectCellRange1": "Sélectionner le cellule", 
   "DeselectCellRange1": "Désélectionner le cellule", 
   "SelectColCells1": "Sélectionner la seule cellule dans les colonnes", 
   "DeselectColCells1": "Désélectionner la seule cellule dans les colonnes", 
   "SelectRowCells1": "Sélectionner la seule cellule dans les lignes", 
   "DeselectRowCells1": "Désélectionner la seule cellule dans les lignes", 
   "SelectAllCells1": "Sélectionner la seule cellule", 
   "DeselectAllCells1": "Désélectionner la seule cellule", 
   "SelectAllCols1": "Sélectionnez la seule colonne", 
   "DeselectAllCols1": "Désélectionner la seule colonne", 
   "SelectRowRange": "Sélectionner les %1 lignes dans la zone", 
   "DeselectRowRange": "Désélectionner les %1 lignes dans la zone", 
   "SelectColRange": "Sélectionner les %1 colonnes dans la zone", 
   "DeselectColRange": "Désélectionner les %1 colonnes dans la zone", 
   "SelectCellRange": "Sélectionner les %1 cellules dans la zone", 
   "DeselectCellRange": "Désélectionner les %1 cellules dans la zone", 
   "SelectColCells": "Sélectionner toutes les %1 cellules dans les colonnes", 
   "DeselectColCells": "Désélectionner toutes %1 cellules dans les colonnes", 
   "SelectRowCells": "Sélectionner toutes les %1 cellules dans les lignes", 
   "DeselectRowCells": "Désélectionner toutes %1 cellules dans les lignes", 
   "SelectAllCells": "Sélectionner toutes les %1 cellules", 
   "DeselectAllCells": "Désélectionner toutes %1 cellules", 
   "SelectAllCols": "Sélectionnez toutes les %1 colonnes", 
   "DeselectAllCols": "Désélectionner toutes %1 colonnes", 

   "Span": "Étendre cellules", 
   "Split": "Diviser les cellules étendues", 

   "Expand": "Fermer ligne", 
   "Collapse": "Ouvrir ligne", 
   "ExpandAll1": "Ouvrir la seule ligne", 
   "CollapseAll1": "Fermer la seule ligne", 
   "CollapseAllRoot1": "Fermer la ligne racine", 
   "ExpandAll": "Ouvrir toutes les %1 lignes", 
   "CollapseAll": "Fermer toutes les %1 lignes", 
   "CollapseAllRoot": "Fermer toutes les %1 lignes racines", 
   "Outdent1": "Diminue le indent la ligne", 
   "Indent1": "Indenter la ligne", 
   "Outdent": "Diminue le indent de %1 lignes", 
   "Indent": "Indenter %1 lignes", 

   "ExpandCell": "Ouvrir ou fermer les cellules", 
   "ExpandCol": "Ouvrir colonne", 
   "CollapseCol": "Fermer colonne", 
   "ExpandRow": "Ouvrir ligne", 
   "CollapseRow": "Fermer ligne", 
   "ExpandAllCells": "Développez toutes les colonnes", 
   "CollapseAllCells": "Fermer toutes les colonnes", 
   "ExpandRowCells": "Ouvrir toutes les colonnes dans la ligne", 
   "CollapseRowCells": "Fermer toutes les colonnes dans la ligne", 

   "HideRows1": "Masquer la ligne", 
   "HideRows": "Masquer %1 lignes", 
   "ShowRowAbove": "Afficher ligne masquée ci-dessus", 
   "ShowRowBelow": "Afficher ligne masquée ci-dessous", 
   "ShowRows1": "Afficher la ligne cachée", 
   "ShowRowsW": "Afficher toutes %1 lignes cachées", 
   "ShowRows": "Afficher %1 lignes cachées", 

   "HideCols1": "Masquer colonne", 
   "HideCols": "Masquer %1 colonnes", 
   "ShowColLeft": "Afficher la colonne cachée sur la gauche", 
   "ShowColRight": "Afficher la colonne cachée sur la droite", 
   "ShowCols1": "Afficher la colonne cachée", 
   "ShowColsW": "Afficher toutes %1 colonnes cachées", 
   "ShowCols": "Afficher %1 colonnes cachées", 

   "SearchOn": "Activer la recherche", 
   "SearchOff": "Désactiver la recherche", 

   "SortAsc": "Trier par ordre croissant de la colonne", 
   "SortDesc": "Trier par la colonne descendante", 
   "SortAscOne": "Trier par ordre croissant d'une colonne", 
   "SortDescOne": "Trier par une colonne descendante", 
   "SortAscAppend": "Trier par la colonne suivante croissant", 
   "SortDescAppend": "Trier par la colonne suivante décroissant", 
   "NoSort": "Ne pas trier par la colonne", 
   "DefaultSort": "Restaurer le tri d'origine", 
   "SortOn": "Activer le tri", 
   "SortOff": "Désactiver le tri", 

   "Undo": "Annuler dernier action", 
   "UndoAll1": "Annuler le action", 
   "UndoAll": "Annuler toutes les %1 actions", 
   "Redo": "Refaire la dernière action annulée", 
   "RedoAll1": "Refaire le action annulées", 
   "RedoAll": "Refaire toutes les %1 actions annulées", 
   "ClearUndo": "Effacer le tampon d'annulation", 

   "Print": "Imprimez la grille", 
   "ExportPDF": "Imprimer la grille au format PDF", 
   "Export": "Exporter la grille vers XLSX, XLS ou CSV", 
   "Repaint": "Repeindre, effacer les pages inutilisées", 
   "RenderPages": "Modifier la pagination", 
   "PagingOn": "Activer la pagination, effacer les pages inutilisées", 
   "PagingOff": "Désactiver la pagination, générer toutes les pages", 
   "ShowCfg": "Afficher le menu de configuration", 
   "ShowColumns": "Afficher colonnes menu", 
   "ShowDebug": "Affiche la fenêtre de débogage", 
   "Reload": "Recharger la grille, annuler les changements", 
   "Validate": "Vérifiez les données pour les erreurs", 
   "Save": "Enregistrer les modifications au serveur", 

   "GoUp": "Focus sur", 
   "GoUpEdit": "Focus sur", 
   "GoDown": "Focus bas", 
   "GoDownEdit": "Focus bas", 
   "GoDownAdd": "Focus bas", 
   "GoDownEditAdd": "Focus bas", 
   "GoLeft": "Focus gauche", 
   "GoLeftEdit": "Focus gauche", 
   "GoRight": "Focus droite", 
   "GoRightEdit": "Focus droite", 
   "GoFirst": "Pointe la première ligne", 
   "GoLast": "Focus dernière ligne", 
   "PageDown": "Aller à la page suivante", 
   "PageUp": "Aller à page précédente", 
   "PageDownFull": "Aller à la page suivante", 
   "PageUpFull": "Aller à page précédente", 

   "ShowDetail": "Voir le détail de la ligne", 
   "RefreshDetail": "Voir le détail de la ligne", 
   "ClearDetail": "Effacer le détail", 

   "ShowHintStatic": "Afficher le contenu complet de la cellule", 
   "GridResizeDefault": "Restaurer la taille de la grille", 

   "GroupBy": "Groupé par la colonne", 
   "GroupByLast": "Ajouter la colonne à grouper", 
   "UngroupBy": "Dissocier par la colonne", 
   "GroupOn": "Activer le groupement", 
   "GroupOff": "Désactiver le regroupement", 

   "Focus": "Focus cellule", 
   "FocusEdit": "Pointe et modifier cellule", 
   "FocusAndEdit": "Pointe et modifier cellule", 
   "ChangeFocus": "Focus cellule", 
   "ChangeFocusRow": "Focus ligne cellule", 
   "ChangeFocusCol": "Pointe une colonne", 
   "Blur": "Retirer le focus", 
   "BlurFocused": "Retirer le focus", 
   "FocusWholeRow": "Pointer toutes les cellules dans la ligne", 
   "FocusWholeCol": "Pointers les cellules de la colonne", 
   "FocusWholeGrid": "Pointer toutes les cellules dans la grille", 

   "StartEdit": "Modifier les cellules pointées", 
   "StartEditEmpty": "Modifier  les cellules pointées vide", 
   "StartEditCell": "Modifier la cellule", 
   "StartEditCellEmpty": "Éditer la cellule vide", 
   "CancelEdit": "Annuler l'édition", 
   "AcceptEdit": "Terminer l'édition", 
   "ShowCalendar": "Prendre la date du calendrier", 
   "ShowDates": "Prendre la date de la table", 
   "ShowLink": "Accédez au url", 
   "Button": "Appuyer sur le bouton", 
   "ButtonClick": "Appuyer sur le bouton de droite", 
   "IconClick": "Appuyer sur le bouton gauche", 
   "ShowHelp": "Voir l'aide", 
   "ShowFile": "Choisir un fichier", 
   "ShowDefaults": "Afficher les éléments prédéfinis", 
   "ShowDefaultsMenu": "Afficher les éléments prédéfinis", 

   "ChangeBool": "Changer la case à cocher", 
   "CheckBool": "Vérifiez l'icône", 
   "UncheckBool": "Décochez l'icône", 
   "ClearBool": "Effacer la cellule", 
   "ChangeRadioLeft": "Cycle radio de gauche", 
   "ChangeRadioLeftCycle": "Cycle radio de gauche", 
   "ChangeRadioRight": "Cycle radio de droite", 
   "ChangeRadioRightCycle": "Cycle radio de droite", 
   "CheckIcon": "Vérifiez l'icône", 
   "UncheckIcon": "Décochez l'icône", 
   "SetChecked": "Changer ls case à cocher", 

   "ShowFilterMenu": "Afficher le menu de filtre", 
   "ShowFilterMenuRow": "Afficher le menu de filtre", 
   "FilterBy": "Filtre selon les valeurs de la cellule", 
   "FilterByMenu": "Filtre pour choisir la valeur de la cellule", 
   "FilterByMenuRow": "Filtre pour choisir la valeur de la cellule", 
   "ClearFilter": "Effacer le filtre pour la colonne", 
   "ClearFilters": "Effacer tous les filtres", 
   "FilterOn": "Activer le filtrage", 
   "FilterOff": "Désactiver le filtrage", 

   "ClearCell": "Effacer", 
   "ClearValueStyle": "Effacer la valeur et le style", 
   "ClearValue": "Effacer la valeur", 
   "ClearStyle": "Effacer le style", 

   "SetCellAbsolute": "Réglez la cellule référence absolue", 
   "SetCellRelative": "Réglez la cellule référence relative", 
   "SwitchCellAbsolute": "Modifier la référence de cellule", 
   "SwitchRowColAbsolute": "Modifier la cellule référence", 
   "ChooseRowInsert": "Insérer une référence de ligne", 
   "ChooseRowReplace": "Remplacer la ligne référence", 
   "ChooseRowReplaceAll": "Remplacer la ligne référence", 
   "ChooseColInsert": "Insérer une colonne référence", 
   "ChooseColReplace": "Remplacer la colonne référence", 
   "ChooseColReplaceAll": "Remplacer la colonne référence", 
   "ChooseCellInsert": "Insérer une cellule référence", 
   "ChooseCellReplace": "Remplacer une cellule référence", 
   "ChooseCellReplaceAll": "Remplacer une cellule référence", 

   "CalcOn": "Activer les calculs", 
   "CalcOff": "Désactiver les calculs", 

   "ClearBorder": "Effacer bordures", 
   "ClearBorderOut": "Effacer bordures extérieur", 
   "ClearBorderIn": "Effacer bordures intérieur", 
   "ClearBorderTop": "Effacer bordures supérieure", 
   "ClearBorderBottom": "Effacer bordures inférieur", 
   "ClearBorderLeft": "Effacer bordures gauche", 
   "ClearBorderRight": "Effacer bordures droite", 
   "SetBorder": "Définir bordures", 
   "SetBorderOut": "Définir bordures extérieur", 
   "SetBorderOutTop": "Définir bordures supérieur extérieur", 
   "SetBorderOutBottom": "Définir bordures inférieur extérieur", 
   "SetBorderOutLeft": "Définir bordures gauche extérieur", 
   "SetBorderOutRight": "Définir bordures droite extérieur", 
   "SetBorderTop": "Définir bordures supérieur", 
   "SetBorderBottom": "Définir bordures inférieur", 
   "SetBorderLeft": "Définir bordures gauche", 
   "SetBorderRight": "Définir bordures droite", 
   "SetBorderIn": "Définir bordures intérieur", 
   "SetBorderInTop": "Définir bordures supérieur intérieur", 
   "SetBorderInBottom": "Définir bordures inférieur intérieur", 
   "SetBorderInLeft": "Définir bordures gauches intérieur", 
   "SetBorderInRight": "Définir bordures droites intérieur", 
   "ChooseBorderEdge": "Choisir le bord de bordure", 
   "ChooseBorderEdgeItems": "%1", 
   "ChooseBorderStyle": "Choisir le style de bordure", 
   "ChooseBorderStyleItems": "%1", 
   "ChooseBorderColor": "Choisir la couleur de bordure", 
   "ChooseBorderColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "ChooseBorder": "Choisir la bordure", 

   "RotateLeft": "Tourner à gauche", 
   "RotateRight": "Tourner à droite", 
   "NoRotate": "Effacer la rotation", 
   "VertAlignTop": "Aligner au dessus", 
   "VertAlignBottom": "Aligner au dessous", 
   "VertAlignMiddle": "Centrer verticalement", 
   "NoVertAlign": "Effacer alignement vertical", 
   "AlignLeft": "Aligner à gauche", 
   "AlignRight": "Aligner à droite", 
   "AlignCenter": "Centrer horizontalement", 
   "NoAlign": "Effacer alignement horizontal", 
   "WrapOn": "Envelopper", 
   "WrapOff": "Ne pas envelopper", 
   "NoWrap": "Envelopper par défaut", 
   "NoTextStyle": "Style de texte par défaut", 
   "BoldOn": "En gras", 
   "BoldOff": "Pas en gras", 
   "ItalicOn": "Italique", 
   "ItalicOff": "Sans italique", 
   "UnderlineOn": "Souligner", 
   "UnderlineOff": "Sans souligner", 
   "StrikeOn": "Barré", 
   "StrikeOff": "Pas barré", 
   "OverlineOn": "Surligner", 
   "OverlineOff": "Sans surligner", 
   "SmallCapsOn": "En minuscules", 
   "SmallCapsOff": "Pas minuscules", 
   "SetTextColor": "Définir la couleur du texte", 
   "NoTextColor": "Annuler la couleur du texte", 
   "ChooseTextColor": "Choisir la couleur du texte", 
   "ChooseTextColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "SetColor": "Définir la couleur de fond", 
   "NoColor": "Annuler la couleur de fond", 
   "ChooseColor": "Choisir la couleur de fond", 
   "ChooseColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "SetTextSize": "Définir la taille de police", 
   "NoTextSize": "Définir la taille de police par défaut", 
   "ChooseTextSize": "Choisir la taille de police", 
   "ChooseTextSizeItems": "%1", 
   "SetTextFont": "Définir le nom de la police", 
   "NoTextFont": "Définir le nom de la police par défaut", 
   "ChooseTextFont": "Choisir le nom de police", 
   "ChooseTextFontItems": "%1", 
   "SetTextShadowColor": "Définir la couleur de ombragé", 
   "NoTextShadowColor": "Annuler la couleur de ombragé", 
   "ChooseTextShadowColor": "Choisir la couleur de ombragé", 
   "ChooseTextShadowColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 
   "SetTextShadow": "Définir le ombragé", 
   "NoTextShadow": "Annuler le ombragé", 
   "ChooseTextShadow": "Choisir le ombragé", 
   "ChooseTextShadowItems": "%1", 

   "SetEditable": "Permettre l'édition", 
   "SetReadOnly": "Restreindre l'édition", 
   "SetPreview": "Lecture seulement", 
   "ClearEditable": "Restreindre l'édition lorsqu'elle est verrouillée", 
   
   "ShowFormula": "Montrer la formule", 
   "HideFormula": "Masquer la formule", 
   "DefaultFormula": "Masquer la formule lorsqu'elle est verrouillée", 

   "ChooseFormat": "Choisir le format", 
   "SetFormat": "Ajuster le format", 

"V12_1": "", 
   "Copy": "Copier vers presse-papiers", 
   "Exclude": "Couper vers presse-papiers", 

"V13_0": "", 
   "Import": "Importer un fichier XLSX local dans la grille", 

"V15_0": "", 
   "ShowCellLink": "Accédez au url", 
   "SetLink1": "Entrez le lien", 
   "SetLinkE": "Entrez le lien", 
   "SetLink": "Entrez les %1 liens", 
   "ClearLink1": "Supprimer le lien", 
   "ClearLinkE": "Supprimer le lien", 
   "ClearLink": "Supprimer les %1 liens", 

   "OpenImage": "Insérer un fichier image local dans la cellule", 

   "UpperCase1": "En majuscule", 
   "UpperCaseE": "En majuscule", 
   "UpperCase": "%1 textes en majuscule", 
   "LowerCase1": "En minuscule", 
   "LowerCaseE": "En minuscule", 
   "LowerCase": "%1 textes en minuscule", 

   "IncreaseTextSizeE": "Augmenter la taille de la police", 
   "IncreaseTextSize": "Augmenter la taille de la police", 
   "DecreaseTextSizeE": "Diminuer la taille de la police", 
   "DecreaseTextSize": "Diminuer la taille de la police", 

   "Superscript": "Texte en exposant", 
   "Subscript": "Texte en indice", 
   "Noscript": "Effacer exposant / indice", 
   "SetTextLine": "Définir une décoration de soulignement", 
   "NoTextLine": "Annuler une décoration de soulignement", 
   "ChooseTextLine": "Choisir une décoration de soulignement", 
   "ChooseTextLineItems": "<span style='text-decoration:%1 line-through;'>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</span>", 
   "SetPattern": "Définir le motif de fond", 
   "NoPattern": "Annuler le motif de fond", 
   "ChoosePattern": "Choisir le motif de fond", 
   "ChoosePatternItems": "<span style='background-image:%1;padding-left:50px;line-height:16px;font-size:16px;'></span>", 
   "SetPatternColor": "Définir la couleur du motif de fond", 
   "NoPatternColor": "Annuler la couleur du motif de fond", 
   "ChoosePatternColor": "Choisir la couleur du motif de fond", 
   "ChoosePatternColorItems": "<span style='background:%2;padding-left:15px;margin-right:5px;border-radius:50px;line-height:12px;font-size:12px;'></span>%1", 

   "RotateLeft30": "Tourner à gauche de 30 degrés", 
   "RotateRight30": "Tourner à droite de 30 degrés", 
   "RotateLeft45": "Tourner à gauche de 45 degrés", 
   "RotateRight45": "Tourner à droite de 45 degrés", 
   "RotateLeft60": "Tourner à gauche de 60 degrés", 
   "RotateRight60": "Tourner à droite de 60 degrés", 
   "RotateLeft90": "Tourner à gauche de 90 degrés", 
   "RotateRight90": "Tourner à droite de 90 degrés", 
   "RotateLeftVert": "Tourner à la verticale gauche", 
   "RotateRightVert": "Tourner à la verticale droite", 

   "VertAlignTopE": "Texte en exposant", 
   "SuperscriptE": "Texte en exposant", 
   "VertAlignBottomE": "Texte en indice", 
   "SubscriptE": "Texte en indice", 
   "VertAlignMiddleE": "Effacer exposant / indice", 
   "NoVertAlignE": "Effacer exposant / indice", 
   "NoscriptE": "Effacer exposant / indice", 
   "BoldOnE": "En gras / normal", 
   "BoldOffE": "", 
   "ItalicOnE": "Italique / normal", 
   "ItalicOffE": "", 
   "UnderlineOnE": "Soulignez / normal", 
   "UnderlineOffE": "", 
   "StrikeOnE": "Barré / normal", 
   "StrikeOffE": "", 
   "SetTextLineE": "Définir la couleur de soulignement", 
   "NoTextLineE": "Annuler la couleur de soulignement", 
   "ChooseTextLineE": "Choisir la couleur de soulignement", 
   "SetTextColorE": "Définir la couleur du texte", 
   "NoTextColorE": "Annuler la couleur du texte", 
   "ChooseTextColorE": "Choisir la couleur du texte", 
   "SetColorE": "Définir la couleur de fond du texte", 
   "NoColorE": "Annuler la couleur de fond du texte", 
   "ChooseColorE": "Choisir la couleur de fond du texte", 
   "SetTextSizeE": "Définir la taille de la police", 
   "NoTextSizeE": "Annuler la taille de la police", 
   "ChooseTextSizeE": "Choisir la taille de la police", 
   "SetTextFontE": "Définir le nom de la police", 
   "NoTextFontE": "Annuler le nom de la police", 
   "ChooseTextFontE": "Choisir le nom de la police", 
   "SetTextShadowColorE": "Définir la couleur de texte ombragé", 
   "NoTextShadowColorE": "Annuler la couleur de texte ombragé", 
   "ChooseTextShadowColorE": "Choisir la couleur de texte ombragé", 
   "ClearStyleE": "Effacer le style du texte", 

   "ShowColTreeLevel": "Développer les colonnes à ce niveau", 
   "OutdentCols1": "Diminue le indent de la colonne", 
   "OutdentColsForce1": "Diminue le indent de la colonne", 
   "IndentCols1": "Indenter la colonne", 
   "IndentColsForce1": "Indenter la colonne", 
   "OutdentCols": "Diminue le indent de %1 colonnes", 
   "OutdentColsForce": "Diminue le indent de %1 colonnes", 
   "IndentCols": "Indenter %1 colonnes", 
   "IndentColsForce": "Indenter %1 colonnes", 

   "FixAbove": "Geler les lignes précédentes ci-dessus", 
   "FixBelow": "Geler les lignes suivantes ci-dessous", 
   "FixPrev": "Geler les colonnes précédentes à gauche", 
   "FixNext": "Geler les autres colonnes à droite", 

   "RestoreImage": "Restaurer la taille / position / rotation de l'image", 
   "RestoreImageSize": "Restaurer la taille de l'image par défaut", 
   "RestoreImageRotation": "Ne pas faire pivoter l'image", 
   "RestoreImagePosition": "Déplacer l'image à sa position d'origine", 
   "AssignImage": "Déplacer l'image dans sa cellule en haut à gauche", 
   "DeleteImage": "Supprimer l'image", 
   "DuplicateImage": "Dupliquer l'image", 
   "DragImageClear": "Faire glisser l'image fera l'action par défaut", 
   "DragImageResize": "Faire glisser l'image redimensionnera dans une direction", 
   "DragImageResizeXY": "Faire glisser l'image redimensionnera dans une direction", 
   "DragImageResizeFree": "Faire glisser l'image redimensionnera, ignore les proportions", 
   "DragImageRotate": "Faire glisser l'image pour la faire pivoter", 
   "DragImageCrop": "Faire glisser l'image va la recadrer", 
   "DragImageMove": "Faire glisser l'image va la déplacer", 
   "DragImageMoveXY": "Faire glisser l'image va la déplacer dans une direction", 
   "DragImageCopy": "Faire glisser l'image va la copier", 
   "DragImageCopyXY": "Faire glisser l'image va la copier", 
   "DragImageNone": "Glisser l'image sera restreint", 
   "EnterImageOpacity": "Entrez l'opacité de l'image", 
   "EnterImageName": "Entrez l'nom de l'image", 

   "AutoSpan": "Joindre automatiquement les cellules", 
   "AutoRowSpan": "Joindre automatiquement les cellules verticalement", 
   "AutoColSpan": "Joindre automatiquement les cellules horizontalement", 

   "Lock": "Verrouiller / déverrouiller la grille", 
   "Lock0": "Déverrouiller la grille", 
   "Lock1": "Verrouiller la structure de la grille", 
   "Lock2": "Verrouiller la structure et les styles de la grille", 
   "Lock3": "Verrouiller complètement la grille", 

   "DefineName": "Définir le nom", 
   "DefineGlobalName": "Définir un nom global", 
   "EditName": "Changer de nom", 
   "DeleteName": "Supprimer le nom"  
    }, 



// Configuration menu item names, HTML 
      
"MenuCfg" : { 
         
"V2_3": "", 		
   "Caption": "Paramètres de TreeGrid", 
   "ShowDeleted": "Afficher supprimé lignes (en rouge)", 
   "AutoSort": "Tri de ligne automatique après changement", 
   "AutoUpdate": "Mise à jour automatique change au serveur", 
   "MouseHover": "Survol Souris", 
   "Hover1": "Aucune", 
   "Hover2": "Cellule seul", 
   "Hover3": "Ligne", 
   "Hover4": "Ligne et colonne", 
   "ShowDrag": "Afficher l'objet déplacé", 
   "ShowPanel": "Afficher les lignes du panneau de gauche", 
"V2_6": "", 
   "ShowPager": "Afficher panneau", 
   "ShowAllPages": "Afficher toutes les pages", 
"V4_4": "", 
   "CheckUpdates": "Vérifier les mises à jour sur le serveur chaque", 
   "CheckUpdates0": "Non", 
   "CheckUpdates2": "2 secondes", 
   "CheckUpdates5": "5 secondes", 
   "CheckUpdates10": "10 secondes", 
   "CheckUpdates30": "30 secondes", 
   "CheckUpdates60": "1 minute", 
   "CheckUpdates120": "2 minutes", 
   "CheckUpdates300": "5 minutes", 
   "CheckUpdates600": "10 minutes", 
"V5_0_20": "", 
   "SortClick": "Bouton Trie", 
   "SortClick1": "Simple, pas d'icônes", 
   "SortClick2": "Simple", 
   "SortClick3": "Directionnels, icônes seulement", 
   "SortClick4": "Directionnel", 
"V6_3": "", 
   "GanttCorrectDependencies": "Planifier des tâches", 
   "Correct1": "manuellement", 
   "Correct2": "auto", 
   "Correct3": "Demandez", 
   "GanttCheckDependencies": "Dépendances circulaires", 
   "Check1": "permis", 
   "Check2": "restreindre", 
   "Check3": "Demandez", 
   "GanttHideExclude": "Afficher le tableau des vacances", 
   "GanttCheckExclude": "Début des tâches en vacances", 
   "GanttCorrectDependenciesFixed": "Auto cédule changera également les tâches", 
"V6_4": "", 
   "GanttBaseProof": "Peut déplacer des objets avant le début du projet", 
   "GanttBasePreferred": "Le début du projet est préféré aux contraintes", 
"V6_6": "", 
   "GanttMinSlack": "Jeu minimal pour tâche critique", 
   "GanttErrSlack": "Jeu minimal limite pour une tâche en erreur", 
   "GanttSeparateSlack": "Calculer le chemin critique individuellement", 
"V6_7": "", 
   "Check4": "alerte", 
"V7_0": "", 
   "GanttFixComplete": "Céduler même si les tâches ont déjà commencé", 
   "GanttFinishProof": "Peut déplacer des objets après la fin du projet", 
   "GanttFinishPreferred": "La finition du projet est préférée aux contraintes", 
   "Scrollbars": "Type de barres de défilement", 
   "Scrollbars1": "Aucune", 
   "Scrollbars2": "Mince", 
   "Scrollbars3": "Standard", 
   "Scrollbars4": "Largeur", 
   "Scroll": "Défiler selon", 
   "Scroll1": "Barres de défilement seulement", 
   "Scroll2": "Un doigt (aucun mouvement)", 
   "Scroll3": "Deux doigts (sans zoom)", 
   "Scroll4": "Trois doigts (pas glisser)", 
"V10_0": "", 
   "GanttCheck": "Saisies manuelles incorrectes", 
   "GanttCheck1": "permis", 
   "GanttCheck2": "restreindre", 
   "GanttCheck3": "restreindre + alerte", 
   "GanttCheck4": "correcte", 
   "GanttCheck5": "correcte + alerte", 
   "ReversedTree": "Arbre Inversée (comme dans MS Excel)", 
   "GanttDirection": "Planifier les tâches à partir de", 
   "GanttDirection1": "début du projet", 
   "GanttDirection2": "fin du projet", 
   "GanttStrict": "Méthode de planification des tâches", 
   "GanttStrict1": "mouvement minimal", 
   "GanttStrict2": "déplacement stricte", 
   "GanttStrict3": "", 
   "GanttStrict4": "min. déplacement stricte", 
"V11_0": "", 
   "ShowButtons": "Afficher les boutons", 
   "ShowButtons1": "Icônes seulement", 
   "ShowButtons2": "Texte seul", 
   "ShowButtons3": "Icônes et textes", 
   "GanttCorrectOutsideBounds": "Planifier des tâches en dehors des limites du projet", 
"V12_1": "", 
   "CfgCaption": "Configuration de base", 
   "GanttCaption": "Configuration de Gantt", 
"V13_0": "", 
   "Animations": "Animer des actions", 
   "ShrinkStyle": "Rétrécissez le style dans un petit espace", 
   "ShrinkStyle1": "Jamais", 
   "ShrinkStyle2": "Toujours", 
   "ShrinkStyle3": "Demander", 
   "CompatibleStyles": "Compatible", 
   "Style": "Style", 
   "GanttStyle": "Gantt style", 
   "StyleSize": "Taille du style", 
   "Scale": "Échelle", 
   "StylesCaption": "-", 
   "ShowBorder": "Afficher la bordure par défaut de la cellule", 
   "FormulaTip": "Afficher la formule en tant que pointe de cellule", 
"V13_1": "", 
   "ShrinkStyle4": "Minimal", 
"V14_0": "", 
   "LanguageCaption": "-", 
   "Language": "Langue", 
"V15_0": "", 
   "ShowFormulas": "Afficher des formules au lieu de résultats", 
   "ShowZeros": "Afficher les valeurs de cellule zéro", 
   "PageBreaks": "Afficher les sauts de page pour l'impression", 
   "Contrast": "Contraste", 
   "ShowTree": "Afficher l'arbre des colonnes", 
   "ShowTree1": "Désactiver", 
   "ShowTree2": "Masquer", 
   "ShowTree3": "Parents ci-dessus", 
   "ShowTree4": "Parents ci-dessous", 
   "ColTree": "Afficher l'arbre des lignes", 
   "ColTree1": "Désactiver", 
   "ColTree2": "Masquer", 
   "ColTree3": "Parents à gauche", 
   "ColTree4": "Parents à droite", 
   "SheetCaption": "Configuration de feuille", 
   "GanttShowBorder": "Afficher la bordure des cellules"  
    }, 



// Columns menu item names, HTML 

"MenuColumns" : { 

"V12_1": "", 
   "Caption": "Choisir les éléments", 
   "ColsCaption": "Choisir les colonnes", 
   "PagersCaption": "Choisir le pagineur", 
   "SpaceCaption": "Choisir les barres d'outils", 
   "RowsCaption": "Choisir les lignes"  
    }, 



// Print menu item names, HTML 

"MenuPrint" : { 

"V12_1": "", 
   "Caption": "Options d'impression", 
   "PrintOptions": "Options d'impression", 
   "PDFName": "Nom de fichier", 
   "PDFFormat": "", 
   "PrintRows": "Maximum de lignes par page", 
   "PrintPageRoot": "Page d'accueil toujours par ligne racine", 
   "PDFText": "", 
   "PDFTexts": "Image seulement,texte sélectionnable,polices incorporées", 
   "PrintExpanded": "Imprimer toutes les lignes élargies", 
   "PrintFiltered": "Imprimer toutes les lignes (non filtrée)", 
   "PrintSelectedRows": "Imprimer les lignes sélectionnées seulement", 
   "PrintSelectedCols": "Imprimer colonnes sélectionnées uniquement", 
   "PrintSelectedCells": "Imprimer cellules sélectionnées uniquement", 
   "PrintVisible": "Imprimer le Gantt visible seulement", 

   "PrintPageOptions": "Taille de la page <div style='font-size:10px;color:#EA4647;white-space:normal;'> Définir &nbsp;les &nbsp; mêmes&nbsp;valeurs&nbsp; également dans &nbsp;le&nbsp;navigateur&nbsp; print&nbsp;dialog!</div>", 
   "PDFPageOptions": "Taille de la page", 
   "PrintPageSize": "Taille de la page", 
   "PrintPageSizes": "Auto,26000,26000,Lettre (8.5x11in),215.9,279.4,Légal (8.5x14in),215.9,355.6,Grand Livre(11x17in),279.4,431.8,A0 - (841x1189),841,1189,A1 - (594x841),594,841,A2 - (420x594),420,594,A3 - (297x420),297,420,A4 - (210x297),210,297,A5 - (148x210),148,210,A6 - (105x148),105,148,A7 - (74x105),74,105,A8 - (52x74),52,74,A9 - (37x52),37,52,B0 - (1000x1414),1000,1414,B1 - (707x1000),707,1000,B2 - (500x707),500,707,B3 - (353x500),353,500,B4 - (250x353),250,353,B5 - (176x250),176,250", 
   "PrintPageOrientation": "Orientation de la Page", 
   "PrintPageOrientations": "Portrait,Paysage", 
   "PrintMarginWidth": "Page: marge largeur (mm)", 
   "PrintMarginHeight": "Page: marge hauteur (mm)", 
   "PDFFitPage": "Ajuster en une page", 
   "PDFFitPages": "Aucun,Hargeur,Hauteur,Page unique", 
   "PrintDPI": "DPI (PPI) rapport", 
   "PrintWidth": "Page: largeur (px)", 
   "PrintHeight": "Page: hauteur (px)", 
   "PrintResults": "Imprimer... taille is %d x %d pages", 
"V15_0": "", 
   "PrintOnlyData": "Sans les dernières cellules vides"  
    }, 



// Export menu item names, HTML 

"MenuExport" : { 

"V12_1": "", 
   "Caption": "Options d'exportation", 
   "ExportOptions": "Options d'exportation", 
   "ExportName": "Nom de fichier", 
   "ExportFormat": "Format de fichier", 
   "ExportExpanded": "Exporter toutes les lignes étendus", 
   "ExportFiltered": "Exporter toutes les lignes (non filtrée)", 
   "ExportOutline": "Exporter l'arborescence vers Excel", 
   "ExportIndent": "Indentater de l'arborescence dans la colonne principale", 
   "ExportSelectedRows": "Exporter les lignes sélectionnées uniquement", 
   "ExportSelectedCols": "Exporter les colonnes sélectionnées uniquement", 
   "ExportSelectedCells": "Exporter les cellules sélectionnées uniquement", 
   "ExportFixedRows": "Congeler (ancrage) lignes de tête", 
   "ExportFixedCols": "Figer (ancrage) gauche colonnes", 
   "ExportEmpty": "Exporter les cellules vides aussi"  
    },  



// Filter menu operator names, HTML 
      
"MenuFilter" : { 
       
   "F0": "Non", 
   "F1": "Égal", 
   "F2": "Non égal", 
   "F3": "Plus petit que", 
   "F4": "Plus petit ou égal", 
   "F5": "Plus grand que", 
   "F6": "Supérieur ou égal à", 
   "F7": "Débute avec", 
   "F8": "Ne commence pas par", 
   "F9": "Finit avec", 
   "F10": "Ne se termine pas avec", 
   "F11": "Contient", 
   "F12": "Ne contiens pas", 
"V14_0": "", 
   "Defs": "Appliquer le filtre à", 
   "Defs1": "Filtre appliqué à"  
    }, 



// Names of functions in editable formulas, in format JavaScriptName="LocalizedName". Since 12.0 

"FormulaFunctions" : { 

"V12_0": "", 
   "sum": "somme", 
   "sumsq": "somme.carres", 
   "count": "nb", 
   "counta": "nbval", 
   "countblank": "nb.vide", 
   "max": "max", 
   "min": "min", 
   "product": "produit", 
   "second": "seconde", 
   "minute": "minute", 
   "hour": "heure", 
   "day": "jour", 
   "month": "mois", 
   "year": "annee", 
   "date": "date", 
   "time": "temps", 
   "today": "aujourdhui", 
   "now": "maintenant", 
   "weekday": "joursem", 
   "weeknum": "no.semaine", 
   "round": "arrondi", 
   "ceil": "ceil", 
   "floor": "plancher", 
   "abs": "abs", 
   "exp": "exp", 
   "log": "log", 
   "pow": "pow", 
   "sqrt": "racine", 
   "sin": "sin", 
   "cos": "cos", 
   "tan": "tan", 
   "asin": "asin", 
   "acos": "acos", 
   "atan": "atan", 
   "text": "texte", 
"V13_0": "", 
   "if": "si", 
   "ifs": "si.conditions", 
   "switch": "si.multiple", 
   "choose": "choisir", 
   "concatenate": "concatener", 
   "concat": "concat", 
   "int": "ent", 
   "fix": "ctxt", 
   "pi": "pi", 
   "hlookup": "rechercheh", 
   "vlookup": "recherchev", 
   "lookup": "recherche", 
   "match": "equiv", 
   "index": "index", 
   "rank": "rang", 
   "rank.eq": "equation.rang", 
   "rank.avg": "moyenne.rang", 
   "percentrank": "rang.pourcentage", 
   "percentrank.inc": "rang.pourcentage.inclure", 
   "percentrank.exc": "rang.pourcentage.exclure", 
   "percentile": "centile", 
   "percentile.inc": "centile.inclure", 
   "percentile.exc": "centile.exclure", 
   "quartile": "quartile", 
   "quartile.inc": "quartile.inclure", 
   "quartile.exc": "quartile.exclure", 
   "find": "trouve", 
   "iferror": "sierreur", 
   "ifna": "si.non.disp", 
   "and": "et", 
   "or": "ou", 
   "xor": "oux", 
   "not": "non", 
   "true": "vrai", 
   "false": "faux", 
   "address": "adresse", 
   "column": "colonne", 
   "columns": "colonnes", 
   "row": "ligne", 
   "rows": "lignes", 
   "offset": "decaler", 
   "days": "jours", 
   "edate": "mois.decaler", 
   "eomonth": "fin.mois", 
   "timevalue": "tempsval", 
   "datevalue": "dateval", 
   "isoweeknum": "no.semaine.iso", 
   "isblank": "estvide", 
   "iserror": "esterreur", 
   "iserr": "esterr", 
   "isna": "estna", 
   "iseven": "est.pair", 
   "isodd": "est.impair", 
   "isformula": "estformule", 
   "islogical": "estlogique", 
   "isnontext": "estnontexte", 
   "istext": "esttexte", 
   "isnumber": "estnum", 
   "isref": "estref", 
   "n": "n", 
   "t": "t", 
   "na": "na", 
   "type": "type", 
   "formulatext": "formuletexte", 
   "char": "car", 
   "clean": "epurage", 
   "code": "code", 
   "dollar": "devise", 
   "exact": "exact", 
   "fixed": "ctxt", 
   "left": "gauche", 
   "right": "droite", 
   "mid": "stxt", 
   "len": "nbcar", 
   "lower": "minuscule", 
   "upper": "majuscule", 
   "numbervalue": "valeurnombre", 
   "proper": "nompropre", 
   "replace": "remplacer", 
   "rept": "rept", 
   "search": "cherche", 
   "substitute": "substitue", 
   "textjoin": "joindre.texte", 
   "unicode": "unicode", 
   "unichar": "unicar", 
   "value": "cnum", 
   "trim": "supprespace", 
   "sinh": "sinh", 
   "cosh": "cosh", 
   "tanh": "tanh", 
   "asinh": "asinh", 
   "acosh": "acosh", 
   "atanh": "atanh", 
   "cot": "cot", 
   "acot": "acot", 
   "coth": "coth", 
   "acoth": "acoth", 
   "atan2": "atan2", 
   "base": "base", 
   "ceiling": "plafond", 
   "ceiling.math": "plafond.math", 
   "ceiling.precise": "plafond.precis", 
   "floor.math": "plancher.math", 
   "floor.precise": "plancher.precis", 
   "combin": "combin", 
   "combina": "combina", 
   "sign": "signe", 
   "gcd": "pgcd", 
   "lcm": "ppcm", 
   "power": "puissance", 
   "quotient": "quotient", 
   "mod": "mod", 
   "mround": "arrondi.au.multiple", 
   "roundup": "arrondi.sup", 
   "rounddown": "arrondi.inf", 
   "trunc": "tronque", 
   "rand": "alea", 
   "randbetween": "alea.entre.bornes", 
   "sumproduct": "sommeprod", 
   "sumx2my2": "somme.x2my2", 
   "sumx2py2": "somme.x2py2", 
   "sumxmy2": "somme.xmy2", 
   "seriessum": "somme.series", 
   "sqrtpi": "racine.pi", 
   "degrees": "degres", 
   "radians": "radians", 
   "sec": "sec", 
   "sech": "sech", 
   "csc": "csc", 
   "csch": "csch", 
   "ln": "ln", 
   "log10": "log10", 
   "fact": "fact", 
   "factdouble": "factdouble", 
   "multinomial": "multinomiale", 
   "decimal": "decimal", 
   "mdeterm": "determat", 
   "sumif": "somme.si", 
   "countif": "nb.si", 
   "sumifs": "somme.si.ens", 
   "countifs": "nb.si.ens", 
   "permut": "permutation", 
   "permutationa": "permutationa", 
   "average": "moyenne", 
   "averagea": "averagea", 
   "averageif": "moyenne.si", 
   "averageifs": "moyenne.si.ens", 
   "median": "mediane", 
   "mode": "mode", 
   "mode.sngl": "mode.simple", 
   "geomean": "moyenne.geometrique", 
   "harmean": "moyenne.harmonique", 
   "trimmean": "moyenne.reduite", 
   "avedev": "ecart.moyen", 
   "devsq": "somme.carres.ecarts", 
   "stdev": "ecartype", 
   "stdeva": "stdeva", 
   "stdevp": "ecartypep", 
   "stdevpa": "stdevpa", 
   "stdev.s": "ecartype.standard", 
   "stdev.p": "ecartype.pearson", 
   "var": "var", 
   "vara": "vara", 
   "varp": "var.p", 
   "varpa": "varpa", 
   "var.s": "var.s", 
   "var.p": "var.p.n", 
   "covar": "covariance", 
   "covariance.s": "covariance.standard", 
   "covariance.p": "covariance.pearson", 
   "forecast": "prevision", 
   "forecast.linear": "prevision.lineaire", 
   "intercept": "ordonnee.origine", 
   "slope": "pente", 
   "steyx": "erreur.type.xy", 
   "mina": "mina", 
   "minifs": "min.si", 
   "maxa": "maxa", 
   "maxifs": "max.si", 
   "large": "grande.valeur", 
   "small": "petite.valeur", 
   "bin2dec": "bindec", 
   "bin2oct": "binoct", 
   "bin2hex": "binhex", 
   "oct2bin": "octbin", 
   "oct2dec": "octdec", 
   "oct2hex": "octhex", 
   "dec2bin": "decbin", 
   "dec2oct": "decoct", 
   "dec2hex": "dechex", 
   "hex2bin": "hexbin", 
   "hex2oct": "hexoct", 
   "hex2dec": "hexdec", 
   "bitand": "bitet", 
   "bitor": "bitou", 
   "bitxor": "bitouexclusif", 
   "bitlshift": "bitdecalg", 
   "bitrshift": "bitdecald", 
   "delta": "delta", 
   "gestep": "sup.seuil", 
   "subtotal": "sous.total", 
   "aggregate": "agregat"  
    }, 



// Names of constants in editable formulas, in format JavaScriptName="LocalizedName". Since 12.0 

"FormulaConstants" : { 

   "Math.PI": "pi", 
   "Math.LN10": "ln10", 
   "Math.LN2": "ln2", 
   "Math.LOG10E": "log10e", 
   "Math.LOG2E": "log2e", 
   "Math.SQRT2": "sqrt2", 
   "Math.SQRT1_2": "SQRT1_2", 
   "null": "null", 
   "false": "faux", 
   "true": "vrai"  
    }, 



// Names of operators in editable formulas, in format TreeGridName="LocalizedName". The operator count and names (TreeGridName) cannot be changed. Since 12.0 

"FormulaOperators" : { 

   "Left": "(", 
   "Right": ")", 
   "Plus": "+", 
   "Minus": "-", 
   "Multiply": "*", 
   "Divide": "/", 
   "Modulo": "", 
   "Equal": "= ==", 
   "Inequal": "<> !=", 
   "Greater": ">", 
   "Less": "<", 
   "GreaterEqual": ">=", 
   "LessEqual": "<=", 
   "Not": "", 
   "And": "&&", 
   "Or": "||", 
   "BitNot": "~", 
   "BitAnd": "", 
   "BitOr": "|", 
   "BitXor": "", 
   "BitLeft": "<<", 
   "BitRight": ">>", 
   "If": "?", "Else": ":", 
   "Quote": "\" '", 
   "Chars": "()+-*/%=!<>~&|^?:", 
"V13_0": "", 
   "Concat": "&", 
   "Power": "^", 
   "External": "!", 
   "Percent": "%"  
    }, 



// Language dependent formatting dates and numbers 
      
"Format" : { 
         
   "LongDayNames": "dimanche,lundi,mardi,mercredi,jeudi,vendredi,samedi", 
   "ShortDayNames": "dim,lun,mar,mer,jeu,ven,sam", 
   "Day2CharNames": "di,lu,ma,me,je,ve,sa", 
   "Day1CharNames": "D,L,M,M,J,V,S", 
   "LongMonthNames": "janvier,février,mars,avril,mai,juin,juillet,août,septembre,octobre,novembre,décembre", 
   "LongMonthNames2": "janvier,février,mars,avril,mai,juin,juillet,août,septembre,octobre,novembre,décembre", 
   "ShortMonthNames": "jan,fév,mar,avr,mai,juin,juil,aoû,sep,oct,nov,déc", 
   "InputMonthNames": "", 
   "DayNumbers": "1er,2e,3e,4e,5e,6e,7e,8e,9e,10e,11e,12e,13e,14e,15e,16e,17e,18e,19e,20e,21e,22e,23e,24e,25e,26e,27e,28e,29e,30e,31e", 
   "Quarters": "I,II,III,IV", 
   "Halves": "I,II", 
   "DateSeparator": "/", 
   "InputDateSeparators": "/.-", 
   "TimeSeparator": ":", 
   "InputTimeSeparators": ":", 
   "InputDateTimeSeparators": "", 
   "AMDesignator": "AM", 
   "PMDesignator": "PM", 
   "InputAMPMDesignators": "", 
   "FirstWeekDay": "1", 
   "FirstWeekYearDay": "3", 
   "NaD": "NaN", 
   "Hirji": "0", 

   "sd": "dd/MM", 
   "sy": "dd/MM/yyyy", 
   "sw": "ddd dd/MM/yyyy", 
   "sm": "M/yyyy", 
   "sn": "\\sddddddd", 
   "ld": "d MMMM", 
   "ly": "d MMMM yyyy", 
   "lw": "dddd d MMMM yyyy", 
   "lwa": "ddd d MMMM yyyy", 
   "lm": "MMMMMMM yyyy", 
   "ln": "'semaine' ddddddd", 
   "ad": "d MMM", 
   "ay": "d MMM yyyy", 
   "aw": "ddd d MMM yyyy", 
   "awl": "dddd d MMM yyyy", 
   "am": "MMM yyyy", 
   "an": "'sem.' ddddddd", 
   "th": "HH", 
   "tm": "HH:mm", 
   "ts": "HH:mm:ss", 
   "tf": "HH:mm:ss.fff", 
   "sth": " HH", 
   "stm": " HH:mm", 
   "sts": " HH:mm:ss", 
   "stf": " HH:mm:ss.fff", 
   "lth": ", HH", 
   "ltm": ", HH:mm", 
   "lts": ", HH:mm:ss", 
   "ltf": ", HH:mm:ss.fff", 
   "yq": "MMMMM yyyy", 
   "yh": "MMMMMM yyyy", 

   "m": "dd/MM", 
   "d": "dd/MM/yyyy", 
   "h": "dd/MM/yyyy HH:mm", 
   "H": "dd/MM/yyyy HH:mm:ss", 
   "j": "dd/MM/yyyy h:mm tt", 
   "J": "dd/MM/yyyy h:mm:ss tt", 
   "y": "MM/yyyy", 
   "M": "d MMMM", 
   "D": "d MMMM yyyy", 
   "l": "d MMMM yyyy H:mm", 
   "L": "d MMMM yyyy H:mm:ss", 
   "k": "d MMMM yyyy h:mm tt", 
   "K": "d MMMM yyyy h:mm:ss tt", 
   "Y": "MMMMMMM yyyy", 
   "t": "HH:mm", 
   "T": "HH:mm:ss", 
   "i": "h:mm tt", 
   "I": "h:mm:ss tt", 

   "f": "d MMMM yyyy H:mm", 
   "F": "d MMMM yyyy H:mm:ss", 
   "g": "dd/MM/yyyy H:mm", 
   "G": "dd/MM/yyyy H:mm:ss", 
   "s": "yyyy-MM-ddTHH:mm:ss", 
   "u": "yyyy-MM-dd HH:mm:ssZ", 
   "U": "d. MMMM yyyy HH:mm:ss", 
   "r": "ddd MMM d HH:mm:ss UTCzzzzz yyyy", 
   "R": "ddd MMM d HH:mm:ss UTCzzzzz yyyy", 
   "a": "dddd, dddddd MMMM yyyy", 

   "CalendarMonth": "MMMMMMM yyyy", 

   "ValueSeparator": ";", "ValueSeparatorHtml": "; ", 
   "RangeSeparator": "~", "RangeSeparatorHtml": " ~ ", 
   "RepeatSeparator": "#", 
   "CountSeparator": "*", 
   "AddSeparator": "+", 
      
   "DecimalSeparator": ",", 
   "InputDecimalSeparators": ".,", 
   "GroupSeparator": " ", 
   "GroupCount1": "3", 
   "GroupCount": "3", 
   "InputGroupSeparators": "", 
   "Percent": "%", 
   "NaN": "NaN", 
   "Currency": " \u20AC ", 
   "Digits": "", 
   "FractionSeparator": "/", 

   "ng": "0.####", 
   "nf": "0.00", 
   "nc": ",###########0.00$;-,###########0.00$", 
   "ncm": ",###########0.00$;-,###########0.00$", 
   "ncmr": ",###########0.00$;[red]-,###########0.00$", 
   "ncp": ",###########0.00$;(,###########0.00$)", 
   "ncpr": ",###########0.00$;[red](,###########0.00$)", 
   "np": ",0.00%", 
   "nr": "0.0000", 
   "ne": "0 000 000 E+000", 
	
   "Cont": "...", 
   "ContLeft": "... ", 
   "ContRight": " ...", 
   
   "PivotSeparators": "|,|:|<b>,</b> | <em><b>+</b></em> | <em><b>=</b></em> ", 

   "FormulaPrefix": "=", 
   "FormulaRangeSeparator": ":", 
   "FormulaValueSeparator": ",", 
   "FormulaIntersectionSeparator": " ", 
   "FormulaAbsolute": "$", 
   "NaR": "#InvalideRef", 
   "TextPrefix": "'"  
    }  

},  // End of root tag Lang 
   
   
   
// Toolbar button tooltips, HTML 
   
"Toolbar" : { 
   "SaveButtonText": "Sauvegarder", "SaveTip": "Soumettre les changements au serveur", 
   "ReloadButtonText": "Recharger", "ReloadTip": "Recharger la grille, annuler les changements", 
   "RepaintButtonText": "Pages", "RepaintTip": "Générer toutes les pages", "RepaintTip1": "Générer les pages sur demande", 
   "PrintButtonText": "Imprimer", "PrintTip": "Imprimez le Grid", 
   "ExportPDFButtonText": "PDF", "ExportPDFTip": "Imprimer la grille au format Adobe PDF", 
   "ExportButtonText": "Exporter", "ExportTip": "Exporter la grille de donnée à votre programme chiffrier", 
   "ImportButtonText": "Importer", "ImportTip": "Ouvrir le fichier xlsx ou csv MS Excel local dans la grille", 
   "UndoButtonText": "Annuler", "UndoTip": "Annuler dernier action", 
   "RedoButtonText": "Refaire", "RedoTip": "Annuler dernier action", 
   "AddButtonText": "Ajouter", "AddTip": "Ajouter une nouvelle ligne ou déplacer ou copier les lignes sélectionnées", 
   "AddChildButtonText": "Ajout enfant", "AddChildTip": "Ajouter une nouvelle ligne enfant ou déplacer ou copier des lignes sélectionnées à la position actuelle du curseur", 
   "AddColButtonText": "Ajout colonne", "AddColTip": "Ajouter une nouvelle colonne ou déplacer ou copier les colonnes sélectionnées", 
   "JoinButtonText": "Joindre", "JoinTip": "Étendre aux cellules sélectionnées", 
   "SplitButtonText": "Divisé", "SplitTip": "Split cellules étendues", 
   "OutdentButtonText": "Outdent", "OutdentTip": "Retirer, déplacer la ligne focalisée au-dessous de son parent", 
   "IndentButtonText": "Indenter", "IndentTip": "Indenter, déplacer la ligne focalisée au-dessus de son parent", 
   "LeftButtonText": "Gauche", "LeftTip": "Aligner le contenu de la cellule côté gauche", 
   "CenterButtonText": "Centrer", "CenterTip": "Centrer the cellule contenu horizontalement", 
   "RightButtonText": "Droite", "RightTip": "Aligner le contenu de la cellule côté droit", 
   "TextIndentText": "Indenter", "TextIndentTip": "Valeur de cellule de retrait à partir du bord d'alignement", 
   "TopButtonText": "Dessus", "TopTip": "Aligner contenu côté supérieur de la cellule", 
   "MiddleButtonText": "Milieu", "MiddleTip": "Centrer the cellule contenu verticalement", 
   "BottomButtonText": "Bas", "BottomTip": "Aligner le contenu de la cellule côté inférieur", 
   "BoldButtonText": "Gras", "BoldTip": "Définir la police de la cellule gras", 
   "ItalicButtonText": "Italique", "ItalicTip": "Définir la police de la cellule italique", 
   "UnderlineButtonText": "Souligner", "UnderlineTip": "Soulignez le texte de la cellule", 
   "StrikeButtonText": "Rayer", "StrikeTip": "Rayer the cellule texte", 
   "RotateLeftButtonText": "Tournez 270", "RotateLeftTip": "Tourner le contenu de la cellule 270 degrés dans le sens horaire", 
   "NoRotateButtonText": "Neotáčet", "NoRotateTip": "Ne tourne pas le contenu de la cellule", 
   "RotateRightButtonText": "Tournez 90", "RotateRightTip": "Tourner le contenu de la cellule de 90 degrés dans le sens horaire", 
   "WrapTextButtonText": "Envelopper", "WrapTextTip": "Envelopper le texte de la cellule verticalement", 
   "SetLinkButtonText": "Lien", "SetLinkTip": "Ajouter ou effacer un lien hypertexte dans la cellule ou pour le texte sélectionné dans la cellule", 
   "AddImageButtonText": "Image", "AddImageTip": "Insérer une image du fichier local dans la cellule", 
   "ClearStyleButtonText": "Effacer le style", "ClearStyleTip": "Efface tous les paramètres de style", 
   "SizeTip": "Choisissez la taille de la police de la cellule", 
   "BorderButtonText": "Frontières", "BorderTip": "Modifier the cellule frontières", 
   "ColorTextButtonText": "Couleur", "ColorTextTip": "Choisir la couleur de texte", 
   "ColorShadowButtonText": "Ombre", "ColorShadowTip": "Choisir la couleur ombragé du texte", 
   "ColorBackgroundButtonText": "Fond...", "ColorBackgroundTip": "Choisir la couleur de l'arrière-plan", 
   "TextFormatTip": "* Valeur *<br>Choisissez le format de la cellule", 

   "SortButtonText": "Trier", "SortTip": "Activer le tri et le retrie des lignes maintenant", "SortTip1": "Désactiver le tri afin d'accélérer le changement de critères de tri", 
   "CalcButtonText": "Calculer", "CalcTip": "Activer les calculs et recalculer la grille maintenant", "CalcTip1": "Désactiver les calculs afin d'accélérer l'édition des cellules", 
   "WinScrollButtonText": "Pas de défilement", "WinScrollTip": "Désactiver les barres de défilement de la grille et utiliser les barres de défilement des pages", "WinScrollTip1": "Activer les barres de défilement de la grille", 
   "ExpandAllButtonText": "Développer tout", "ExpandAllTip": "Développer toutes les lignes", 
   "CollapseAllButtonText": "Réduire tout", "CollapseAllTip": "Fermer toutes les lignes", 
   "ColumnsButtonText": "Colonnes", "ColumnsTip": "Afficher le menu afin de choisir les colonnes visibles", 
   "CfgButtonText": "Config.", "CfgTip": "Paramètres de TreeGrid usager", 
   "LockButtonText": "Verrouiller", "LockTip": "La grille est entièrement déverrouillée et modifiable", 
   "LockTip1": "La structure de la grille est verrouillée, les cellules sont déverrouillées", 
   "LockTip2": "La structure de grille, les styles de cellules et les formules sont verrouillés, les valeurs de cellules sont déverrouillées", 
   "LockTip3": "La grille est entièrement verrouillé et en lecture seule", 
   "HelpButtonText": "Aide", "HelpTip": "Afficher l'aide pour le contrôle TreeGrid", 
   "DebugButtonText": "Déboguer", "DebugTip": "Affiche la fenêtre de débogage", 
   "ResizeTip": "Redimensionner grille", 

   "CorrectButtonText": "Correcte", "CorrectTipFormula": "ganttdependencyerrors (null, 1)", 
   "ZoomInButtonText": "Zoom avant", "ZoomInTip": "Zoom avant", 
   "ZoomOutButtonText": "Zoom arrière", "ZoomOutTip": "Zoom arrière", 
   "ZoomFitButtonText": "Zoom ajustement", "ZoomFitTip": "Zoom pour adapter dans la page", 

   "LanguagesLabel": "<s>Langue:</s>", 
   "StylesLabel": "<s>Style:</s>", 
   "GanttStylesLabel": "<s>Gantt:</s>", 
   "SizesLabel": "<s>Taille:</s>", 
   "ScalesLabel": "<s>Échelle:</s>", 
   "ContrastsLabel": "<s>Contraste:</s>"  
    }, 

// Row displayed when no variable rows are visible 
// To hide it define Html=""    
"Solid" : [ { "id": "NoData", "Html": "Aucune donnée trouvée"   }  ],    
   
// Right side pager caption 
"Pager" : { "Caption": "Pages"   },    
   
// Left side panel button tooltips, HTML 
   
"Panel" : { 
   "PanelMoveTip": "Glisser la ligne", 
   "PanelSelectTip": "Sélectionner ligne", 
   "PanelDeleteTip": "Supprimer la ligne", 
   "PanelCopyTip": "Copié la ligne", 
   "MenuName": "Panneau en ligne"  
    }, 
   
"Header" : { 
   "PanelPanelSelectAllTip": "Sélectionner ou désélectionner toutes les lignes", 
   "PanelPanelDeleteAllTip": "Supprimer toutes les lignes sélectionnées", 
   "PanelPanelCopyAllTip": "Ajouter une nouvelle ligne ou déplacer ou copier les lignes sélectionnées"  
    }, 

"Def" : [ 
   { "Name": "Panel", "MenuName": "Panneau en colonne", 
      "PanelColSelectTip": "Sélectionner une colonne", 
      "PanelColDeleteTip": "Supprimer la colonne", 
      "PanelColCopyTip": "Copier colonnes", 
      "PanelColSelectAllTip": "Sélectionner ou désélectionner toutes les colonnes", 
      "PanelColDeleteAllTip": "Supprimer toutes les colonnes sélectionnées", 
      "PanelColCopyAllTip": "Ajouter une nouvelle colonne ou déplacer ou copier les colonnes sélectionnées"  
       }  
], 



// Other text translations 

"TextFR" : [ 
   { "Action":"Change", "Space": "1", "Col": "Styles,GanttStyles,StylesMenu,GanttStylesMenu", "Standard": "Standard", "White": "Blanc", "Black": "Noir", "Material": "Material", "Turq": "Turq", 
      "Relief": "Relief", "Light": "Lumière", "Office": "Office", "Gradient": "Pente", "Borders": "Frontières", "Query": "Query", "ExtJS": "ExtJS", "Sharp": "Vif", "Round": "Rond", "Plain": "Plat", "Colors": "Couleurs"   }, 
   { "Action":"Set", "Row": "Toolbar", "StylesStandard": "Standard", "StylesWhite": "Blanc", "StylesBlack": "Noir", "StylesMaterial": "Material", "StylesTurq": "Turq", "StylesRelief": "Relief", "StylesLight": "Lumière", 
      "StylesOffice": "Office", "StylesGradient": "Pente", "StylesBorders": "Frontières", "StylesQuery": "Query", "StylesExtJS": "ExtJS", "StylesSharp": "Vif", "StylesRound": "Rond", "StylesPlain": "Plat", "StylesColors": "Couleurs"   }, 
   { "Action":"Change", "Space": "1", "Col": "Sizes,SizesMenu", "Tiny": "Infime", "Mini": "Mini", "Small": "Petit", "Low": "Faible", "Normal": "Normal", "Wide": "Large", "High": "Haut", "Big": "Gros", "Giant": "Géant"   }, 
   { "Action":"Set", "Row": "Toolbar", "SizesTiny": "Infime", "SizesMini": "Mini", "SizesSmall": "Petit", "SizesLow": "Faible", "SizesNormal": "Normal", "SizesWide": "Large", "SizesHigh": "Haut", "SizesBig": "Gros", "SizesGiant": "Géant"   }, 
   { "Action":"Change", "Space": "1", "Col": "Contrasts,ContrastsMenu", "Bright": "Luisant", "Vivid": "Vif", "Default": "Défaut", "Soft": "Subtil", "Dim": "Sombre"   }, 
   { "Action":"Set", "Row": "Toolbar", "ContrastsBright": "Luisant", "ContrastsVivid": "Vif", "ContrastsDefault": "Défaut", "ContrastsSoft": "Subtil", "ContrastsDim": "Sombre"   }, 
   { "Action":"Change", "Space": "1", "Col": "Size", "N": "<span style='font-size:9px;color:silver;'>size</span>", "V": "<span style='font-size:8px;color:silver;'>taille</span>"   }, 
   { "Action":"Change", "Space": "1", "Col": "TextIndent", "N": "<span style='font-size:9px;color:silver;'>indent</span>", "V": "<span style='font-size:8px;color:silver;'>retrait</span>"   }, 
   { "Action":"Replace", "Space": "1", "Col": "TextFormat", "general": "général", "text": "texte", "integer": "entier", "percent": "pourcentage", "December": "décembre", "pm": "pm", "format": "format", "Items": [
      { "N": "12th", "V": "12"   }, 
      { "N": "percent int", "V": "entier pourcentage"   }  
   ]}, 
   { "Action":"Change", "Space": "1", "Col": "FormatMenu,TextFormatMenu", "Col1": "Menu", "Count": "2", "Items": [
      { "N": "General number or text", "V": "Nombre général ou texte"   }, 
      { "N": "Enter custom format ...", "V": "Entrez le format personnalisé ..."   }, 
      { "N": "Custom formats", "V": "Formats personnalisés"   }, 
      { "N": "Remove unused formats", "V": "Supprimer les formats inutilisés"   }, 
      { "N": "Not formatted text", "V": "Texte non formaté"   }, 
      { "N": "Boolean true / false", "V": "Booléen vrai / faux"   }, 
      { "N": "Integer number", "V": "Nombre entier"   }, 
      { "N": "Next float numbers", "V": "Autres numéros de float"   }, 
      { "N": "Next date times", "V": "Autre date et heure"   }  
   ]}, 
   { "Action":"Replace", "Space": "1", "Col": "FormatMenu,TextFormatMenu,TextFormat", "Col1": "Menu", "Count": "2", "Items": [
      { "N": "Float number", "V": "Nombre flottant"   }, 
      { "N": "Currency number", "V": "Nombre de devise"   }, 
      { "N": "Float percent number", "V": "Flottant pourcentage"   }, 
      { "N": "Integer percent number", "V": "Nombre entier en pourcentage"   }, 
      { "N": "Short full date", "V": "Date complète courte"   }, 
      { "N": "Short partial date", "V": "Date partielle courte"   }, 
      { "N": "Short month and year", "V": "Mois et année courtes"   }, 
      { "N": "Long full date", "V": "Date complète longue"   }, 
      { "N": "Long partial date", "V": "Date partielle longue"   }, 
      { "N": "Long month and year", "V": "Mois et année longues"   }, 
      { "N": "Short date and long time am/pm", "V": "Date courte et longue heure am/pm"   }, 
      { "N": "Short date and long time", "V": "Date courte et longue heure"   }, 
      { "N": "Short date and time am/pm", "V": "Courte date et heure am/pm"   }, 
      { "N": "Short date and time", "V": "Courte date et heure"   }, 
      { "N": "Long date and time am/pm", "V": "Longue date et heure am/pm"   }, 
      { "N": "Long date and time", "V": "Longue date et heure"   }, 
      { "N": "Long date and long time am/pm", "V": "Date et heure longues am/pm"   }, 
      { "N": "Long date and long time", "V": "Date et heure longues"   }, 
      { "N": "Long time am/pm", "V": "Longue heure am/pm"   }, 
      { "N": "Short time am/pm", "V": "Courte heure am/pm"   }, 
      { "N": "Long time", "V": "Longue heure"   }, 
      { "N": "Short time", "V": "Courte heure"   }, 
      { "N": "1234.5", "V": "1234,5"   }, 
      { "N": "1,234.5", "V": "1 234,5"   }, 
      { "N": "$1,234.50", "V": "1 234,50$"   }, 
      { "N": "12/31/2000", "V": "31/12/2000"   }, 
      { "N": "12/31", "V": "31/12"   }, 
      { "N": "12th December", "V": "12 décembre"   }, 
      { "N": "December", "V": "décembre"   }, 
      { "N": "pm", "V": "pm"   }  
   ]}, 
   { "Action":"Last", "Space": "1", "Col": "ColorTextMenu,ColorShadowMenu,ColorBackgroundMenu,BorderMenu", "Col1": "Menu", "Count": "2", 
      "none": "aucun", "black": "noir", "red": "rouge", "green": "vert", "blue": "bleu", "brown": "marron", "maroon": "bordeaux", "gray": "gris", 
      "yellow": "jaune", "lime": "chaux", "aqua": "aqua", "pink": "rose", "orange": "orange", "silver": "argent"   }, 
   { "Action":"Replace", "Col": "Menu", "default": "standard"   }  
], 

}) /* End of JSONP header */ 